MODULE WriteBoot;  (* Writes Block 1 of a boot file to block 0 of a device *)

FROM R2SysCalls IMPORT Status, Open, ReadBlock, WriteBlock, Close,
                     ReadString, WriteString, Handle, Exit, 
                     WriteLn, GetMessage;
FROM R2Strings IMPORT Insert, Length;

VAR     tf, sf : ARRAY [0..79] OF CHAR;
        th, sh : Handle;
        b : ARRAY [0..511] OF CHAR;
        rs : Status;

PROCEDURE Check( rs : Status);

VAR     m : ARRAY [0..79] OF CHAR;

BEGIN   IF rs <> Ok THEN 
          GetMessage(rs,m);
          WriteString("WriteBoot -- ");
          WriteString(m);
          WriteLn;
          Exit(Ok); 
          END;
END Check;

BEGIN   WriteString("Bootstrap .LOD file: ");
        ReadString(sf);
        Check(Open(sf,FALSE,sh));
        WriteString("Target device: ");
        ReadString(tf);
        Insert("-BOOTBLOCKS.SYS",tf,Length(tf));
        Check(Open(tf,TRUE,th));
        Check(ReadBlock(sh,b));
        Check(ReadBlock(sh,b));
        Check(WriteBlock(th,b,FALSE));
        Check(ReadBlock(sh,b));
        Check(WriteBlock(th,b,FALSE));
        Check(Close(th,TRUE));
        Check(Close(sh,TRUE));
END WriteBoot.
