MODULE E2Editor;

FROM E2Help IMPORT RunHelp;

FROM E2Capital IMPORT Cap;

FROM E2Paster IMPORT paste2, paste3, paste4, 
                     Paste, Select, CutPart, Reset, Cut, Replace, Append;

FROM E2Variables IMPORT maxline, string, lineptr, text, ff, EOL, 
                        paste, paste1, width, goingup, row, col, display,
                        sectlength, bottomline, repeat, lenrep, series;
 
FROM E2Terminal IMPORT WriteLn, Write, WriteString,
                       WriteCursor, WriteReverse, WriteCard, 
                       Read, ReadString, ClearTypeAhead,
                       ClearScreen, MakeSpace, Initialize, 
                       EraseLine, Exit, SetOn, SetOff, 
                       RvsOn, RvsOff,EraseRest, BackSpace,
                       AlternateKeyPad, RegularKeyPad;

FROM E2Functions IMPORT CopyLine, WriteLine, LineNumber, ReadLine, Length,
                        SearchLine, ToCard, Letter, ToString;

FROM E2FileIt IMPORT OpenInput, ReadFile, CloseInput, Empty,
                     OpenOutput, WriteFile, CloseOutput, FileName;

FROM E2Pointer IMPORT SetPtr, CopyPointer, Up, JoinPtr, JoinInPtr, CanDo, Top,
                      EOF, ReplacePtr, DEALLOCATE;

FROM E2Displays IMPORT Prompt, ErasePrompt, prompt, CheckRange, 
                       ReplaceTop, ReplaceBottom;

FROM E2Learn IMPORT StartStoring, StartLearn, learnon, storing,
                    sequence, counter;
 
VAR     learnable, pasted, findline , dellndone, delchdone,
        redisplay, delwddone, linefddone, PUSH, TheEnd : BOOLEAN;
        deletedptr : lineptr;
        search, deletedword, filename : string;
        deletedchar, letter : CHAR;
        page, tabwidth : CARDINAL;

PROCEDURE Init;

BEGIN   SetPtr(text,1);
        SetPtr(deletedptr,1);
        SetPtr(paste1,1);
        paste2 := paste1;
        SetPtr(paste3,1);
        paste4 := paste3;
        Initialize;
        tabwidth := 9;
        col := 1; row := 1;
        delchdone := FALSE; dellndone := FALSE; delwddone := FALSE;
        findline := FALSE; pasted := FALSE; linefddone := FALSE; 
        paste := FALSE; redisplay := FALSE;
        TheEnd := FALSE; 
        learnable := FALSE; 
        goingup := FALSE;
        PUSH := FALSE;
        prompt := FALSE;
        learnon := FALSE;
        storing := FALSE;
END Init;

PROCEDURE Readfile;

VAR     p, q : lineptr;
        n : CARDINAL;
        s : string; 

BEGIN   p := text;
        FileName(filename);
        OpenInput(filename); 
        IF NOT Empty THEN
          WHILE NOT Empty DO
            ReadFile(s);
            SetPtr(q,Length(s));
            CopyLine(q^.line,s,1,1); 
            JoinPtr(p,q);
            Up(p,n,FALSE);
            END;
          IF NOT EOF() THEN text := text^.down END;
          text^.up := NIL;
        END;
        CloseInput;
        ToString('[EOF] ',p^.line);
        p^.down := NIL; 
END Readfile;

PROCEDURE Display(p : lineptr);

VAR     i : CARDINAL;

BEGIN   CanDo := TRUE;
        i := 1;
        SetOff; 
        WHILE (i < 12) AND (p^.up # NIL) DO
          p := p^.up;
          INC(i);
          END;
        row := i; i := 1;
        WHILE (i < bottomline) AND CanDo DO
          WriteLine(i,1,p); WriteLn;
          Up(p,i,FALSE);
          END;
        IF i >= bottomline THEN WriteLine(bottomline,1,p);
        ELSE WriteLine(i,1,p);WriteLn;
        END; 
        EraseRest;
        SetOn; 
        WriteCursor(row,col);
END Display;
          
PROCEDURE OptimizeDisplay(VAR p : lineptr; up : BOOLEAN);

VAR     d, i : CARDINAL; 

BEGIN   CanDo := TRUE;
        IF page > sectlength THEN FOR i := 1 TO page DO Up(p,d,up) END; 
                               Display(p);
        ELSE WHILE (page > 0) AND CanDo DO 
               IF paste THEN CheckRange END; 
               page := page - 1;
               Up(p,row,up);
               Refresh(p);
               END; 
             IF prompt THEN ErasePrompt END; 
        END;
END OptimizeDisplay; 

PROCEDURE KillRepeat;

BEGIN   IF repeat > 0 THEN repeat := 0;
                           display := TRUE;
        END;
END KillRepeat;

PROCEDURE Return;

VAR     p : lineptr;
        rp : BOOLEAN;
        n : CARDINAL;

BEGIN   PastEOL(col-1); 
        n := Length(text^.line);
        IF n < col THEN n := col END;
        n := n - col + 1;
        SetPtr(p,n);
        CopyLine(p^.line,text^.line,1,col);
        text^.line[col] := EOL;                
        rp := text = paste1;
        ReplacePtr(text,Length(text^.line)); 
        IF rp THEN paste1 := text END;
        JoinInPtr(p,text,FALSE);
        Up(text,col,FALSE); 
        col := 1;
        IF row < 18 THEN INC(row);
                         MakeSpace(row,bottomline,TRUE);
                    ELSE 
                         MakeSpace(1,row,FALSE);
                    END;                         
        WriteLine(row-1,col,text^.up);
        WriteLine(row,1,text);
END Return;

PROCEDURE EndOfLine;

BEGIN  IF EOF() AND ((NOT goingup) OR (text^.up = NIL)) 
        THEN col := 1;
             KillRepeat;
        ELSE
         IF (col = Length(text^.line)) OR (EOF())
          THEN Up(text,row,goingup);
               IF NOT CanDo THEN KillRepeat END;
          END;
         IF EOF() THEN col := 1
         ELSE col := Length(text^.line) END;
       END;
END EndOfLine;          

PROCEDURE DeleteLn;

VAR     i : CARDINAL;
        yorn : BOOLEAN;

BEGIN  IF NOT EOF() THEN
        DEALLOCATE(deletedptr);
        SetPtr(deletedptr,Length(text^.line));
        CopyPointer(deletedptr,text);
        IF text^.up # NIL THEN 
            JoinPtr(text^.up,text^.down);
            Up(text,i,FALSE);
        ELSE 
            Up(text,i,FALSE);
            text^.up := NIL;
        END;
        yorn := FALSE;
        IF row <= 12 THEN ReplaceTop(row,text,yorn) END;
         IF NOT yorn THEN ReplaceBottom(row,text,yorn);
          IF NOT yorn THEN MakeSpace(row,bottomline,FALSE); END;
         END;
        ELSE KillRepeat;
        END;
END DeleteLn;

PROCEDURE EndOfProg(p : lineptr; top : BOOLEAN);

BEGIN   WHILE CanDo DO Up(p,col,top); INC(page) END;
        IF page = 0 THEN KillRepeat END;
        col := 1;
        OptimizeDisplay(text,top);
END EndOfProg;

PROCEDURE FindNxt(up:BOOLEAN; VAR w:string; VAR n:CARDINAL; 
                  VAR p:lineptr):BOOLEAN;

VAR     q : lineptr;
        j : CARDINAL;
        found : BOOLEAN;

BEGIN   IF w[1] # EOL THEN
        Prompt('Working');
        q := p; j := n;
        REPEAT  found := SearchLine(j,w,q^.line);
                IF NOT found THEN Up(q,j,up);
                  INC(page); 
                  IF up THEN j := Length(q^.line) ELSE j := 0 END;
                END;
        UNTIL (NOT CanDo) OR found OR (q^.down = NIL);
        IF found THEN n := j;
                      OptimizeDisplay(p,up);
                      END;
        END;
        found := found AND (w[1] # EOL);
        IF NOT found THEN KillRepeat END;
        RETURN found;
END FindNxt;

PROCEDURE Change(VAR w1, w2 : string; VAR p : lineptr; VAR l : CARDINAL);

VAR     a, b, i : CARDINAL;

BEGIN   a := Length(w1); b := Length(w2);
        IF l + a < maxline THEN 
          i := l + a - 1;
          WHILE i >= l + 1 DO DeleteIt(i,p) END;
          l := i;
          WHILE i <= l + b -2 DO WriteLetterIn(i,w2[i-l+1],p) END;
        END;
END Change;

PROCEDURE SetTabWidth;

VAR     s : string;

BEGIN   RegularKeyPad;
        Prompt('New tab width: '); ReadLine(s); tabwidth := ToCard(s);
        AlternateKeyPad;
        IF tabwidth < 1 THEN tabwidth := 9 END;
        IF tabwidth > width THEN tabwidth := width END;
END SetTabWidth;

PROCEDURE ChangeCase(VAR c : CHAR);

BEGIN  CASE ORD(c) OF 
           65..90 : c := (CHR(ORD(c)+32))|
           97..122: c := (CHR(ORD(c)-32))
       ELSE END;
END ChangeCase;

PROCEDURE SingleCC;

BEGIN   IF NOT EOF() THEN
         ChangeCase(text^.line[col]);
         Write(text^.line[col]);
         IF col < maxline THEN INC(col) END;
        END
END SingleCC;

PROCEDURE GlobalCC;

VAR     i, n, m : CARDINAL;
        p : lineptr;

BEGIN   CutPart(text);
        n := LineNumber(paste2); m := LineNumber(paste1);
        p := paste1;
        WHILE m <= n DO
           i := 1;
           WHILE p^.line[i] # EOL DO 
              ChangeCase(p^.line[i]);
              INC(i);
              END;
           Up(p,m,FALSE);
        END;
        Display(text);
END GlobalCC;

PROCEDURE UnDeleteWord;

VAR     c : CARDINAL;
        p : lineptr;

BEGIN IF delwddone OR linefddone THEN 
       IF deletedword[1] = EOL THEN
                    SetPtr(p,1);
                    UnDeleteLn(p);
       ELSE
        IF NOT EOF() THEN
         c := col;
         WHILE deletedword[c-col+1] # EOL DO
            WriteLetterIn(c,deletedword[c-col+1],text);
            END;
         WriteLine(row,1,text);
         IF linefddone THEN col := c END; 
         END
        END
      END
END UnDeleteWord;

PROCEDURE OpenLine;

VAR     c : CARDINAL;

BEGIN   c := col;
        Return; 
        Up(text,row,TRUE);
        col := c;
END OpenLine;

PROCEDURE DelEoL;

VAR     i : CARDINAL;

BEGIN  i := Length(text^.line);
       IF (NOT EOF()) AND (col < i) AND (text^.line[1] # EOL) THEN
        EraseLine;
        text^.line[col] := EOL;
       ELSE KillRepeat;
       END;
END DelEoL;

PROCEDURE FindLine(s : string);

VAR     n, m, r : CARDINAL;
        p : lineptr; 

BEGIN   p := text; 
        r := LineNumber(p); 
        Top(p,TRUE);
        n := ToCard(s); m := 1; 
        WHILE CanDo AND (m < n) DO Up(p,m,FALSE) END;
        IF r > n THEN page := r - n ELSE page := n - r END; 
        OptimizeDisplay(text,r>n);
        prompt := TRUE;
        RvsOn; WriteLine(24,1,text); RvsOff;
END FindLine;

PROCEDURE Writefile;

BEGIN   Top(text,TRUE);
        OpenOutput(filename);
        Prompt('  Writing  ');
        WHILE NOT EOF() DO
          WriteFile(text^.line);
          text := text^.down;
          END;
        CloseOutput;
        TheEnd := TRUE;
END Writefile;

PROCEDURE Include;

VAR     s : string;
        p0, p1, p2 : lineptr;
        st , fi, i : CARDINAL;

BEGIN   Prompt('Include file: '); ReadLine(s);
        OpenInput(s); 
        IF NOT Empty THEN 
           Prompt('Starting line: '); ReadLine(s); st := ToCard(s);
           IF st = 0 THEN st := 1 END;
           Prompt('Until line: '); ReadLine(s); fi := ToCard(s);
           IF fi = 0 THEN fi := 5000 END;
           i := 1;
           WHILE (i < st) AND (NOT Empty) DO
               ReadFile(s);
               INC(i);
               END;
           IF NOT Empty THEN
            SetPtr(p1,1);
            p2 := p1; p0 := p1;
            WHILE NOT Empty AND (i <= fi) DO 
                 ReadFile(s);
                 SetPtr(p1,Length(s));
                 CopyLine(p1^.line,s,1,1); 
                 JoinPtr(p2,p1);
                 Up(p2,i,FALSE);
                 END;
            IF Empty THEN Up(p2,i,TRUE) END;
            Up(p0,i,FALSE);
            IF text^.up # NIL THEN JoinPtr(text^.up,p0) ELSE p0^.up := NIL END;
            JoinPtr(p2,text); 
            text := p0;
            Display(text);
           END;
           CloseInput;
       ELSE Prompt('File not found') 
       END;
END Include;

PROCEDURE ChangeWord(VAR p : lineptr);
           
VAR     s1, s2 : string;
        l, m, n, r : CARDINAL;
        p2 : lineptr;
        was : BOOLEAN;

BEGIN   Prompt('Change: ');ReadLine(s1);
        Prompt('For what: ');ReadLine(s2);
        IF s1[1] # EOL THEN
         was := goingup; goingup := FALSE;
         IF paste THEN CutPart(text);
                       p := paste1;
                       p2 := paste2;
         ELSE p2 := text;
              Top(p2,FALSE); 
              CanDo := TRUE;
         END;
         l := 0; n := Length(s2);
         m := LineNumber(p2); r := LineNumber(p);
         REPEAT  IF (r > m) THEN CanDo := FALSE;
                 ELSE IF SearchLine(l,s1,p^.line) THEN Change(s1,s2,p,l); 
                         IF n > 2 THEN l := l + n - 1 END;
                      ELSE Up(p,r,FALSE);
                           l := 0;
                      END; 
                 END; 
         UNTIL (NOT CanDo) OR (p^.down = NIL);
         goingup := was;
         Display(p);
        END;
END ChangeWord;

PROCEDURE WriteOutFile;

VAR     p1 : lineptr;
        s : string;
        n, m : CARDINAL;

BEGIN   CutPart(text); 
        p1 := paste1; 
        m := LineNumber(paste1);
        n := LineNumber(paste2);
        Prompt('Name of file: '); ReadLine(s);
        OpenOutput(s);
        WHILE (m <= n) AND CanDo DO
            WriteFile(p1^.line);
            Up(p1,m,FALSE);
            END;
        CloseOutput;
        Display(text);
END WriteOutFile;

PROCEDURE Command;

VAR     s, t : string;
        i, j : CARDINAL;
        done, was : BOOLEAN;

BEGIN   Prompt('Command: ');ReadLine(s);
        i := 1; j := 1; done := FALSE;
        WHILE (s[i] = ' ') AND (i < maxline) DO INC(i) END;
        WHILE (s[i] # ' ') AND (s[i] # EOL) DO 
               s[j] := Cap(s[i]); INC(i); INC(j); END;
        s[j] := EOL; j := 0;
        was := goingup; goingup := FALSE;
        CASE s[1] OF 
           '0'..'9' : FindLine(s); done := TRUE|
           'E'      : ToString('EXIT ',t); 
                      IF SearchLine(j,s,t) THEN Writefile; done := TRUE END|
            EOL     : WriteReverse(24,1,'line : ');
                      RvsOn;WriteCard(LineNumber(text));RvsOff|
           'I'      : ToString('INCLUDE ',t);
                      IF SearchLine(j,s,t) THEN done := TRUE;
                               IF NOT paste THEN Include END
                      END|
           'L'      : ToString('LEARN ',t);
                      IF SearchLine(j,s,t)THEN done := TRUE;
                         StartStoring; Prompt('Learning'); learnable := TRUE
                      END|
           'Q'      : ToString('QUIT ',t); 
                      IF SearchLine(j,s,t) THEN done := TRUE; 
                      TheEnd := TRUE END|
           'S'      : ToString('SUBSTITUTE ',t);
                      IF SearchLine(j,s,t) THEN done := TRUE;
                                                ChangeWord(text);
                      END|
           'W'      : ToString('WRITEFILE ',t);
                      IF SearchLine(j,s,t) THEN done := TRUE;
                                  IF paste THEN WriteOutFile
                                  ELSE Prompt('No selected region')
                                  END;
                      END
         ELSE END;
         goingup := was;
         IF NOT done THEN Prompt('Unrecognized command') END;
END Command;

PROCEDURE Fill;

VAR     i, j, k : CARDINAL;
        p, q, top : lineptr;
        newline : BOOLEAN;

BEGIN   Cut(text);
        SetPtr(p,1); JoinPtr(paste2,p); paste2 := p;
        i := 1; j := 1; newline := FALSE;
        SetPtr(p,width); q := p; top := q;
        WHILE paste1 # paste2 DO 
          WHILE Letter(paste1^.line[i])  AND (j < width) DO 
            q^.line[j] := paste1^.line[i];
            INC(i); INC(j);
            END;
          IF (NOT Letter(paste1^.line[i])) AND (j < width) THEN 
            q^.line[j] := ' '; INC(j) END;
          IF (j >= width) AND Letter(paste1^.line[i]) THEN 
             k := 1;
             WHILE (i-k > 0) AND Letter(paste1^.line[i-k]) DO INC(k) END;
             IF (i-k > 0) AND (NOT Letter(paste1^.line[i-k])) THEN DEC(j,k); 
                                                DEC(i,k);
                                                q^.line[j] := EOL;
                                                newline := TRUE;
                                               END;
             IF (i-k = 0) AND Letter(paste1^.line[1])
             AND (j-k > 1) THEN i := 1; DEC(j,k);
                                q^.line[j] := EOL;
                                newline := TRUE;
                                END;
             END;
          WHILE (paste1^.line[i] =' ') AND (i < maxline) DO INC(i); END;
          IF paste1^.line[i] = EOL THEN i := maxline + 1 END;
          IF i >= maxline THEN 
            paste1 := paste1^.down;
            DEALLOCATE(paste1^.up); 
            WHILE (Length(paste1^.line) = 1) AND (paste1 # paste2) DO 
              paste1 := paste1^.down;
              DEALLOCATE(paste1^.up); 
              END;
            i := 1;
          ELSE
            IF (j >= width) OR newline THEN           
              SetPtr(p,width);             
              JoinPtr(q,p);               
              q^.line[j] := EOL; 
              q := q^.down;
              j := 1;
              newline := FALSE;               
              END;           
          END; 
       END;
       q^.line[j] := EOL;
       IF text^.up = NIL THEN top^.up := NIL ELSE JoinPtr(text^.up,top) END;
       JoinPtr(q,text);
       Display(text);
       paste1 := paste3; paste2 := paste4;
END Fill;

PROCEDURE UnDeleteChar;

VAR     p : lineptr;

BEGIN IF delchdone THEN 
        IF (deletedchar # EOL) AND (NOT EOF())  THEN
          WriteLetter(deletedchar);
          DEC(col)
        ELSE
          SetPtr(p,1);
          UnDeleteLn(p);
          col := 1;
        END;
      END;
END UnDeleteChar;

PROCEDURE UnDeleteLn(p : lineptr);

VAR     q : lineptr;

BEGIN   SetPtr(q,Length(p^.line));
        CopyPointer(q,p);
        JoinInPtr(q,text,TRUE);
        text := text^.up;
        IF row <= 12 THEN MakeSpace(row,bottomline,TRUE);
        ELSE
            DEC(row); 
            MakeSpace(1,row,FALSE);
        END;
        WriteLine(row,1,text);
END UnDeleteLn;

PROCEDURE Find;

BEGIN   Prompt('Search for: ');
        ReadLine(search);
        findline  := TRUE;
        IF NOT FindNxt(goingup,search,col,text) THEN Prompt('Not found') END;
END Find;       

PROCEDURE Substitute;

VAR     word1, word2 : string;
        found : BOOLEAN;

BEGIN   Prompt('substitute: ');ReadLine(word1);
        Prompt('For what: ');ReadLine(word2);
        IF word1[1] # EOL THEN
        REPEAT found := FindNxt(goingup,word1,col,text);
               page := 0;
               WriteCursor(row,col);
               IF found THEN 
                Read(letter);
                 IF letter = 33C THEN Read(letter);Read(letter); END;
                  IF (letter = 115C) OR (letter = 15C) THEN 
                                           Change(word1,word2,text,col);
                                           WriteLine(row,col,text);
                 END;
               END;
        UNTIL (NOT found) OR ((letter # 115C) AND (letter # 15C) 
                               AND (letter # 122C));
        ErasePrompt;
        END;
END Substitute;

PROCEDURE Repeat;

VAR     s : string;
        i, j : CARDINAL;
        do : BOOLEAN;

BEGIN WriteCursor(24,1); RvsOn;
      i := 1; s[1] := letter;
      REPEAT IF s[i] = 177C THEN
               IF i > 1 THEN DEC(i); BackSpace; EraseLine; END;
             ELSE Write(s[i]);
                  INC(i);
             END;
             Read(s[i]);
     UNTIL ((s[i] < 60C) OR (s[i] > 71C)) AND (s[i] # 177C) OR (i > maxline-1);
     RvsOff;
     series[1] := s[i];
     s[i] := 0C;
     IF series[1] = 33C THEN 
        Read(series[2]);
        Read(series[3]);
        IF series[3] = 'P' THEN
           Read(series[4]);
           IF series[4] = 33C THEN
              Read(series[5]);
              Read(series[6]);
              lenrep := 6;
              IF (series[6] = 'P') OR (series[6] = 'w') THEN do := FALSE END;
           ELSE do := FALSE
           END;
        ELSE  lenrep := 3 END;
     ELSE lenrep := 1; END;
     IF do THEN repeat := ToCard(s) END;
     display := NOT do;
     redisplay := do;
END Repeat;

PROCEDURE Gold;

BEGIN   Read(letter);
        IF ORD(letter) = 13 THEN Substitute
        ELSE
            IF ORD(letter) = 27 THEN
                Read(letter); Read(letter);
                CASE ORD(letter) OF 
                        77  : Substitute|
                        81  : RunHelp; Display(text)|
                        82  : Find|
                        83  : IF dellndone THEN UnDeleteLn(deletedptr) END|
                        108 : UnDeleteChar|
                        109 : UnDeleteWord|
                        110 : IF paste THEN Reset(text);Display(text) END|
                        112 : OpenLine|
                        113 : IF paste THEN GlobalCC ELSE SingleCC END|
                        114 : DelEoL|
                        115 : |
                        116 : EndOfProg(text,FALSE)|
                        117 : EndOfProg(text,TRUE)|
                        118 : IF pasted THEN Paste(text);Display(text) END|
                        119 : IF storing THEN sequence[counter-5] := 5C;
                                              storing := FALSE;
                                              END;
                              Command|
                        120 : IF paste THEN Fill END|
                        121 : IF paste THEN Replace(text);Display(text) END
                        ELSE Prompt('Unrecognized command')
                        END
             ELSE 
                 IF (letter >= '0') AND (letter <= '9') THEN Repeat END;
             END;
        END
END Gold;

PROCEDURE DeleteChar;

BEGIN  IF NOT EOF() THEN
        delchdone := TRUE;
        deletedchar := EOL;
        IF (text^.line[1] = EOL) AND (col <= 1) THEN DeleteLn
        ELSE
         IF (text^.line[col] # EOL) AND (col < Length(text^.line)) THEN
          deletedchar := text^.line[col];
          INC(col);
          Delete;
         END;
        END;
       ELSE KillRepeat;
       END;
END DeleteChar;

PROCEDURE DeleteWord;

VAR     k : CARDINAL;

BEGIN  IF NOT EOF() THEN
        delwddone := TRUE; linefddone := FALSE; 
        IF (col <= 1) AND (text^.line[1] = EOL) THEN DeleteLn;
                                                     deletedword[1] := EOL;
        ELSE
        IF (text^.line[col] # EOL) AND (col < Length(text^.line)) THEN
         k := col;
         WHILE (k < maxline) AND (Letter(text^.line[k])) DO
              deletedword[k-col+1] := text^.line[k];
              INC(k);
              END;
         WHILE (text^.line[k] = ' ') AND (k < maxline) DO 
              deletedword[k-col+1] := ' ';
              INC(k);
              END;
         deletedword[k-col+1] := EOL;
         WHILE k > col DO DeleteIt(k,text) END;
         WriteLine(row,col,text);
         END
        END
       ELSE KillRepeat;
       END
END DeleteWord;

PROCEDURE Line;

BEGIN   Up(text,row,goingup);
        col := 1;
END Line;       

PROCEDURE Word;

BEGIN  IF goingup THEN 
           IF (col <= 1) THEN Up(text,row,goingup);
                             IF CanDo THEN col := Length(text^.line) END;
           ELSE DEC(col);
                WHILE (Letter(text^.line[col])) AND (col > 1) DO DEC(col) END;
                WHILE (col > 1) AND (text^.line[col] = ' ') DO DEC(col) END;
           END;
        ELSE
         IF NOT EOF() THEN
          IF (text^.line[col] = EOL) THEN Up(text,row,goingup);
                             IF CanDo THEN col := 1 END;
          ELSE INC(col);
           WHILE (col < maxline) AND (Letter(text^.line[col])) DO INC(col) END;
           WHILE (text^.line[col] = ' ') AND (col < maxline) DO INC(col) END;
           END
          END
        END
END Word;

PROCEDURE Char;

BEGIN  IF goingup THEN 
            IF (col > 1) THEN DEC(col);
            ELSE 
                 Up(text,row,TRUE);                                     
                 IF CanDo THEN col := Length(text^.line) END;
            END;
        ELSE 
           IF NOT EOF() THEN
            IF (col < maxline) AND (text^.line[col] # EOL) THEN INC(col)
            ELSE  
                Up(text,row,FALSE);  
                IF CanDo THEN col := 1 END;
            END;
           END;
        END;
END Char;

PROCEDURE Sect;

VAR     i : CARDINAL;

BEGIN   i := 1;
        REPEAT  IF paste THEN CheckRange END;
                Up(text,row,goingup);
                Refresh(text);
                INC(i);
        UNTIL (i >= sectlength) OR (NOT CanDo);
        IF NOT CanDo THEN KillRepeat END;
END Sect;       

PROCEDURE Page;

VAR     s : string;

BEGIN   s[1] := ff; s[2] := EOL;
        IF NOT FindNxt(goingup,s,col,text) THEN 
           page := 0; 
           CanDo := TRUE;
           EndOfProg(text,goingup);
        END;
END Page;

PROCEDURE Escape;
BEGIN   Read(letter);
        CASE ORD(letter) OF
          91 : Arrows|
          79 : Read(letter); 
                page := 0; 
                CASE ORD(letter) OF
                  77  : | 
                  80  : Gold|
                  81  : RunHelp; Display(text)|
                  82  : IF findline  THEN 
                          IF NOT FindNxt(goingup,search,col,text) THEN 
                                 Prompt('Not found'); END
                        END|
                  83  : dellndone := TRUE; DeleteLn|
                  108 : DeleteChar|
                  109 : DeleteWord|
                  110 : IF NOT ((text^.up = NIL) AND (EOF()))
                        THEN Select(text) END|
                  112 : Line|
                  113 : Word|
                  114 : EndOfLine|
                  115 : Char|
                  116 : goingup := FALSE|
                  117 : goingup := TRUE|
                  118 : IF paste THEN pasted := TRUE; 
                          Cut(text);Display(text) END |
                  119 : Page|
                  120 : Sect|
                  121 : IF paste THEN Append(text) ;Display(text) END
                  ELSE Prompt('Unrecognized command')
                  END
        ELSE
        END;
        ClearTypeAhead;
END Escape;

PROCEDURE LineFeed; 

VAR     was : BOOLEAN; 
        i, j, r, c : CARDINAL; 

BEGIN   IF col < Length(text^.line) THEN
         was := goingup;
         goingup := TRUE;
         linefddone := TRUE; delwddone := FALSE; 
         r := row; c := col; 
         Word;
         IF r # row THEN col := 1; Up(text,row,FALSE); 
         ELSE IF col # 1 THEN col := col + 1 END; END; 
         j := 0; 
         FOR i := col TO c-1 DO INC(j); deletedword[j] := text^.line[i] END;
         deletedword[j+1] := EOL;
         WHILE c > col DO DeleteIt(c,text) END; 
         WriteLine(row,1,text); 
         goingup := was; 
        END;
END LineFeed;

PROCEDURE PastEOL(c : CARDINAL);

VAR     i, l : CARDINAL;
        rp : BOOLEAN;

BEGIN   l := Length(text^.line);
        IF c >= l THEN
                rp := text = paste1;
                ReplacePtr(text,c+1); 
                FOR i := l TO c-1 DO text^.line[i] := ' ' END;
                text^.line[c] := EOL; 
                text^.line[c+1] := EOL;
                IF rp THEN paste1 := text END;
                IF paste THEN WriteLine(row,l,text) END;
        END;
END PastEOL;

PROCEDURE WriteLetterIn(VAR l : CARDINAL; c : CHAR; VAR p : lineptr);

VAR     i : CARDINAL;
        rp : BOOLEAN;

BEGIN  IF l < maxline THEN
        IF EOF() THEN OpenLine END;
        PastEOL(l);
        rp := paste1 = text;
        ReplacePtr(p,Length(p^.line)+1); 
        IF rp THEN paste1 := text END;
        CopyLine(p^.line,p^.line,l+1,l);
        p^.line[l] := c;
        INC(l);
       END;
END WriteLetterIn;

PROCEDURE WriteLetter(l : CHAR);

VAR     i : CARDINAL;

BEGIN  IF col < maxline THEN 
         IF PUSH THEN 
            IF EOF() THEN OpenLine END;
              PastEOL(col);
              text^.line[col] := l;
              Write(l);
              INC(col);
        ELSE 
              WriteLetterIn(col,l,text);
              WriteLine(row,col-1,text);
        END;
       END;
END WriteLetter;

PROCEDURE DeleteIt(VAR d : CARDINAL; VAR p : lineptr);

VAR     rp  : BOOLEAN;

BEGIN   IF NOT EOF() THEN 
          CopyLine(p^.line,p^.line,d-1,d);
          rp := paste1 = text;
          ReplacePtr(p,Length(p^.line));
          IF rp THEN paste1 := text END;
          DEC(d);
        ELSE KillRepeat;
        END;
END DeleteIt;

PROCEDURE Delete;

VAR     p : lineptr;
        done, rp : BOOLEAN;

BEGIN   IF col > 1 THEN
         IF col <= Length(text^.line) THEN 
          DeleteIt(col,text);
          WriteLine(row,col,text);
         ELSE DEC(col)
         END
        ELSE 
         IF (NOT EOF()) AND (text^.up # NIL) THEN
            done := FALSE;
            IF row < 12 THEN ReplaceTop(row,text,done) END;
            IF NOT done THEN ReplaceBottom(row-1,text,done);
              IF NOT done THEN MakeSpace(row,bottomline,FALSE); END;
            END;
            rp := text = paste1;
            p := text;
            JoinPtr(text^.up,text^.down);
            col := Length(text^.up^.line);
            Up(text,row,TRUE);
            rp := rp OR (text = paste1);
            ReplacePtr(text,Length(text^.line)+Length(p^.line)); 
            CopyLine(text^.line,p^.line,Length(text^.line),1);
            IF rp THEN 
               paste1 := text;
               RvsOn;
               WriteLine(row,1,text);
               RvsOff;
            ELSE
               WriteLine(row,col,text);
            END;
            DEALLOCATE(p);
         ELSE KillRepeat;
         END;
        END;
        ClearTypeAhead;
END Delete;

PROCEDURE Tab;

VAR     i, t : CARDINAL;

BEGIN   t := tabwidth - (col MOD tabwidth);
        FOR i := 1 TO t DO WriteLetterIn(col,' ',text) END;
        WriteLine(row,1,text);    
END Tab;

PROCEDURE Arrows;
            
BEGIN   Read(letter);
          CASE ORD(letter) OF
             65 : Up(text,row,TRUE)|
             66 : Up(text,row,FALSE)|
             67 : IF col < maxline THEN INC(col) END|
             68 : IF col > 1 THEN DEC(col) END
          ELSE END;
END Arrows;

PROCEDURE Refresh(p : lineptr);

BEGIN   IF row < 2 THEN 
            IF p^.up # NIL THEN
               MakeSpace(1,bottomline,TRUE);
               p := p^.up;
               WriteLine(1,1,p);
               INC(row);
            END;
        ELSE
        IF row > (bottomline-1) THEN 
           MakeSpace(1,bottomline,FALSE);
           DEC(row);
           IF p^.down # NIL THEN 
                p := p^.down;
                WriteLine(bottomline,1,p);
           END;
          END;
        END;
END Refresh;

BEGIN   Init;
        AlternateKeyPad;
        Readfile;
        ClearScreen;
        Display(text);
        REPEAT  Refresh(text);
                IF paste THEN CheckRange END;
                IF EOF() THEN col := 1 END;
                WriteCursor(row,col);
                CanDo := TRUE;
                IF redisplay AND (repeat = 0) THEN
                   redisplay := FALSE; Display(text) END;
                Read(letter);
                IF prompt THEN ErasePrompt; WriteCursor(row,col) END;
                CASE ORD(letter) OF 
                   5  : |
                   8  : col := 1| 
                   9  : Tab|
                   10 : LineFeed| 
                   12 : WriteLetter(ff)|
                   13 : IF EOF() THEN OpenLine ELSE Return END|
                   14 : PUSH := NOT PUSH|
                   18 : IF learnable THEN StartLearn; Prompt('Working') END|
                   20 : SetTabWidth|
                   23 : ClearScreen; Display(text)|
                   26 : Writefile|
                   27 : Escape|
                   32..126: WriteLetter(letter)|
                   127 : Delete 
                   ELSE Prompt('Unrecognized command')
                END;
        UNTIL TheEnd;
        Exit;
        WriteCursor(23,1);
END E2Editor. 
