IMPLEMENTATION MODULE E2FileIt;

FROM R2SysCalls IMPORT GetCommand;
FROM E2Terminal IMPORT WriteString, ReadString, RvsOn, RvsOff, 
                     EraseRest, WriteCursor, WriteLn;
FROM R2Streams IMPORT CreateStream, OpenStream, CloseStream, EndStream,
                      Stream, Done, ReleaseStream, ReadLine, WriteLine;
FROM E2Variables IMPORT string;

VAR     f, g : Stream;
        success : BOOLEAN;

PROCEDURE OpenInput(s : string);

BEGIN   OpenStream(f,s,FALSE);
        Empty := NOT Done;
        success := Done;
END OpenInput;

PROCEDURE FileName(VAR s : ARRAY OF CHAR);

BEGIN   GetCommand(s);
        IF s[0] <> 0C THEN RETURN END;
        WriteString("Filename: ");
        ReadString(s);
END FileName;

PROCEDURE ReadFile(VAR line : ARRAY OF CHAR);

BEGIN   Empty := EndStream(f);
        IF NOT Empty THEN ReadLine(f,line) END;
END ReadFile;

PROCEDURE CloseInput;

BEGIN   IF success THEN ReleaseStream(f) END;
END CloseInput;

PROCEDURE OpenOutput(s : string);

BEGIN   LOOP CreateStream(g,s);
             IF Done THEN RETURN END;
             WriteCursor(23,1);
             RvsOn;
             WriteString("Cannot open file, try again");
             WriteLn;
             WriteString("Filename: ");
             ReadString(s);
             RvsOff;
             WriteCursor(22,1);
             EraseRest;
             END;
END OpenOutput;

PROCEDURE WriteFile( VAR line : string);

BEGIN   WriteLine(g,line);
END WriteFile;

PROCEDURE CloseOutput;

BEGIN   CloseStream(g);
END CloseOutput;

END E2FileIt.
