IMPLEMENTATION MODULE E2Functions;

FROM E2Pointer   IMPORT Up;
FROM E2Variables IMPORT goingup, ff, maxline, text, formfeed, width, literal, 
                        pastbuffer, paste1, paste, EOL, string, lineptr;
FROM E2Terminal  IMPORT RvsOn, RvsOff, Read, BackSpace, EraseLine, Write,
                        WriteCursor, WriteString, SpecChar;

PROCEDURE ToString(s : literal; VAR t : string);

VAR     i, j : CARDINAL;

BEGIN   i := 0; j := 1;
        WHILE (s[i] # ' ') AND (j < maxline) DO 
          t[j] := s[i];
          INC(i); INC(j);
          END;
        t[j] := EOL;
END ToString;

PROCEDURE LineNumber(p : lineptr) : CARDINAL;

VAR     l : CARDINAL;

BEGIN   l := 1;
        WHILE p^.up # NIL DO p := p^.up; INC(l) END;
        RETURN l;
END LineNumber;

PROCEDURE Length(VAR s : string) : CARDINAL;

VAR     l : CARDINAL;
 
BEGIN   l := 1;
        WHILE (s[l] # EOL) AND (l <= maxline) DO INC(l) END;
        RETURN l;
END Length;

PROCEDURE CopyLine(VAR s1, s2: string; n1, n2 : CARDINAL);

VAR     i, l : CARDINAL; 
        s : literal;

BEGIN   l := Length(s1);
        FOR i := 1 TO l DO s[i-1] := s1[i] END;
        l := Length(s2); 
        WHILE (n1 < maxline) AND (n2 < l) DO
           s[n1-1] := s2[n2];
           INC(n1);  INC(n2);
           END;
        s[n1-1] := EOL;
        l := n1;
        FOR i := 1 TO n1 DO s1[i] := s[i-1] END;
END CopyLine;

PROCEDURE ReadLine(VAR s : string);

VAR     i : CARDINAL;
        c : CHAR;

BEGIN   RvsOn;
        i := 1;
        Read(c);
        WHILE (ORD(c) >= 32) AND (ORD(c) <=127) DO
           IF (ORD(c) = 127) AND (i > 1) THEN BackSpace;
                                   EraseLine;
                                   DEC(i);
           ELSE
             IF (ORD(c) # 127) AND (i < maxline) THEN 
                                   s[i] := c;
                                   INC(i);
                                   Write(c);
                                   END;
           END;
           Read(c);
           END;
           s[i] := EOL;
        IF (ORD(c) = 27) THEN Read(c);Read(c);
          IF (ORD(c) = 117) OR (ORD(c) = 65) THEN goingup := TRUE END;
          IF (ORD(c) = 116) OR (ORD(c) = 66) THEN goingup := FALSE END;
        END;
        RvsOff;
END ReadLine;

PROCEDURE WriteLine(r, c : CARDINAL; p : lineptr);

VAR     s : string;
        a, b, d : CARDINAL;

  PROCEDURE Copy(VAR s1,s2:string; n1:CARDINAL; VAR n2:CARDINAL):BOOLEAN; 
  BEGIN   WHILE (n2 < width) AND (s2[n2] # ff) AND (s2[n2] # EOL) DO
                   s1[n1] := s2[n2];
                   INC(n1); INC(n2);
                   END;
         IF n2 < width THEN s1[n1+1] := EOL ELSE s1[width] := EOL END;
         IF s2[n2] # ff THEN s1[n1] := EOL END;
         RETURN (s2[n2] # ff);
  END Copy;

  PROCEDURE InRange() : BOOLEAN;
  BEGIN 
         IF p^.down = NIL THEN RETURN FALSE END;
         a := LineNumber(p); 
         b := LineNumber(text); 
         d := LineNumber(paste1);
         RETURN  ((a <= b) AND (a >= d)) OR ((a >= b) AND (a <= d))
  END InRange;

BEGIN 
        p^.reverse := (paste AND InRange());
        IF p^.reverse THEN RvsOn END;
        WriteCursor(r,c);
        LOOP
              IF Copy(s,p^.line,1,c) THEN WriteString(s); EXIT;
              ELSE WriteString(s);SpecChar(r,c,formfeed);INC(c);
              END;
        END;
        IF Length(p^.line) > width THEN SpecChar(r,width,pastbuffer) END; 
        RvsOff;
END WriteLine;
 
PROCEDURE SearchLine(VAR at : CARDINAL; VAR word, line : string) : BOOLEAN;

VAR     count, i, j, k, l, n : INTEGER;
 
BEGIN   i := at;
        l := Length(word);
        n := Length(line);
        IF goingup THEN j := -1; k := l - 1;
        ELSE k := 1; j := 1; END;
        INC(i,j);
        count := 1;
        WHILE (i < n) AND (i > 0) AND (count < l) DO
                IF word[k] = line[i] THEN INC(k,j);
                                          INC(count);
                ELSE count := 1;
                     IF goingup THEN k := l - 1;
                     ELSE k := 1;
                     END;
                END;
        INC(i,j);
        END;
        IF count >= l THEN 
            IF j > 0 THEN at := i - l + 1 ELSE at := i + 1 END;
        END;
        RETURN (count >= l);
END SearchLine;

PROCEDURE Letter(ch : CHAR) : BOOLEAN;

BEGIN   RETURN (((ORD(ch) >= 33) AND (ORD(ch) <=126)) OR (ch = ff))
END Letter;

PROCEDURE ToCard(s : string) : CARDINAL;

VAR     i, n : CARDINAL;

BEGIN   i := 1; n := 0;
        WHILE (i <= 4) AND (ORD(s[i]) <= 57) AND (ORD(s[i]) >= 48) DO
            n := 10 * n + ORD(s[i]) - 48;
            INC(i);
            END;
        RETURN n;
END ToCard;

END E2Functions.
