IMPLEMENTATION MODULE E2Pointer;

IMPORT R2Storage;

FROM E2Variables IMPORT lineptr, EOL, text, maxline, string;

CONST   blocksize = 14; 
        multiple  = 16;

PROCEDURE Length(VAR s : string):CARDINAL;

VAR     l : CARDINAL;
 
BEGIN   l := 1;
        WHILE (s[l] # EOL) AND (l < maxline) DO INC(l) END;
        RETURN l;
END Length;

PROCEDURE EOF() : BOOLEAN;

BEGIN   RETURN (text^.down = NIL);
END EOF;

PROCEDURE SetPtr(VAR p : lineptr; n : CARDINAL);

BEGIN   n := ((n + (multiple-1)) DIV multiple) * multiple;
        R2Storage.ALLOCATE(p,blocksize+n);
        p^.length := n;
        p^.reverse := FALSE;
        p^.line[1] := EOL;
        p^.up := NIL;
        p^.down := NIL;
END SetPtr;

PROCEDURE CopyPointer(VAR p1 : lineptr; p2 : lineptr);

VAR     i, l : CARDINAL; 

BEGIN   l := Length(p2^.line);
        FOR i := 1 TO l DO p1^.line[i] := p2^.line[i] END; 
        p1^.reverse := p2^.reverse; 
END CopyPointer;

PROCEDURE ReplacePtr(VAR p : lineptr; n : CARDINAL);

VAR     q : lineptr; 

BEGIN   IF (n > p^.length) OR (p^.length - multiple > n) THEN 
         n := ((n + (multiple-1)) DIV multiple) * multiple;
         R2Storage.ALLOCATE(q,blocksize+n);
         CopyPointer(q,p);
         IF p^.up = NIL THEN q^.up := NIL ELSE JoinPtr(p^.up,q) END;
         IF p^.down = NIL THEN q^.down := NIL ELSE JoinPtr(q,p^.down) END;
         DEALLOCATE(p);
         p := q;
         p^.length := n;
        END;
END ReplacePtr; 

PROCEDURE DEALLOCATE(VAR p : lineptr);

BEGIN   R2Storage.DEALLOCATE(p,blocksize+p^.length);
END DEALLOCATE; 

PROCEDURE Up(VAR p : lineptr; VAR n : CARDINAL; up : BOOLEAN);

BEGIN   CanDo := FALSE;
        IF (p^.up # NIL) AND up THEN 
            p := p^.up; 
            DEC(n); 
            CanDo := TRUE;
        ELSE
         IF (p^.down # NIL) AND (NOT up) THEN 
            p := p^.down; 
            INC(n); 
            CanDo := TRUE; 
         END
        END
END Up;

PROCEDURE Top(VAR p : lineptr; up : BOOLEAN);

VAR     d : CARDINAL; (*dummy var*)

BEGIN   CanDo := TRUE;
        WHILE CanDo DO Up(p,d,up) END;
END Top;

PROCEDURE JoinPtr(VAR p1, p2 : lineptr);

BEGIN   p1^.down := p2;
        p2^.up := p1;
END JoinPtr;

PROCEDURE JoinInPtr(VAR p1, p2 : lineptr; above : BOOLEAN);

BEGIN   IF above THEN p1^.up := p2^.up;
                      IF p2^.up # NIL THEN p2^.up^.down := p1 END;
                      p1^.down := p2;
                      p2^.up := p1;
        ELSE
                      p1^.down := p2^.down;
                      IF p2^.down # NIL THEN p2^.down^.up := p1 END;
                      p1^.up := p2;
                      p2^.down := p1;
        END
END JoinInPtr;

END E2Pointer.
