IMPLEMENTATION MODULE E2Terminal;

IMPORT R2SysCalls;
FROM E2Variables IMPORT literal, lenrep, series, repeat, display;
FROM E2Learn IMPORT NextLearn, learnon, storing, StoreLearn;

VAR     count : CARDINAL;

PROCEDURE ClearTypeAhead;

VAR    c : CHAR; 

BEGIN   IF NOT storing THEN
         LOOP   R2SysCalls.Read(c,FALSE);
                IF R2SysCalls.Result() <> R2SysCalls.Ok 
                  THEN c := 0C; EXIT; END;
                IF c = 33C THEN 
                  R2SysCalls.Read(c,TRUE);
                  R2SysCalls.Read(c,TRUE);
                  END;
         END;
        END;
END ClearTypeAhead;

PROCEDURE WriteString(VAR s : ARRAY OF CHAR);

BEGIN   IF display THEN R2SysCalls.WriteString(s);
           EraseLine;
        END;
END WriteString;

PROCEDURE WriteLn;

BEGIN   IF display THEN R2SysCalls.WriteLn; END;
END WriteLn;

PROCEDURE Write(c : CHAR);

BEGIN   IF display THEN R2SysCalls.Write(c); END;
END Write;

PROCEDURE Read(VAR c : CHAR);

VAR     donebefore : BOOLEAN;

BEGIN   IF repeat > 0 THEN 
          IF learnon THEN NextLearn(c)
          ELSE 
            IF NOT donebefore THEN count := 0; donebefore := TRUE; END;
            count := (count MOD lenrep) + 1;
            c := series[count];
            IF count = lenrep THEN DEC(repeat) END;
            display := repeat = 0;
          END;
        ELSE display := TRUE;
             donebefore := FALSE;
             IF storing THEN R2SysCalls.Read(c,TRUE);
                             StoreLearn(c);
             ELSE 
               IF learnon THEN NextLearn(c);
               ELSE R2SysCalls.Read(c,TRUE) END;
             END;
        END;
END Read;

PROCEDURE ReadLn;

BEGIN 
END ReadLn;

PROCEDURE ReadString(VAR s : ARRAY OF CHAR);

BEGIN   Write(CHR(27));Write('>');
        R2SysCalls.ReadString(s);
        Write(CHR(27));Write('=');
END ReadString;

PROCEDURE SetOff;

BEGIN 
END SetOff;

PROCEDURE SetOn;

BEGIN 
END SetOn;

PROCEDURE AlternateKeyPad;

BEGIN   Write(CHR(27));Write('='); (* alternate keypad mode *);
END AlternateKeyPad;

PROCEDURE RegularKeyPad;

BEGIN   Write(CHR(27)); Write('>');
END RegularKeyPad;

PROCEDURE Initialize;

BEGIN   AlternateKeyPad;
        RvsOff;
        display := TRUE;
        Write(CHR(27));Write(')');Write('0');
END Initialize;

PROCEDURE Exit;

BEGIN   RegularKeyPad;
END Exit;

PROCEDURE WriteCard( x : CARDINAL);

VAR     j, l : CARDINAL;
        string : ARRAY[1..10] OF CHAR;

BEGIN   l := 0;
        WHILE x > 0 DO
          INC(l);
          j := x;
          x := x DIV 10;
          string[l] := CHR(ORD ('0') + j - (x * 10));
          END;
        FOR x := l TO 1 BY -1 DO
          Write(string[x]);
          END;
END WriteCard;

PROCEDURE EraseRest;

BEGIN   Write(CHR(27));
        Write('[');
        Write('J');
END EraseRest;

PROCEDURE EraseLine;

BEGIN   Write(CHR(27));
        Write('[');
        Write('K');
END EraseLine;

PROCEDURE BackSpace;

BEGIN   Write(CHR(8));
END BackSpace;

PROCEDURE WriteCursor(x, y : CARDINAL);

BEGIN   Write(CHR(27));
        Write('[');WriteCard(x);Write(';');WriteCard(y);Write('f');
END WriteCursor;

PROCEDURE RvsOn;

BEGIN   Write(CHR(27));
        Write('[');Write('7');Write('m');
END RvsOn;

PROCEDURE RvsOff;

BEGIN   Write(CHR(27));
        Write('[');Write('m');
END RvsOff;

PROCEDURE WriteReverse( x, y : CARDINAL ;s : literal);

BEGIN   RvsOn;
        WriteCursor(x,y);
        WriteString(s);
        RvsOff;
END WriteReverse;

PROCEDURE MakeSpace( x, y : CARDINAL; top : BOOLEAN);

BEGIN   Write(CHR(27));
        Write('[');WriteCard(x);Write(';');WriteCard(y);Write('r');
        (* make area of screen between x and y *)
        IF top THEN 
                WriteCursor(x,1);
                Write(CHR(27));
                Write('M')
                (* grab from the bottom *)
        ELSE 
                WriteCursor(y,1);
                Write(CHR(27));
                Write('E')
                (* grab from the top *)
        END;
        Write(CHR(27));Write('[');Write('r');
        (* screen back to full size *)
END MakeSpace;

PROCEDURE ClearScreen;

BEGIN   Write(CHR(27));
        Write('[');Write('2');Write('J'); 
END ClearScreen;

PROCEDURE SpecChar(r, c, ch : CARDINAL);

BEGIN   Write(CHR(14));
        WriteCursor(r,c);
        Write(CHR(ch));
        Write(CHR(15));
END SpecChar;

BEGIN repeat := 0;
END E2Terminal.
