IMPLEMENTATION MODULE DayOfWeek;

FROM R2SysCalls IMPORT Status, Time, GetTime;
FROM R2Strings IMPORT Substring;

(* Adapted from a program by B.G. Adams, using Zeller's formula *)

CONST   days = "SunMonTueWedThuFriSat";

PROCEDURE  DOW( t : Time; VAR s : ARRAY OF CHAR);

(* Return the day of the week for an arbitrary time *)

VAR     y, m, d, c, x, j : CARDINAL;

BEGIN   x := t.day;
        y := (x DIV 512) + 1980;
        x := x MOD 512;
        m := x DIV 32 + 1;
        d := x MOD 32;
        IF m > 2 THEN DEC(m,2) ELSE INC(m,10); DEC(y,1) END;
        c := y DIV 100;
        y := y MOD 100;
        j := (d + (26*m-2) DIV 10 + y + y DIV 4 + c DIV 4 + 5*c) MOD 7;
        Substring(days,s,3*j,3);
END DOW;

PROCEDURE  Today( VAR s : ARRAY OF CHAR);

(* Return the day of week for today *)

VAR     r : Status;    
        t : Time;

BEGIN   r := GetTime(t);
        DOW(t,s);
END Today;

END DayOfWeek.
