MODULE LMDF;  (* The LUMOS-2 implementation of MMDF *)

FROM LogFile IMPORT StartLog, LogString, LogLn, Terminate;
FROM R2SysCalls IMPORT Status, GetMessage;
FROM DialProto IMPORT InitProto, RecvChar, RecvRec, SendChar, SendRec;
FROM MailInterface IMPORT Deliver, Return, NextMessage;
FROM R2Streams IMPORT WriteChar, CloseStream, ReleaseStream, Stream,
                      ReadChar, EndStream;
FROM R2Strings IMPORT Copy, Remove, Concatenate, Find, Insert;
FROM R2NewCalls IMPORT WriteMessage;

PROCEDURE  BeepMsg( VAR to, from : ARRAY OF CHAR);

VAR     ms, us : ARRAY [0..79] OF CHAR; 
        x : Status;
        k : CARDINAL;

BEGIN   ms[0] := 15C; ms[1] := 12C; ms[2] := 7C;
        ms[3] := 15C; ms[4] := 12C; ms[5] := 0C;
        Insert(from,ms,3);
        Insert("New network mail from ",ms,3);
        Copy(to,us);
        k := 0;
        WHILE (k <= 79) AND (us[k] <> 0C) AND (us[k] <> '@') DO INC(k) END;
        IF k <= 79 THEN us[k] := 0C END;        (* trim off domain *)
        x := WriteMessage(us,ms);
END BeepMsg;
        
PROCEDURE  Submit;

VAR     to, ra, jn : ARRAY [0..133] OF CHAR;
        ms : Stream;
        rs : Status;
        ch : CHAR;

BEGIN   LOOP RecvRec(ra);
             IF ra[0] = 0C THEN EXIT END;
             IF (ra[0] <> 'm') OR (ra[1] <> ';') THEN
               LogString("'m;' expected in: ");
               LogString(ra); LogLn; Terminate;
               END;
             Remove(ra,0,2); 
             RecvRec(to);
             rs := Deliver(ms,to);
             IF rs = Ok
               THEN SendRec("60");
                    RecvRec(jn);
                    WHILE RecvChar(ch) DO WriteChar(ms,ch) END;
                    CloseStream(ms);
                    SendRec("20submitted");
                    DoLog(ra,to,"");
                    BeepMsg(to,ra);  (* announce the mail *)
              ELSIF rs = NoSuch
               THEN Concatenate("D8No such user: ",to,jn);
                    SendRec(jn);
                    RecvRec(jn); RecvRec(jn);
                    SendRec("20");
                    DoLog(ra,to,"No such user");
               ELSE SendRec("88Try again later");
                    RecvRec(jn); RecvRec(jn);
                    SendRec("20");
                    GetMessage(rs,jn);
                    DoLog(ra,to,jn);
               END;
             END;
END Submit;               

PROCEDURE  Pickup;

VAR     xs, ms : Stream;
        rs : Status;
        rp, to, fr, jn : ARRAY [0..133] OF CHAR;
        ch : CHAR;

BEGIN   WHILE NextMessage(ms,to,fr) DO
          SendChar('m'); SendChar(';');
          SendRec(fr);
          SendRec(to);
          RecvRec(rp);      
          SendRec("");
          IF Find("60",rp) = 0
            THEN WHILE NOT EndStream(ms) DO
                   ReadChar(ms,ch);
                   SendChar(ch);
                   END;
                 SendRec("");
                 RecvRec(rp);
                 IF Find("20",rp) = 0
                   THEN ReleaseStream(ms);
                        rp[0] := 0C;
                   ELSE CloseStream(ms);
                        Remove(rp,0,2);
                   END;
            ELSE SendRec("");
                 RecvRec(jn);   
                 Remove(rp,0,2);
                 rs := Return(xs,fr,rp);
                 IF rs = Ok
                   THEN WHILE NOT EndStream(ms) DO
                          ReadChar(ms,ch);
                          WriteChar(xs,ch);
                          END;
                        CloseStream(xs);
                        BeepMsg(fr,"Postmaster");
                   ELSE Concatenate(rp," - return failed",rp);
                   END;
                 ReleaseStream(ms);
            END;
          DoLog(fr,to,rp);
          END;
END Pickup;

PROCEDURE  DoLog( VAR f, t, e : ARRAY OF CHAR);

BEGIN   LogString("F: ");
        LogString(f);
        LogString("  T: ");
        LogString(t);
        IF e[0] <> 0C THEN
          LogString("  E: ");
          LogString(e);
          END;
        LogLn;
END DoLog;
                       
VAR     c : ARRAY [0..11] OF CHAR;

BEGIN   StartLog("$MAIL-Log");
        InitProto;
        LOOP RecvRec(c);
             IF c[0] = 'e'
               THEN Terminate;
              ELSIF c[0] = 's'
               THEN SendRec("09Ok to submit");
                    Submit;    
              ELSIF c[0] = 'p'
               THEN SendRec("09Ok to pickup");
                    Pickup;
                    SendRec("");
               ELSE LogString("Invalid command received: ");
                    LogString(c); LogLn; Terminate;
               END;
             END;
END LMDF.
