IMPLEMENTATION MODULE LogFile;  (* General appending logger ... *)

FROM R2Streams IMPORT Done, Stream, CreateStream, SetPos, WriteLine, SysErr,
                      OpenStream, CloseStream;
FROM R2TimeSubs IMPORT FormatTime;
FROM R2SysCalls IMPORT Time, Exit, Status, GetTime;
FROM R2Strings IMPORT Insert, Concatenate;
FROM R2Format IMPORT FormatCard;

VAR     logs : Stream;
        on : BOOLEAN;
        line : ARRAY [0..133] OF CHAR;

PROCEDURE  StartLog( VAR fn : ARRAY OF CHAR);

BEGIN   IF on THEN CloseStream(logs) END;
        OpenStream( logs, fn, TRUE);
        IF NOT Done THEN CreateStream(logs,fn) END;
        IF NOT Done THEN Exit(SysErr) END;
        SetPos(logs,0FFFFFFFFH);
        on := TRUE;
END StartLog;

PROCEDURE  LogString( VAR s : ARRAY OF CHAR);

BEGIN   IF NOT on THEN RETURN END;
        Concatenate(line,s,line);
END LogString;

PROCEDURE  LogCard( c : CARDINAL);

VAR     s : ARRAY [0..15] OF CHAR;

BEGIN   FormatCard(c,10,1,s);
        LogString(s);
END LogCard;

PROCEDURE  LogLn;

VAR     s : ARRAY [0..39] OF CHAR;
        t : Time;
        rs : Status;

BEGIN   IF NOT on THEN RETURN END;
        Insert("  ",line,0);
        rs := GetTime(t);
        FormatTime(t,s);
        Insert(s,line,0);
        WriteLine(logs,line);
        line[0] := 0C;
END LogLn;

PROCEDURE  Terminate;

BEGIN   IF on THEN CloseStream(logs) END;
        Exit(Ok);
END Terminate;

BEGIN   on := FALSE;
        line[0] := 0C;
END LogFile.
