MODULE Mail;  (* KGRW Dec 1987, Mods GRG Oct, Dec 1988, Jan 1989 *)

FROM R2SysCalls IMPORT
   Status, Exit, ReadString, WriteString, WriteLn, GetCommand, Result;
FROM R2Format IMPORT
   FormatCard, ScanCard;
FROM R2NumbIO IMPORT
   WriteCard;
FROM R2Strings IMPORT
   Find, Copy, Insert, Remove, Concatenate;
FROM R2Streams IMPORT 
   Stream, Done, OpenStream, CloseStream, EndStream, ReadLine;
FROM MailParse IMPORT
   CMDList, Exec, SetDefault, UnSetDefault, AddCMD,
   Match, Component, UCopy, UCompare;
FROM MailMsg IMPORT
   MSGPtr, 
   RootMsg, MyUserName, NewMessages, OldMessages,
   ReadMsg, ExtractMsg, SendMsg, DirMsg, PurgeMsg, 
   AgeMsg, FindMsg, SystemUserName, CleanUp, InitMsgBase;

CONST
(* Display message values *)
   ToPrompt = 0;
   SubjPrompt = 1;
   FilePrompt = 2;

   NotMsgNum = 10;
   NotReading = 11;
   NotFolder = 12;
   NoMoreMsg = 13;
   MsgSent = 14;
   MsgAbort = 15;
   NoSuchUser = 16;

   MsgDeleted = 17;
   MsgUnDeleted = 18;

   CantReadDel = 20;
   CantReplyDel = 21;
   CantExtractDel = 22;
   CantForwardDel = 23;
   CantExtract = 24;

VAR
   Line, Command, temp : ARRAY [0..79] OF CHAR;
   CurMsg : MSGPtr;
   CurMsgNum, MaxMsg : CARDINAL;
   Folder : BOOLEAN;
   null : ARRAY [0..1] OF CHAR;
   cmds : CMDList;
   ExitFlag : BOOLEAN;

PROCEDURE Read;
VAR
   msgnum : CARDINAL;
BEGIN
   Component(Line,temp);
   IF temp[0]=0C THEN
      IF CurMsgNum<=MaxMsg THEN
         INC(CurMsgNum);
         FindMsg(1,Folder,CurMsg);
         END;
   ELSIF ScanCard(temp,10,msgnum) AND (msgnum<=MaxMsg) THEN
      CurMsg := RootMsg;
      CurMsgNum := msgnum;
      FindMsg(msgnum,Folder,CurMsg);
   ELSE Display(NotMsgNum); RETURN END;
   IF CurMsg=NIL THEN Display(NoMoreMsg); RETURN END;
   IF CurMsg^.Del THEN Display(CantReadDel); RETURN END;
   ReadMsg(CurMsg);
END Read;

PROCEDURE Reply;
BEGIN
   IF (CurMsg=NIL) OR (CurMsg=RootMsg) THEN Display(NotReading); RETURN END;
   IF CurMsg^.Del THEN Display(CantReplyDel); RETURN END;
   Display(ToPrompt);
   WriteString( CurMsg^.From ); WriteLn;
   Display(SubjPrompt);
   IF Match( CurMsg^.Subj, "RE: *") THEN
      Copy(CurMsg^.Subj,temp);
   ELSE
      Concatenate("RE: ",CurMsg^.Subj,temp)
      END;
   WriteString(temp); WriteLn;
   SendMsg(MyUserName,CurMsg^.From,temp,null,FALSE);
END Reply;

PROCEDURE Extract;
VAR
   num : CARDINAL;
   append : BOOLEAN;
BEGIN
   IF (CurMsg=NIL) OR (CurMsg=RootMsg) THEN Display(NotReading); RETURN END;
   IF CurMsg^.Del THEN Display(CantExtractDel); RETURN END;
   append := Match(Line,"*/A~PPEND");
   Component(Line,temp);
   IF append THEN
      num := Find(temp,"/A");
      temp[num] := 0C;
      END;
   IF NOT ExtractMsg(CurMsg,temp,append) THEN
      Display(CantExtract);
      RETURN;
      END;
   IF CurMsgNum<=MaxMsg THEN
      INC(CurMsgNum);
      FindMsg(1,Folder,CurMsg);
      END;
END Extract;

PROCEDURE ExitMail;
BEGIN
   PurgeMsg;
   AgeMsg;
   ExitFlag := TRUE;
END ExitMail;

PROCEDURE Quit;
BEGIN
   AgeMsg;
   ExitFlag := TRUE;
END Quit;

PROCEDURE DeleteMsg( del : BOOLEAN );
VAR
   msgnum : CARDINAL;
BEGIN
   Component(Line,temp);
   IF (temp[0]=0C) THEN
      IF CurMsg=NIL THEN Display(NoMoreMsg); RETURN END;
      IF CurMsg=RootMsg THEN Display(NotReading); RETURN END;
      CurMsg^.Del := del;
   ELSIF ScanCard(temp,10,msgnum) THEN
      IF msgnum > MaxMsg THEN Display(NotMsgNum); RETURN END;
      CurMsg := RootMsg;
      CurMsgNum := msgnum;
      FindMsg(msgnum,Folder,CurMsg);
      IF CurMsg<>NIL THEN CurMsg^.Del := del END;
   ELSE
      Display(NotMsgNum); RETURN; END;
   IF del THEN Display(MsgDeleted) ELSE Display(MsgUnDeleted) END;
END DeleteMsg;

PROCEDURE Delete;
BEGIN
   DeleteMsg(TRUE);
END Delete;

PROCEDURE UnDelete;
BEGIN
   DeleteMsg(FALSE);
END UnDelete;

PROCEDURE Dir;
BEGIN
   Component(Line,temp);
   IF Match(temp, "N~EWMAIL") THEN
      IF NOT Folder THEN AgeMsg END;
      Folder := TRUE;
      MaxMsg := NewMessages;
   ELSIF Match(temp, "M~AIL") OR Match(temp, "O~LDMAIL") THEN
      IF Folder THEN AgeMsg END;
      Folder := FALSE;
      MaxMsg := OldMessages;
   ELSIF temp[0]<>0C THEN
      Display(NotFolder); RETURN;
      END;
   CurMsgNum := 0;
   CurMsg := RootMsg;
   DirMsg(Folder);
END Dir;

PROCEDURE Select;
BEGIN
   AgeMsg;
   InitMsgBase;
   IF NewMessages>0 THEN 
      Folder := TRUE;
      MaxMsg := NewMessages;
   ELSE
      Folder := FALSE;
      MaxMsg := OldMessages;
      END;
   WriteCard(MaxMsg,1); WriteString(" messages selected."); WriteLn;
   CurMsgNum := 0;
   CurMsg := RootMsg;
END Select;

PROCEDURE Purge;
BEGIN
   PurgeMsg;
   AgeMsg;
   IF Folder THEN MaxMsg := NewMessages ELSE MaxMsg := OldMessages END;
   CurMsgNum := 0;
   CurMsg := RootMsg;
END Purge;

PROCEDURE Send;
VAR
   file, to, nto : ARRAY [0..79] OF CHAR;
   i : CARDINAL;
   ask, first : BOOLEAN;
BEGIN
   temp[0] := 0C;
   Component( Line, file );
   IF file[0] <> 0C THEN Component(Line,temp); END;
   ask := temp[0] = 0C;
   IF ask THEN
      Display(ToPrompt);
      ReadString(temp);
      END;
   i := 0; WHILE (i<HIGH(Line)) AND (Line[0]=' ') DO INC(i) END;
   Remove(Line,0,i);
   IF ask THEN
      Display(SubjPrompt);
      ReadString(Line);
      END;
   i := 0;
   WHILE (i <= HIGH(temp)) AND (temp[i] <> 0C) DO
     IF temp[i] = ',' THEN temp[i] := ' ' END;
     INC(i);
     END;   
   first := file[0] = 0C; 
   LOOP  Component(temp,nto);
         IF nto[0] = 0C THEN EXIT END;
         IF SystemUserName(nto,to)
           THEN SendMsg( MyUserName, to, Line, file, FALSE );
                IF first THEN Copy("LASTMESSAGE",file) END;
                first := FALSE;
           ELSE WriteString("No such user: ");
                WriteString(nto);
                WriteLn;
           END;
         END;
END Send;

PROCEDURE Forward;
VAR
   to, file, nto : ARRAY [0..79] OF CHAR;
   msgnum, i : CARDINAL;
BEGIN
   IF (CurMsg=NIL) OR (CurMsg=RootMsg) THEN Display(NotReading); RETURN END;
   IF CurMsg^.Del THEN Display(CantForwardDel); RETURN END;
   Display(ToPrompt);
   ReadString(temp);
   Concatenate("$MAIL-O",CurMsg^.Stamp,file);
   IF Folder THEN file[6] := 'N' END; 
   i := 0;
   WHILE (i <= HIGH(temp)) AND (temp[i] <> 0C) DO
     IF temp[i] = ',' THEN temp[i] := ' ' END;
     INC(i);
     END;
   LOOP  Component(temp,nto);
         IF nto[0] = 0C THEN EXIT END;
         IF SystemUserName(nto,to)
           THEN SendMsg( MyUserName, to,CurMsg^.Subj, file, TRUE )
           ELSE WriteString("No such user: ");
                WriteString(nto);
                WriteLn;
           END;
         END;
   IF CurMsgNum<=MaxMsg THEN
      INC(CurMsgNum);
      FindMsg(1,Folder,CurMsg);
      END;
END Forward;

PROCEDURE Help;

VAR     hs : Stream;
        ln : ARRAY [0..133] OF CHAR;

BEGIN   OpenStream(hs,"$MailHelp",FALSE);
        IF NOT Done THEN RETURN END;
        WHILE NOT EndStream(hs) DO
          ReadLine(hs,ln);
          WriteString(ln); WriteLn;
          END;
        CloseStream(hs);
END Help;

PROCEDURE Display( n : CARDINAL );
BEGIN
   CASE n OF
   0 : WriteString("To:      ") |
   1 : WriteString("Subject: ") |
   2 : WriteString("File:    ") |
   10: WriteString("Not a message number."); WriteLn |
   11: WriteString("You aren't reading a message."); WriteLn |
   12: WriteString("Invalid folder. Use NEW or OLD."); WriteLn |
   13: WriteString("No more messages."); WriteLn |
   14: WriteString("Message sent."); WriteLn |
   15: WriteString("Message aborted."); WriteLn |
   16: WriteString("Name not found."); WriteLn |
   17: WriteString("Message deleted."); WriteLn |
   18: WriteString("Message un-deleted."); WriteLn |
   20: WriteString("Can't read a deleted message."); WriteLn |
   21: WriteString("Can't reply to a deleted message."); WriteLn |
   22: WriteString("Can't extract a deleted message."); WriteLn |
   23: WriteString("Can't forward a deleted message."); WriteLn |
   24: WriteString("Can't create extract file"); WriteLn;
   ELSE WriteString("bad Display argument"); WriteLn;
   END;
END Display;

PROCEDURE InitParser;
VAR
   rs : Status;
BEGIN
   rs := SetDefault(PROC(Read),cmds);
   rs := AddCMD( "A~NSWER", PROC(Reply),cmds);
   rs := AddCMD( "REP~LY", PROC(Reply),cmds);
   rs := AddCMD( "Q~UIT", PROC(Quit),cmds);
   rs := AddCMD( "PUR~GE", PROC(Purge),cmds);
   rs := AddCMD( "DE~LETE", PROC(Delete),cmds);
   rs := AddCMD( "UND~ELETE", PROC(UnDelete),cmds);
   rs := AddCMD( "DI~RECTORY", PROC(Dir),cmds);
   rs := AddCMD( "SEL~ECT", PROC(Select),cmds);
   rs := AddCMD( "M~AIL", PROC(Send),cmds);
   rs := AddCMD( "S~END", PROC(Send),cmds);
   rs := AddCMD( "F~ORWARD", PROC(Forward),cmds);
   rs := AddCMD( "R~EAD", PROC(Read),cmds);
   rs := AddCMD( "H~ELP", PROC(Help),cmds);
   rs := AddCMD( "EXT~RACT", PROC(Extract),cmds);
   rs := AddCMD( "EX~IT", PROC(ExitMail),cmds);
END InitParser;

PROCEDURE InitVars;
BEGIN
   ExitFlag := FALSE;
   null[0] := 0C;
   cmds := CMDList(NIL);
   IF NewMessages>0 THEN
      Folder := TRUE;
      MaxMsg := NewMessages;
   ELSE
      Folder := FALSE;
      MaxMsg := OldMessages;
      END;
   CurMsg := RootMsg;
   CurMsgNum := 0;
END InitVars;

VAR
   num : CARDINAL; (* dummy parameter for ScanCard *)
BEGIN
   InitVars;
   GetCommand(Line);  (* is this the file send mode ? *)
   IF Line[0] <> 0C THEN
     Send;
     CleanUp;
     Exit(Ok);
     END;
   InitParser;
   IF NewMessages>0 THEN
      WriteString("You have ");
      WriteCard(NewMessages,1);
      WriteString(" new mail message"); 
      IF NewMessages > 1 THEN WriteString("s.") ELSE WriteString(". ") END;
      WriteLn;
      END;
   REPEAT
      Copy("M > ",Line);
      IF Folder THEN Line[0] := 'N' END;
      IF (CurMsg<>NIL) AND CurMsg^.Del THEN Line[0] := 'D' END;
      IF CurMsgNum <= MaxMsg THEN
         FormatCard(CurMsgNum,10,3,Command)
      ELSE
         Copy("end",Command);
         END;
      Insert(Command,Line,2);
      WriteString(Line);
      ReadString(Line);
      IF Result() <> Ok THEN Copy("EXIT",Line) END;
      Component(Line,Command);
      IF ScanCard(Command,10,num) THEN
         Copy(Command,Line);
         Read;
      ELSIF NOT Exec(Command,cmds) THEN
         WriteString("Invalid command."); WriteLn;
         END;
   UNTIL ExitFlag;
   CleanUp;
   Exit(Ok);
END Mail.
