IMPLEMENTATION MODULE MailDates;  (* KGRW 1987 *)

FROM SYSTEM IMPORT ADDRESS;
FROM R2SysCalls IMPORT Status, Time, GetTime, WriteString, WriteLn;
FROM R2Format IMPORT FormatCard, FormatAddr;
FROM R2Strings IMPORT Copy, Concatenate, Length, Insert;
FROM R2TimeSubs IMPORT FormatTime;
FROM DayOfWeek IMPORT DOW;

CONST   TimeZone = "EST";   (* for now *)

PROCEDURE MakeNewStamp( VAR to, ds : ARRAY OF CHAR );
VAR     tmp : ARRAY [0..5] OF CHAR;
        t : Time;
        i : CARDINAL;
        adr : ADDRESS;
        rs : Status;
BEGIN
   IF HIGH(ds) < 19 THEN RETURN END;
   tmp[0] := 'N';
   tmp[1] := 0C;
   Concatenate( tmp, to, ds );
   ds[9] := 0C; (* truncate 'to' to 8 characters *)
   tmp[0] := '.';
   Insert( tmp, ds, Length(ds) );
   rs := GetTime( t );
   FormatCard( t.day, 16, 4, tmp );
   Insert( tmp, ds, Length(ds) );
   adr := ADDRESS(t.min);
   adr := adr*4096+ADDRESS(t.csec);
   FormatAddr( adr, 16, 6, tmp );
   Insert( tmp, ds, Length(ds) );
   i := 0;                             
   FOR i := 0 TO 19 DO IF ds[i]=' ' THEN ds[i] := '0' END; END;
END MakeNewStamp;

PROCEDURE MakeDate( VAR d : ARRAY OF CHAR );
VAR
   day, tmp : ARRAY [0..39] OF CHAR;
   t : Time;
   rs : Status;
BEGIN
   rs := GetTime(t);
   FormatTime( t, tmp );
   tmp[2] := ' '; tmp[6] := ' '; (* blank out the hyphens *)
   DOW(t,day);
   Insert(',  ',day,3);
   Insert(TimeZone,day,6);
   Insert(tmp,day,5);
   Copy(day,d);
END MakeDate;

END MailDates.
