IMPLEMENTATION MODULE MailMsg;

FROM SYSTEM IMPORT
   WORD, ADDRESS;
FROM R2SysCalls IMPORT
   Status, Process, Handle, ModeBits, FileMode, ReadString, Result, 
   Write, WriteString, WriteLn, Rename, Delete, GetCommand, GetMessage,
   Translate, CreateLogical, DeleteLogical, GetPID, GetUser, SetUser,
   Open, Create, Close, GetMode, SetMode, Execute, Exit, Read;
FROM R2Storage IMPORT
   ALLOCATE, DEALLOCATE;
FROM R2Strings IMPORT
   Compare, Concatenate, Insert, Copy, Substring, Remove, Length;
FROM R2Streams IMPORT
   Stream, Done, SysErr, OpenStream, CreateStream, CloseStream, EndStream,
   ReleaseStream, ReadLine, WriteLine, SetPos;
FROM R2Directories IMPORT
   FullName, NName, SetWild, NextWild;
FROM R2Format IMPORT
   FormatCard, ScanCard;
FROM MailDates IMPORT
   MakeNewStamp, MakeDate;
FROM MailParse IMPORT
   Match, UCompare, Component, UCopy;
FROM OptionFile IMPORT 
   SetOptionFile, GetStrOption;
FROM R2NumbIO IMPORT WriteCard;
FROM R2NewCalls IMPORT WriteMessage, GetName;
FROM LockSync IMPORT LockWait, LockClear;

CONST
   PASSWORD = "$SysDisk-PASSWORDS.SYS";
   pwlck = "passwords.lock";
   LASTMESSAGE = "$HOME-LASTMESSAGE";
VAR
   MyTerminal, MyUID : CARDINAL;
   MyPID : Process;
   exd : Stream; (* extract destination stream *)
   At : ARRAY [0..1] OF CHAR; (* "@" *)
   Mailer, Local : ARRAY [0..79] OF CHAR; 

PROCEDURE ReadMsg( msg : MSGPtr );
VAR
   tmpfnm1, tmpfnm2 : ARRAY [0..25] OF CHAR;
   line : ARRAY [0..79] OF CHAR;
   s : Stream; rs : Status;
   ch : CHAR;
   lc : CARDINAL;
BEGIN
   IF msg=NIL THEN RETURN END;
   WITH msg^ DO
      IF Del THEN RETURN END;
      Concatenate("$MAIL-N",Stamp,tmpfnm1);
      IF NOT New THEN tmpfnm1[6] := 'O' END;
      END;

   OpenStream(s,tmpfnm1,FALSE);
   IF NOT Done THEN RETURN END;
   lc := 0;
   LOOP
      IF EndStream(s) THEN EXIT END;
      IF lc = 22 THEN
        WriteString("-- <space> for more, <ctrl-z> or <esc> to quit --");
        Read(ch,TRUE);
        lc := 0;
        Write(15C);
        WriteString("                                                 ");
        Write(15C);
        IF (ch = 32C) OR (ch = 33C) THEN EXIT END;
        END;
      INC(lc);
      ReadLine(s,line);
      WriteString(line);
      WriteLn;
      END;
   WriteLn;

   CloseStream(s);
   msg^.WasRead := TRUE;
END ReadMsg;

PROCEDURE ExtractMsg(msg : MSGPtr; VAR file : ARRAY OF CHAR;
                     append : BOOLEAN) : BOOLEAN;
VAR
   tmpfnm1, tmpfnm2 : ARRAY [0..25] OF CHAR;
   line : ARRAY [0..79] OF CHAR;
   s : Stream;        
   h : Handle;
   rs : Status;
   newfile : BOOLEAN;
BEGIN
   IF msg=NIL THEN RETURN FALSE END;
   WITH msg^ DO
      IF Del THEN RETURN FALSE END;
      Concatenate("$MAIL-N",Stamp,tmpfnm1);
      IF NOT New THEN tmpfnm1[6] := 'O' END;
      END;
   OpenStream(s,tmpfnm1,FALSE);
   IF NOT append THEN
      rs := SetUser(MyPID,MyUID);
      CreateStream(exd,file);
      rs := SetUser(MyPID,0);
      IF NOT Done THEN RETURN FALSE END;
   ELSE
      OpenStream(exd,file,TRUE);
      IF Done 
           THEN SetPos(exd,0FFFFFFFFH);
           ELSE CreateStream(exd,file);          
                IF NOT Done THEN RETURN FALSE END;
           END;
      END;
   WHILE NOT EndStream(s) DO ReadLine(s,line); WriteLine(exd,line); END;
   CloseStream(s);
   CloseStream(exd);
   rs := Open(file,TRUE,h);
   rs := SetMode(h,FileMode{ORd,OWr,ODe},MyUID);
   rs := Close(h,TRUE);
   RETURN TRUE;
END ExtractMsg;

PROCEDURE SendMsg( VAR From, To, Subj, File : ARRAY OF CHAR; fwd : BOOLEAN );
VAR
   tmpfnm, line, tFrom : ARRAY [0..79] OF CHAR;
   h : Handle;
   rs, Krs : Status;

PROCEDURE PutHeader( d : Stream; VAR from, to, subj : ARRAY OF CHAR );
BEGIN
   Concatenate("To:      ",to,line);
   WriteLine(d,line);
   Concatenate("From:    ",from,line);
   WriteLine(d,line);
   MakeDate(line); Insert("Date:    ",line,0);
   WriteLine(d,line);
   Concatenate("Subject: ",subj,line);
   WriteLine(d,line);
END PutHeader;

PROCEDURE Edit( s : Stream ) : Status;
VAR
   rs : Status;
BEGIN
   LOOP
      WriteString(
   "Type <CTRL-Z> when completed, or type <ESC> to edit/abort.");
      WriteLn;
      LOOP
         ReadString(line);
         rs := Result();
         WriteLine(s,line);
         IF rs<>Ok THEN EXIT END;
         END;
      IF rs<>Ok THEN RETURN rs END;
      END;
END Edit;

PROCEDURE SendMsgWork;
VAR
   Kproc : Process; KAdr : ADDRESS;
   s : Stream;
BEGIN
   IF Match(File,"LAST~MESSAGE") THEN Copy(LASTMESSAGE,File) END;
   IF (File[0]=0C) THEN
      rs := Translate(LASTMESSAGE,tmpfnm);
      CreateStream(s,tmpfnm);
      LOOP
         rs := Edit(s);
         IF rs=EscKey THEN
            LOOP
               WriteLn;
               WriteString("Options: Abort, Edit, Continue (A,E,C): ");
               ReadString(line);
               CASE CAP(line[0]) OF
                  'A': ReleaseStream(s);
                       WriteString("Message aborted."); WriteLn;
                       RETURN |
                  'E': CloseStream(s);
                       IF (Translate("$EDIT",line)=Ok) AND
                         (Execute(line,tmpfnm,"$HOME",MyTerminal,MyUID,
                          TRUE,TRUE,FALSE,Kproc,Krs,KAdr)=Ok) THEN
                          rs := Ok; RETURN END;
                       WriteString("The editor is not available.");
                       WriteLn;
                       OpenStream(s,tmpfnm,TRUE);
                       SetPos(s,0FFFFFFFFH);
                       EXIT |
                  'C': EXIT;
                  ELSE EXIT 
                  END;
               END;
         ELSIF rs=EndFile THEN
            CloseStream(s);
            rs := Ok; EXIT;
            END;
         END;
   ELSE 
     Copy(File,tmpfnm);
     OpenStream(s,File,FALSE);
     IF NOT Done THEN 
       rs := NoPriv;
       WriteString("Cannot access file to send");
       WriteLn;
       RETURN;
       END;
     CloseStream(s);
   END;
   rs := Ok;
END SendMsgWork;

PROCEDURE CopyMsgWork;
VAR
   stamp : ARRAY [0..19] OF CHAR;
   line : ARRAY [0..79] OF CHAR;
   s,d : Stream;
BEGIN
   (* copy the file *)
   OpenStream(s,tmpfnm,FALSE);
   IF NOT Done THEN
      RETURN END;

   (* don't need the name of the source file anymore - tmpfnm is reuseable *)

   IF FindAt(To) 
     THEN MakeNewStamp(Mailer,stamp);
     ELSE MakeNewStamp(To,stamp);
     END;
   Concatenate("$MAIL-",stamp,tmpfnm);
   CreateStream(d,tmpfnm);
   IF NOT Done THEN CloseStream(s); 
      RETURN END;

   PutHeader(d,tFrom,To,Subj); (* to be replaced by WriteHeader *)
   line[0] := 0C; WriteLine(d,line);

   WHILE NOT EndStream(s) DO ReadLine(s,line); WriteLine(d,line); END;
   CloseStream(d);
   CloseStream(s);
END CopyMsgWork;

VAR
   temp : ARRAY [0..79] OF CHAR;
BEGIN (* SendMsg *)

   IF FindAt(To) THEN
      Concatenate(From,At,tFrom);
      Insert(Local,tFrom,Length(tFrom));
   ELSE
      Copy( From,tFrom );
      END;

   IF NOT fwd THEN Krs := SetUser(MyPID,MyUID) END;
   SendMsgWork; (* Do the work as MyUID *)
   Krs := SetUser(MyPID,0);
   IF rs<>Ok THEN RETURN END; 
   CopyMsgWork;
   (* tmpfnm is set in CopyMsgWork to the name of the message file *)
   rs := Open(tmpfnm,TRUE,h);
   rs := SetMode(h,FileMode{ORd,ODe},0);
   rs := Close(h,TRUE);
   IF NOT FindAt(To) THEN BeepMsg(To,From) END;
END SendMsg; 

PROCEDURE  BeepMsg( VAR to, from : ARRAY OF CHAR);

VAR     ms : ARRAY [0..79] OF CHAR; 
        x : Status;

BEGIN   ms[0] := 15C; ms[1] := 12C; ms[2] := 7C;
        ms[3] := 15C; ms[4] := 12C; ms[5] := 0C;
        Insert(from,ms,3);
        Insert("New mail from ",ms,3);
        x := WriteMessage(to,ms);
END BeepMsg;

PROCEDURE DirMsg( new : BOOLEAN );
VAR
   p : MSGPtr;
   n : CARDINAL;
BEGIN
   n := 0;
   p := RootMsg^.Next;
   WHILE p<>NIL DO
      IF (p^.New AND new) OR NOT (p^.New OR new) THEN
         INC(n);
         WriteDirEntry(p,n);
         END;
      p := p^.Next;
      END;
END DirMsg;

PROCEDURE AgeMsg;
VAR
   p, q, r : MSGPtr;
   tmpfnm1, tmpfnm2 : ARRAY [0..25] OF CHAR;
   rs : Status;
BEGIN
   q := RootMsg;
   p := RootMsg^.Next;
   NewMessages := 0;
   OldMessages := 0;
   WHILE p<>NIL DO
      WITH p^ DO
         IF WasRead THEN
            IF New THEN
               Concatenate("$MAIL-N",Stamp,tmpfnm1);
               Concatenate("$MAIL-O",Stamp,tmpfnm2);
               rs := Rename(tmpfnm1,tmpfnm2);
               New := FALSE;
               END;
            INC(OldMessages);
         ELSE
            INC(NewMessages);
            END;
         q := p; p := Next;
         END;
      END;
END AgeMsg;

PROCEDURE PurgeMsg;
VAR
   p, q, r : MSGPtr;
   tmpfnm1, tmpfnm2 : ARRAY [0..25] OF CHAR;
   rs : Status;
BEGIN
   q := RootMsg;
   p := RootMsg^.Next;
   NewMessages := 0;
   OldMessages := 0;
   WHILE p<>NIL DO
      WITH p^ DO
         IF Del THEN
            Concatenate("$MAIL-O",Stamp,tmpfnm1);
            IF New THEN tmpfnm1[6] := 'N' END;
            rs := Delete(tmpfnm1);
            r := p; p := Next;
            q^.Next := p;
            DISPOSE(r);
         ELSE
            q := p; p := Next;
            END;
         END;
      END;
END PurgeMsg;

PROCEDURE FindMsg( msgnum : CARDINAL; new : BOOLEAN; VAR p : MSGPtr );
VAR
   i : CARDINAL;
BEGIN
   i := 0;
   IF p=NIL THEN RETURN END;
   LOOP
      p := p^.Next;
      IF p=NIL THEN RETURN END;
      IF (p^.New AND new) OR NOT (p^.New OR new) THEN INC(i) END;
      IF i=msgnum THEN RETURN END;
      END;
END FindMsg;

PROCEDURE FindAt( VAR s : ARRAY OF CHAR ) : BOOLEAN;
VAR
   i : CARDINAL;
BEGIN
   i := 0;
   WHILE (i<HIGH(s)) AND (s[i]<>0C) AND (s[i]<>'@') DO INC(i) END;
   RETURN s[i]='@';
END FindAt;

PROCEDURE SystemUserName( VAR namein, nameout : ARRAY OF CHAR ) : BOOLEAN;
VAR
   rs : Status;
   s : Stream;
   found : BOOLEAN;
   temp : ARRAY [0..5] OF CHAR;
   line : ARRAY [0..79] OF CHAR;
BEGIN
   IF FindAt(namein) THEN
      Copy(namein,nameout);
      RETURN TRUE;
      END;     
   IF NOT LockWait(pwlck,30) THEN RETURN FALSE END; (* ? what else to do ? *)
   OpenStream(s,PASSWORD,FALSE);
   IF NOT Done THEN Exit(SysErr) END;
   LOOP
      IF EndStream(s) THEN nameout[0] := 0C; found := FALSE; EXIT END;
      ReadLine(s,line);
      Component(line,nameout);
      IF UCompare(namein,nameout)=0 THEN found := TRUE; EXIT END;
      END;
   CloseStream(s);
   LockClear(pwlck);
   RETURN found;
END SystemUserName;

PROCEDURE CleanUp;
VAR
   rs : Status;
BEGIN

   (* delete the message work file *)
   OpenStream(exd,LASTMESSAGE,FALSE);
   IF Done THEN
      CloseStream(exd);
      rs := Delete(LASTMESSAGE);
      END;

END CleanUp;

PROCEDURE InitMsgBase;
VAR
   p : MSGPtr;
   s : ARRAY [0..79] OF CHAR;
   rs : Status;
BEGIN
   p := NIL; NewMessages := 0; OldMessages := 0;
   IF RootMsg=NIL THEN
      NEW(RootMsg); IF RootMsg=NIL THEN Exit(NoHeap) END;
      WITH RootMsg^ DO (* make up some data for the root node *)
         Copy("InitCode", From );
         Copy(MyUserName, To );
         MakeDate(s);
         Copy(s, Date);
         Copy("Never display this!", Subj);
         New := FALSE;
         WasRead := FALSE;
         Del := FALSE;
         Next := NIL;
         Copy("NOBODY.0000000000", Stamp);
         END;
      END;
   UCopy("$MAIL-?.*",s);
   Insert(MyUserName,s,Length(s)-2);
   rs := SetWild(s);
   LOOP
      rs := NextWild();
      IF rs<>Ok THEN EXIT END;
      NEW(p); IF p=NIL THEN Exit(NoHeap) END;
      WITH p^ DO
         GetHeader(FullName,From,To,Subj,Date);
         Substring(NName,Stamp,1,Length(NName)-1);
         New := NName[0]='N';
         Next := NIL;
         IF New THEN
            WasRead := FALSE;
            INC(NewMessages);
         ELSE
            WasRead := TRUE;
            INC(OldMessages)
            END;
         Del := FALSE;
         END;
      InsertMsg(p,RootMsg^.Next);
      END;
END InitMsgBase;

PROCEDURE InsertMsg( VAR p : MSGPtr; VAR root : MSGPtr );
VAR
   q, r : MSGPtr;
   i : INTEGER;
BEGIN
   IF root=NIL THEN root := p; RETURN; END; (* paranoia strikes deep! *)
   q := NIL;
   r := root;
   LOOP
      IF r=NIL THEN q^.Next := p; RETURN END;
      i := UCompare(r^.Stamp,p^.Stamp);
      IF i=0 THEN
         DISPOSE(p);
         RETURN;
      ELSIF i>0 THEN
         p^.Next := r;
         IF q=NIL THEN root := p ELSE q^.Next := p END;
         RETURN;
      ELSE
         q := r;
         r := r^.Next;
         END;
      END;
END InsertMsg;

PROCEDURE GetHeader( VAR file, from, to, subj, date : ARRAY OF CHAR );
VAR
   s : Stream;
   temp : ARRAY [0..79] OF CHAR;
   field : ARRAY [0..5] OF CHAR;
BEGIN
   from[0] := 0C; to[0] := 0C; date[0] := 0C; subj[0] := 0C;
   OpenStream(s,file,FALSE);
   LOOP
      IF EndStream(s) THEN EXIT END;
      ReadLine(s,temp);
      Component(temp,field);
      IF field[0] = 0C THEN EXIT END;
      IF (to[0]=0C) AND Match(field,"TO:*") THEN
         Copy(temp,to)
      ELSIF (from[0]=0C) AND Match(field,"FROM:*") THEN
         Copy(temp,from)
      ELSIF (date[0]=0C) AND Match(field,"DATE:*") THEN
         Copy(temp,date)
      ELSIF (subj[0]=0C) AND Match(field,"SUBJ*") THEN
         Copy(temp,subj)
         END;
      END;
   CloseStream(s);
END GetHeader;

(* work procedure for DIRECTORY *)
PROCEDURE WriteDirEntry( p : MSGPtr; num : CARDINAL );
CONST
   blanks = "                                        ";
VAR
   temp : ARRAY [0..39] OF CHAR;
BEGIN
   IF p=NIL THEN RETURN END;
   WITH p^ DO
        IF Del THEN Write('D') ELSE Write(' ') END;
        WriteCard(num,3);  WriteString("  ");
        Concatenate(From,blanks,temp);
        Remove(temp,25,40);
        WriteString(temp); WriteString("  ");
        Copy(Date,temp);
        Remove(temp,11,40);
        WriteString(temp); WriteString("  ");
        IF Length(Subj) > 32 
          THEN Copy(Subj,temp);
               Remove(temp,32,40);
               WriteString(temp);
          ELSE WriteString(Subj);
          END;
        WriteLn;
      END;
END WriteDirEntry;

VAR
   i : CARDINAL;
   temp: ARRAY [0..79] OF CHAR;
   h : Handle;
   rs : Status;
   b : BOOLEAN;

BEGIN
   At[0] := '@';
   At[1] := 0C;

   (* Who am i? *)
   rs := GetPID(MyPID);
   rs := GetUser(MyPID,MyUID);
(*   GetCommand(MyUserName); *)
   rs := GetName(MyPID,MyUserName);

   rs := SetUser(MyPID,0); (* switch to user 0 for the rest *)

   rs := DeleteLogical("MAIL");

   b := SetOptionFile("$MAIL-Config");
   b := GetStrOption("Mailer",Mailer);
   b := GetStrOption("Local",Local);

   (* Where am i? *)
   rs := Translate("$TI",temp);
   MyTerminal := ORD(temp[2])-48;

   (* start up the message data base *)
   RootMsg := NIL;
   InitMsgBase;
END MailMsg.
