IMPLEMENTATION MODULE TimedRead;  (* Read with timeout *)

FROM R2SysCalls IMPORT Sleep, Ticks, Result, Status;
IMPORT R2SysCalls;
FROM R2NewCalls IMPORT UpTime, AttachTerminal, DetachTerminal;

PROCEDURE  Read( VAR ch : CHAR; tmo : Ticks) : Status;

VAR    rs : Status;
       ot, nt : Ticks;

BEGIN  UpTime(ot);
       LOOP  R2SysCalls.Read(ch,FALSE);
             IF Result() = Ok
               THEN RETURN Ok;
               ELSE UpTime(nt);
                    IF nt >= ot+tmo THEN RETURN TimedOut END;
                    AttachTerminal;
                    rs := Sleep(tmo-(nt-ot));
                    DetachTerminal;
               END;
             END;
END Read;   

PROCEDURE  ReadPacket( VAR p : ARRAY OF CHAR; tmo : Ticks) : Status;

VAR     i : CARDINAL;
        ch : CHAR;
        r : Status;

BEGIN   i := 0;
        LOOP  r := Read(ch,tmo);
              IF r <> Ok THEN RETURN r END;
              IF (i < HIGH(p)) AND (ch >= ' ') AND (ch <= '~') THEN
                p[i] := ch;
                INC(i);
                END;
              IF ch = 12C THEN
                p[i] := 0C;
                RETURN Ok;
                END;
              END;
END ReadPacket;

END TimedRead.
