IMPLEMENTATION MODULE Rand2;

FROM SYSTEM IMPORT ADDRESS;

(* This module uses the additive generator invented by Mitchell and Moore
   as described in Vol 3 of Knuth (p27).
*)

(*$T-*)

VAR     j, k : CARDINAL;
        y : ARRAY [1..55] OF ADDRESS;

PROCEDURE  RandAddr() : ADDRESS;

VAR     r : ADDRESS;

BEGIN   r := y[k] + y[j];
        y[k] := r;
        DEC(j); IF j = 0 THEN j := 55 END;
        DEC(k); IF k = 0 THEN k := 55 END;
        RETURN r;
END RandAddr;     

PROCEDURE  Rand() : REAL;   (* in the interval 0..1 *)

VAR     x, y, z : ADDRESS;
        r, d, d2 : REAL;

BEGIN   x := RandAddr();
        d := FLOAT(256);
        d := d*d;
        d2 := d*d;
        y := x MOD 65536; z := x DIV 65536;
        r := FLOAT(CARDINAL(y))/d + FLOAT(CARDINAL(z))/d2;
        RETURN r
END Rand;

PROCEDURE  Start( seed : CARDINAL);

VAR     i : CARDINAL;
        a, b, c : ADDRESS;

BEGIN   a := 123456789;  b := 24689753 + ADDRESS(seed);
        FOR i := 1 TO 55 DO
          c := b + a;
          y[(21*i) MOD 55] := c;
          a := b; b := c;
          END;
        j := 24; k := 55;
        a := RandAddr();
        a := RandAddr();
        a := RandAddr();
END Start;

BEGIN   Start(0);
END Rand2.
