IMPLEMENTATION MODULE RealIO;

FROM R2SysCalls IMPORT ReadString, WriteString;

(* From "Modula-2 Software Components", original routines by R.S. Wiener *)

            PROCEDURE num
                      (     ch  : CHAR            (* in *) ) : BOOLEAN;

            BEGIN
              RETURN ( ORD( ch ) > 47 ) AND ( ORD( ch ) < 58 );
            END num;


            PROCEDURE strtocard
                      (     str   : ARRAY OF CHAR         (* in  *);
                        VAR c     : CARDINAL              (* out *);
                        VAR valid : BOOLEAN               (* out *) );

            VAR
                pos   : CARDINAL;
                start : CARDINAL;


              PROCEDURE valof
                        (     ch  : CHAR     (* in *) ) : CARDINAL;

              BEGIN
                IF ch = 0C
                THEN
                  RETURN 0;
                ELSE
                  IF ( ORD( ch ) >= 48 ) AND ( ORD( ch ) <= 57 )
                  THEN
                    RETURN ORD( ch ) - ORD( "0" );
                  ELSE
                    valid := FALSE;
                    RETURN 0;
                  END(* if then *);
                END(* if then *);
              END valof;


            BEGIN
              valid := TRUE;
              c := 0;
              pos := 0;
              valid := TRUE;
              (* Ignore leading blanks *)
              WHILE ( pos < HIGH ( str ) ) AND ( str[ pos ] = ' ' ) DO
                INC ( pos );
              END(* while loop *);
              start := pos;
              (* Form cardinal *)
              REPEAT
                IF NOT num( str[ pos ] )
                THEN
                  c := 0;
                  valid := FALSE;
                  RETURN;
                END(* if then *);
                c := ( c * 10 ) + valof( str[ pos ] );
                INC( pos );
              UNTIL ( pos = start + 4 ) OR ( str[ pos ] = 0C );
              IF ( pos = start + 4 ) AND ( str[ start + 4 ] # 0C )
              THEN
                IF ( c < 6553 )
                THEN
                  IF NOT num( str[ pos ] )
                  THEN
                    c := 0;
                    valid := FALSE;
                    RETURN;
                  END(* if then *);
                  c := ( c * 10 ) + valof( str[ pos ] );
                  IF str[ pos + 1 ] # 0C
                  THEN
                    c := 0;
                    valid := FALSE;
                    RETURN;
                  END(* if then *);
                ELSIF ( c = 6553 )
                THEN
                  IF ( valof( str[ pos ] ) < 6 )
                  THEN
                    IF NOT num( str[ pos ] )
                    THEN
                      c := 0;
                      valid := FALSE;
                      RETURN;
                    END(* if then *);
                    c := ( c * 10 ) + valof( str[ pos ] );
                    IF str[ pos + 1 ] # 0C
                    THEN
                      c := 0;
                      valid := FALSE;
                      RETURN;
                    END(* if then *);
                  ELSE
                    c := 0;
                    valid := FALSE;
                  END(* if then *);
                ELSE
                  c := 0;
                  valid := FALSE;
                END(* if then *)
              END(* if then *);
            END strtocard;

PROCEDURE FormatReal
                      (     r         : REAL           (* in  *);
                            digits,
                            width     : INTEGER        (* in  *);
                        VAR str       : ARRAY OF CHAR  (* out *);
                        VAR valid     : BOOLEAN        (* out *) );

            VAR
                pos, tab : CARDINAL;
                minwidth : INTEGER;
                i, exp   : INTEGER;
                realexp  : REAL;
                real     : REAL;
                sign     : CHAR;
                rplus    : BOOLEAN;


              PROCEDURE placedigit
                        ( VAR x : REAL                 (* in/out *) );

              VAR
                   int   : INTEGER;
                   whole : REAL;

              BEGIN
                int := TRUNC( x );
                str[ pos ] := CHR( CARDINAL(int) + ORD( "0" ) );
                INC( pos );
                whole := FLOAT( CARDINAL(int) );
                x := x - whole;
              END placedigit;


              PROCEDURE round
                        ( x : REAL                     (* in *) );

              VAR
                  temp : REAL;
                  last : CARDINAL;

              BEGIN
                (* initialize *)
                last := pos;
                IF NOT rplus
                THEN
                  INC( tab );
                END(* if then *);
                temp := 10.0 * ( x - FLOAT( TRUNC( x ) ) );
                (* Round down if next digit < 5 *)
                IF TRUNC( temp ) < 5
                THEN
                  placedigit( x );
                (* Round up if next digit >= 5 and this digit < 9 *)
                ELSIF TRUNC( x ) < 9
                THEN
                  str[ pos ] := CHR( CARDINAL(TRUNC( x ) + 1) + ORD( "0" ) );
                  INC( pos );
                (* Replace "9's" with "0" *)
                ELSE
                  IF NOT ( ( digits = 0 ) AND
                           ( real > 9.4 ) AND ( real < 10.0 ) )
                  THEN
                    REPEAT
                      str[ last ] := "0";
                      DEC( last );
                      IF ( str[ last ] = "." )  AND ( last # tab )
                      THEN
                        DEC( last );
                      END(* if then *);
                    UNTIL ( str[ last ] # "9" ) OR ( last = tab );
                  END(* if then *);
                  (* Round up if string position # 9 *)
                  IF ( last # tab ) OR ( str[ last ] # "9" ) AND
                     NOT ( ( digits = 0 ) AND
                           ( real > 9.4 ) AND ( real < 10.0 ) )
                  THEN
                    str[ last ] := CHR( ORD( str[ last ] )
                                 - ORD( "0" ) + ORD( "1" ) );
                  (* Change "9" to "0" and add "1" to left if
                     width > digits + sign *)
                  ELSE
                    IF ( ( rplus AND ( tab > 0 ) ) OR
                         ( NOT rplus AND ( tab > 1 ) ) ) AND
                         ( digits >= 0 )
                    THEN
                      str[ last ] := "0";
                      DEC( last );
                      str[ last ] := "1";
                      IF NOT rplus
                      THEN
                        DEC( last );
                        str[ last ] := "-";
                      END(* if then *);
                    (* Adjust string values if width < digits *)
                    ELSE
                      str[ last ] := "1";
                      IF digits < 0
                      THEN
                        INC( last );
                        str[ last ] := ".";
                        str[ pos ] := "0";
                        INC( exp );
                      ELSE
                        IF digits # 0
                        THEN
                          REPEAT
                            INC( last );
                          UNTIL str[ last ] = ".";
                          str[ last ] := "0";
                          str[ last + 1 ] := ".";
                        END(* if then *);
                        INC( pos );
                        str[ pos ] := "0";
                      END(* if then *);
                    END(* if then *);
                  END(* if then *);
                  INC( pos );
                END(* if then *);
              END round;


            BEGIN
              valid := TRUE;
              pos := 0;
              exp := 0;
              rplus := TRUE;
              IF r < 0.0
              THEN
                rplus := FALSE;
                r := -r;
              END(* if then *);
              real := r;
              IF ( real = 0.0 ) OR ( real >= 1.0 )
              THEN
                sign := "+";
              ELSE
                sign := "-";
              END(* if then *);
              IF r # 0.0
              THEN
                WHILE ( r < 1.0 ) OR ( r >= 10.0 ) DO
                  IF ( r < 1.0 )
                  THEN
                    r := r * 10.0;
                    DEC( exp );
                  ELSIF ( r >= 10.0 )
                  THEN
                    r := r / 10.0;
                    INC( exp );
                  END(* if then *);
                END(* while loop *);
              END(* if then *);
              IF ( real > 1.0E17 ) AND ( digits >= 0 )
              THEN
                digits := - digits;
              END(* if then *);
              IF digits < 0
              THEN
                minwidth := ABS( digits ) + 7;
              ELSIF digits = 0
              THEN
                IF real >= 1.0
                THEN
                  minwidth := 1 + exp;
                ELSE
                  minwidth := 1;
                END(* if then *);
              ELSE
                IF real >= 1.0
                THEN
                  minwidth := ABS( digits ) + 2 + exp;
                ELSE
                  minwidth := ABS( digits ) + 2;
                END(* if then *);
              END(* if then *);
              IF width < minwidth
              THEN
                width := minwidth;
              END(* if then *);
              IF CARDINAL( width - 1 ) > HIGH( str )
              THEN
                str[ 0 ] := 0C;
                valid := FALSE;
                RETURN;
              END(* if then *);
              tab := CARDINAL( width - minwidth );
              IF ( NOT rplus ) AND ( tab # 0 )
              THEN  (* Make room for "-" *)
                DEC( tab );
              END(* if then *);
              FOR i := 1 TO tab DO
                str[ pos ] := " ";
                INC( pos );
              END(* for loop *);
              IF NOT rplus
              THEN
                str[ pos ] := "-";
                INC( pos );
              END(* if then *);
              (* Negative digits = exponential output *)
              IF digits < 0
              THEN
                placedigit( r );
                r := r * 10.0;
                str[ pos ] := ".";
                INC( pos );
                FOR i := 1 TO ( ABS( digits ) - 1 ) DO
                  placedigit( r );
                  r := r * 10.0;
                END(* for loop *);
                round( r );
                str[ pos ] := "E";
                INC( pos );
                str[ pos ] := sign;
                INC( pos );
                realexp := FLOAT( CARDINAL(ABS( exp )) );
                IF ABS( exp ) >= 100
                THEN
                  realexp := realexp / 100.0;
                  placedigit( realexp );
                  realexp := realexp * 10.0;
                  placedigit( realexp );
                  realexp := realexp * 10.0;
                  round( realexp );
                ELSIF ABS( exp ) >= 10
                THEN
                  str[ pos ] := "0";
                  INC( pos );
                  realexp := realexp / 10.0;
                  placedigit( realexp );
                  realexp := realexp * 10.0;
                  round( realexp );
                ELSIF ABS( exp ) >= 1
                THEN
                  FOR i := 1 TO 2 DO
                    str[ pos ] := "0";
                    INC( pos );
                  END(* for loop *);
                  placedigit( realexp );
                ELSE
                  FOR i := 1 TO 3 DO
                    str[ pos ] := "0";
                    INC( pos );
                  END(* for loop *);
                END(* if then *);
              (* Positive digits = decimal output *)
              ELSE
                IF exp > 0
                THEN
                  FOR i := 1 TO exp DO
                    placedigit( r );
                    r := r * 10.0;
                  END(* for loop *);
                  IF digits = 0
                  THEN
                    round( r );
                  ELSE
                    placedigit( r );
                    r := r * 10.0;
                  END(* if then *);
                ELSIF exp = 0
                THEN
                  IF digits = 0
                  THEN
                    round( r );
                  ELSE
                    placedigit( r );
                    r := r * 10.0;
                  END(* if then *);
                ELSIF exp < 0
                THEN
                  IF digits = 0
                  THEN
                    r := r / 10.0;
                    round( r );
                  ELSE
                    str[ pos ] := "0";
                    INC( pos );
                  END(* if then *);
                END(* if then *);
                IF digits # 0
                THEN
                  str[ pos ] := ".";
                  INC( pos );
                  WHILE ( exp < -1 ) AND ( digits # 0 ) DO
                    str[ pos ] := "0";
                    INC( pos );
                    DEC( digits );
                    INC( exp );
                  END(* while loop *);
                  IF digits >= 1
                  THEN
                    FOR i := 1 TO digits - 1 DO
                      placedigit( r );
                      r := r * 10.0;
                    END(* for loop *);
                    round( r );
                  END(* if then *);
                END(* if then *);
              END(* if then *);
              IF pos < HIGH( str )
              THEN
                str[ pos ] := 0C;
              END(* if then *);
END FormatReal;

PROCEDURE ScanReal
                      (     str   : ARRAY OF CHAR   (* in  *);
                        VAR r     : REAL            (* out *);
                        VAR valid : BOOLEAN         (* out *) );


              PROCEDURE raise
                        (     power : CARDINAL      (* in *) ) : REAL;

              VAR
                  r : REAL;
                  i : CARDINAL;

              BEGIN
                r := 1.0;
                FOR i := 1 TO power DO
                  r := 10.0 * r;
                END(* for loop *);
                RETURN r;
              END raise;


              PROCEDURE chtonum
                        (     ch : CHAR             (* in *) ) : REAL;

              BEGIN
                RETURN FLOAT( ORD( ch ) - 48 );
              END chtonum;


              PROCEDURE handleexponent
                        (     i : CARDINAL          (* in *) );
              (* i is the index position in str after the e *)

              VAR
                 negexp   : BOOLEAN;
                 index    : CARDINAL;
                 exp      : ARRAY[ 0 .. 79 ] OF CHAR;
                 exponent : CARDINAL;
                 ok       : BOOLEAN;

              BEGIN
                negexp := FALSE;
                IF str[ i ] = '-'
                THEN
                  negexp := TRUE;
                  INC( i );
                ELSIF str[ i ] = '+'
                THEN
                  negexp := FALSE;
                  INC( i );
                END(* if then *);
                index := 0;
                WHILE str[ i ] # 0C DO
                  IF NOT num( str[ i ] )
                  THEN
                    r := 0.0;
                    valid := FALSE;
                    RETURN;
                  END(* if then *);
                  exp[ index ] := str[ i ];
                  INC( index );
                  INC( i );
                END(* while loop *);
                exp[ index ] := 0C;
                strtocard( exp, exponent, ok );
                IF negexp
                THEN
                  r := r / raise( exponent );
                ELSE
                  r := r * raise( exponent );
                END(* if then *);
              END handleexponent;


            VAR
               neg, nodecimal  : BOOLEAN;
               start, i, tens  : CARDINAL;
               decimalpos      : CARDINAL;
               expnodec, ok    : BOOLEAN;
               firstdec        : BOOLEAN;

            BEGIN(* strtoreal *)
              firstdec := FALSE;
              expnodec := FALSE;
              valid := TRUE;
              nodecimal := FALSE;
              neg := FALSE;
              r := 0.0;
              start := 0;
              WHILE ( str[ start ] # '-' ) AND ( NOT num( str[ start ] ) ) AND
                    ( str[ start ] # 0C ) AND ( str[ start ] # '.') DO
                INC( start );
              END(* while loop *);
              IF str[ start ] = '.'
              THEN
                decimalpos := start;
                firstdec := TRUE;
              ELSIF str[ start ] = 0C
              THEN
                valid := FALSE;
                r := 0.0;
                RETURN;
              ELSIF str[ start ] = '-'
              THEN
                neg := TRUE;
                INC( start );
                decimalpos := start + 1;
              ELSE
                decimalpos := start + 1;
              END(* if then *);
              WHILE ( str[ decimalpos ] # '.' ) AND
                    ( str[ decimalpos ] # 0C ) AND
                    ( str[ decimalpos ] # 'e' ) AND
                    ( str[ decimalpos ] # 'E' ) DO
                INC( decimalpos );
              END(* while loop *);
              IF str[ decimalpos ] = 0C
              THEN
                nodecimal := TRUE;
              ELSIF ( str[ decimalpos ] = 'e' ) OR
                    ( str[ decimalpos ] = 'E' )
              THEN
                expnodec := TRUE;
              END(* if then *);
              IF NOT firstdec
              THEN
                tens := decimalpos - start;
                FOR i := start TO decimalpos - 1 DO
                  IF NOT num( str[ i ] )
                  THEN
                    r := 0.0;
                    valid := FALSE;
                    RETURN;
                  END(* if then *);
                  DEC( tens );
                  r := r + raise( tens ) * chtonum( str[ i ] );
                END(* for loop *);
                IF expnodec
                THEN
                  handleexponent( decimalpos + 1 );
                  IF ok
                  THEN
                    IF neg
                    THEN
                      r := -r;
                    END(* if then *);
                  END(* if then *);
                  RETURN;
                END(* if then *);
              END(* if then *);
              IF NOT nodecimal
              THEN
                i := decimalpos + 1;
                WHILE ( str[ i ] # 'e' ) AND ( str[ i ] # 'E' ) AND
                      ( str[ i ] # 0C ) DO
                  IF NOT num( str[ i ] )
                  THEN
                    r := 0.0;
                    valid := FALSE;
                    RETURN;
                  END(* if then *);
                  r := r + 1.0 / raise( i - decimalpos ) *
                          chtonum( str[ i ] );
                  INC( i );
                END(* while loop *);
                INC( i );
                IF str[ i - 1 ] # 0C
                THEN
                  (* An e or E is found *)
                  handleexponent( i );
                  IF NOT valid
                  THEN
                    RETURN;
                  END(* if then *);
                END(* if then *);
              END(* if then *);
              IF neg
              THEN
                r := -r;
              END(* if then *);
END ScanReal;

PROCEDURE  ReadReal( VAR r : REAL);

VAR     s : ARRAY [0..39] OF CHAR;
        v : BOOLEAN;

BEGIN   LOOP ReadString(s);
             ScanReal(s,r,v);
             IF v THEN EXIT END;
             WriteString("Try again: ");
             END;
END ReadReal;

PROCEDURE  WriteFixed( r : REAL; wid, prec : CARDINAL);

VAR     s : ARRAY [0..133] OF CHAR;
        v : BOOLEAN;

BEGIN   FormatReal(r,INTEGER(prec),INTEGER(wid),s,v);
        WriteString(s);
END WriteFixed;

PROCEDURE  WriteFloat( r : REAL; wid, prec : CARDINAL);

VAR     s : ARRAY [0..133] OF CHAR;
        v : BOOLEAN;

BEGIN   FormatReal(r,(-1)*INTEGER(prec),INTEGER(wid),s,v);
        WriteString(s);
END WriteFloat;

END RealIO.
