MODULE DayTime;  

FROM SYSTEM       IMPORT ADDRESS;
FROM R2SysCalls   IMPORT WriteString, WriteLn, GetCommand, Write;
                  IMPORT R2SysCalls;
FROM R2NewerCalls IMPORT Status, IPAddr, SetUDPPort, Send, Receive, Port;
FROM R2NetSubs    IMPORT ScanIPAddr, WriteIPAddr;
FROM DNS          IMPORT Resolve, RESULT, GetMessage;
FROM R2Strings    IMPORT Length;

VAR
  len    : CARDINAL;
  rs     : R2SysCalls.Status;
  rt     : Status;
  ds     : RESULT;
  port   : Port;
  string : ARRAY[0..50] OF CHAR;
  data   : ARRAY[0..100] OF CHAR;

(*Print out an error message*)

PROCEDURE Error(str:ARRAY OF CHAR);
BEGIN                    
  WriteLn;
  WriteString(str);
  WriteLn;
END Error;
                                                                  
(*Resolve the IP number for this host if at all possible*)

PROCEDURE GetParam(VAR IP:IPAddr) : BOOLEAN;
VAR
  resolver:ARRAY[0..50] OF CHAR;
BEGIN
  IF (Length(string)=0) THEN
      Error('Usage: DayTime server ');
      RETURN FALSE;
  END(*IF*);
  IF (NOT ScanIPAddr(string,IP)) THEN
    ds:=Resolve(string,IP,resolver);
    IF ds<>NoError THEN
      GetMessage(string,ds);
      Error(string);
      RETURN FALSE;
    END(*IF*);
  END(*IF*);                 
  RETURN TRUE;   
END GetParam;

(*Obtain the time from the host*)

PROCEDURE DoDayTime( IP : IPAddr );
BEGIN 
  Write('[');      
  WriteIPAddr(IP,1);
  Write(']'); WriteLn;    
  rt:=SetUDPPort(3001);                (*This port number is ignored by UDP*)
  rt:=Send(string,11,13,IP);
  rt:=Receive(data,len,500,port,IP);
  data[len] := 0C;                     (*Ensure string is terminated by 0C*)
  WriteString(data);
  WriteLn;
  rt:=SetUDPPort(0);                   (*Close the opened port*)
END DoDayTime;

VAR
  IP : IPAddr;

BEGIN
  string[0]:=0C;
  GetCommand(string);                  (*Get string from command line*)
  IF GetParam(IP) THEN                 (*Get its IP address if possible*)
    DoDayTime(IP);                     (*Get time from other host*)
  END(*IF*);
END DayTime.

