MODULE Finger;
FROM R2SysCalls   IMPORT GetCommand,WriteString,WriteLn,Write;
FROM R2Strings    IMPORT Remove,Length,Insert;
FROM R2NumbIO     IMPORT WriteCard;
FROM R2NewerCalls IMPORT SocHandle,TCPRead,TCPWrite,TCPOpen,Status,
                         GetMessage,IPAddr,TCPClose;
FROM DNS          IMPORT Resolve, RESULT;
IMPORT DNS;
FROM R2NetSubs    IMPORT ScanIPAddr;
              
CONST
  FingPort=79;
VAR
  name,data,resolver,str:ARRAY[0..50] OF CHAR;
  ds:RESULT;
  ipNum, ResolverIP:IPAddr;
  soc:SocHandle;
  j,len,nameLeng,strLeng:CARDINAL;
                          
(* This procedure will open a port and allow us to obtain information on
   a user or set of users on a remote machine. *)

PROCEDURE FClient();
VAR
  rs:Status;
  i:CARDINAL;
BEGIN
  rs:=TCPOpen(FingPort,ipNum,soc);            (* Establish a connection to a *)
  IF rs=Ok THEN                               (* remote host *)
    i:=Length(name);
    rs:=TCPWrite(soc,name,i);                 (* send any information *)
    WHILE TCPRead(soc,data,len,TRUE)=Ok DO    (* wait for response *)
      IF len=0 THEN 
        WriteString('TCP ERROR');WriteLn;
      ELSE
        FOR i:=0 TO len-1 DO                  (* Write out all the data *)
          IF data[i]=CHR(13) THEN             (* Make sure the end of a line *)
             Write(CHR(13));                  (* ends with a CR-LF *)
             Write(CHR(10));
             IF (i<len-1) AND (data[i+1]=CHR(10)) THEN
                 INC(i);
             END(*IF*);  
          ELSIF data[i]=CHR(10) THEN
             Write(CHR(13));
             Write(CHR(10));
             IF (i<len-1) AND (data[i+1]=CHR(13)) THEN
                 INC(i);
             END(*IF*);  
          ELSE
            Write(data[i]); 
          END(*IF*);
        END(*FOR*); 
      END(*IF*);                          
    END(*WHILE*);                                   
    rs:=TCPClose(soc);                              (* Close connection *)
  ELSE
    GetMessage(rs,str);                             (* Error, get message *)
    WriteString(str);WriteLn;
  END(*IF*);
END FClient;

BEGIN
  name[0]:=15C;
  name[1]:=12C;
  name[2]:=0C;
  GetCommand(str); 
  j:=0;
  IF str[0]<>'@' THEN
    j:=0;       
    strLeng:=Length(str);
    nameLeng:=HIGH(name);
    WHILE (j<=nameLeng) AND (j<=strLeng)  AND (str[j]<>'@') DO
      data[j]:=str[j];
      INC(j);
    END(*WHILE*);
    data[j]:=0C;
    Insert(data,name,0);
    Remove(str,0,j);
  END(*IF*);
  IF str[0]='@' THEN
    Remove(str,0,1); 
    ds:=NoError;
    IF (NOT ScanIPAddr(str,ipNum)) THEN
      ds:=Resolve(str,ipNum,resolver,ResolverIP);
    END(*IF*);
    Write('[');              
    WriteString(str);  
    Write(']');WriteLn;
    IF ds=NoError THEN
      FClient();
    ELSE
      DNS.GetMessage(str,ds);
      WriteString(str);WriteLn;
    END(*IF*);
  ELSE
    WriteString('USAGE');WriteLn;
    WriteString('Finger [userid]@server');WriteLn;
  END(*IF*);
END Finger.                                                       

