MODULE NetStats;

FROM R2NewerCalls IMPORT Qquery, ArpStats, IPStats, GlobalStats, ICMPStats,
                         TCPStats;
FROM R2SysCalls IMPORT WriteString, WriteLn, Status, Sleep;
FROM R2NumbIO IMPORT WriteCard,WriteAddr;
FROM SYSTEM IMPORT ADDRESS;
FROM TIO IMPORT Cls, CurPos, Bold, Normal, Reverse, UnderLine;


CONST
  c1 = 2;
  c2 = 22;
  c3 = 42;
  c4 = 62;
  MaxStrSz = 9;                  

VAR first : BOOLEAN;

PROCEDURE WrHdr( r, c : CARDINAL; s : ARRAY OF CHAR );
  BEGIN
    IF NOT first THEN RETURN; END;
    CurPos(r,1);
    UnderLine;
    WriteString(s);
    Normal;
  END WrHdr;

PROCEDURE WrC( r, c : CARDINAL; s : ARRAY OF CHAR; n : CARDINAL );
  BEGIN                 
    IF first THEN
      CurPos(r,c);
      WriteString(s);
      CurPos(r,c + MaxStrSz);
      WriteString(' : ');
    ELSE
      CurPos(r,c + MaxStrSz+3);
    END; (* IF *)
    WriteCard(n,1);
  END WrC;

PROCEDURE WrA( r, c : CARDINAL; s : ARRAY OF CHAR; a : ADDRESS );
  BEGIN
    IF first THEN
      CurPos(r,c);
      WriteString(s);
      CurPos(r,c + MaxStrSz);
      WriteString(' : ');
    ELSE
      CurPos(r,c + MaxStrSz+3);
    END; (* IF *)
    WriteAddr(a,10,1);
  END WrA;

PROCEDURE Packets;
  VAR
    tp,sp : CARDINAL;
  BEGIN
    Qquery(tp,sp);
    WrHdr(3,c1,'Packets');
    WrC(3,c2,'ttl pkts',tp);
    WrC(3,c3,'stck pkts',sp);
  END Packets;

PROCEDURE IP;
  VAR
    bp, pnr, wt ,wd ,bv: CARDINAL;
    psl, psg, pr : ADDRESS;
  BEGIN
    IPStats( bp, pnr, wt, wd, bv, psl, psg, pr );
    WrHdr(5,c1,'IP');
    WrA(5,c2,'rcvd pkts',pr);
    WrC(5,c3,'bchk pkts',bp);
    WrC(5,c4,'bad proto',pnr);
    WrA(6,c1,'snt local',psl);
    WrA(6,c2,'snt gate',psg);
    bv := bv + wd + wt;
    WrC(6,c3,'bad v/d/t',bv);
  END IP;

PROCEDURE ARP;
  VAR
    rsp, req, cn, pd, tp : CARDINAL;
    ps : ADDRESS;
  BEGIN
    ArpStats( rsp, req, cn, pd, tp, ps );
    WrHdr(8,c1,'Arp');
    WrC(8,c2,'Our MAC?',rsp);
    WrC(8,c3,'Their MAC?',req);
    WrC(8,c4,'cache sz',cn);
    WrC(9,c2,'pkts garb',pd);
    WrC(9,c3,'ttl pkts',tp);
    WrA(9,c1,'pkts sent',ps);
  END ARP;

PROCEDURE ICMP;
  VAR
    echo,other,bad: CARDINAL;
  BEGIN
    ICMPStats( echo, other, bad);
    WrHdr(11,c1,'ICMP');
    WrC(11,c2,'bad',bad);
    WrC(11,c3,'other',other);
    WrC(11,c4,'echo',echo);
  END ICMP;

PROCEDURE UDP;
  VAR
    mp, cp, np, bc : CARDINAL;
    pq, ps, pr : ADDRESS;
  BEGIN
    GlobalStats( mp, cp, np, bc, pq, ps, pr );
    WrHdr(13,c1,'UDP');
    WrC(13,c2,'max prts',mp);
    WrC(13,c3,'cur prts',cp);
    WrC(13,c4,'no port',np);
    WrC(14,c1,'bad chk',bc);
    WrA(14,c2,'qd pkts',pq);
    WrA(14,c3,'pkts snt',ps);
    WrA(14,c4,'pkts rcv',pr);
  END UDP;

PROCEDURE TCP;
  VAR
    InSegs, PassOpen, Outs, EstResets, CurrEst,
    AttFails, RetranSegs, OutSegs : ADDRESS;
  BEGIN
    TCPStats( InSegs, PassOpen, Outs, EstResets, CurrEst, AttFails,
              RetranSegs, OutSegs );
    WrHdr(16,c1,'TCP');
    WrA(16,c2,'in pkts',InSegs);
    WrA(16,c3,'p opens',PassOpen);
    WrA(16,c4,'out pkts',Outs);
    WrA(17,c1,'est rsts',EstResets);
    WrA(17,c2,'cur est',CurrEst);
    WrA(17,c3,'att fls',AttFails);
    WrA(17,c4,'rxmts',RetranSegs);
    WrA(18,c1,'out sgs',OutSegs);
  END TCP;
        
VAR
  rs : Status;
BEGIN            
  first := TRUE;
  Cls;
  WrHdr(1,c1,"Net Stats");
  LOOP
   Packets;
   IP;
   ARP;
   ICMP;
   UDP;
   TCP;
   CurPos(24,80);
   rs := Sleep(200);
   first := FALSE;
  END;
END NetStats.
