IMPLEMENTATION MODULE OptionFile;

(* A mechanism for getting option settings from a file *)

FROM R2Streams IMPORT Done, OpenStream, Stream, CloseStream, 
                      ReadLine, EndStream;
FROM R2Storage IMPORT ALLOCATE, DEALLOCATE;
FROM R2Strings IMPORT Substring, Find, Length;
FROM R2Format IMPORT ScanCard;

TYPE    opptr = POINTER TO opnode;
        opnode = RECORD s : ARRAY [0..133] OF CHAR;
                        nx : opptr;
                 END;

VAR     oplist : opptr;

PROCEDURE  SetOptionFile( VAR fn : ARRAY OF CHAR) : BOOLEAN;

VAR     ops : Stream;
        p : opptr;

BEGIN   OpenStream(ops,fn,FALSE);
        IF NOT Done THEN RETURN FALSE END;
        WHILE NOT EndStream(ops) DO
          NEW(p);
          ReadLine(ops,p^.s);
          p^.nx := oplist;
          oplist := p;
          END;
        CloseStream(ops);
        RETURN TRUE;
END SetOptionFile;

PROCEDURE  GetCardOption( VAR opt : ARRAY OF CHAR; VAR c : CARDINAL) : BOOLEAN;

VAR     s : ARRAY [0..133] OF CHAR;

BEGIN   IF NOT GetStrOption(opt,s) THEN RETURN FALSE END;
        RETURN ScanCard(s,10,c);
END GetCardOption;

PROCEDURE  GetStrOption( VAR opt, str : ARRAY OF CHAR) : BOOLEAN;

VAR     p : opptr;

BEGIN   p := oplist;
        WHILE p <> NIL DO
          IF Find(opt,p^.s) = 0 THEN
            Substring(p^.s,str,Length(opt)+1,133);
            RETURN TRUE;
            END;
          p := p^.nx;
          END;
        RETURN FALSE;
END GetStrOption;

BEGIN   oplist := NIL;
END OptionFile.
