MODULE R2Config;
FROM OptionFile   IMPORT SetOptionFile,GetCardOption,GetStrOption;
FROM R2NetSubs    IMPORT ScanIPAddr;
FROM R2NewerCalls IMPORT IPAddr, NetConfig,Status,GetMessage;
FROM SYSTEM       IMPORT ADDRESS;
FROM R2SysCalls   IMPORT WriteString,WriteLn;

CONST
  shift8=100H;
  shift16=10000H;

VAR 
  b:BOOLEAN;
  str,ODName,serverN1,serverN2,netmask:ARRAY[0..50] OF CHAR;
  servIP1,servIP2,gateIP,hostIP:ARRAY[0..20] OF CHAR;
  SIPNum1,SIPNum2,IPgate,IPhost,Netmask:IPAddr;
  gate,host:ARRAY[0..3] OF CHAR;                      
  rs:Status;
(*This procedure changes an IP number into a string of characters*)

PROCEDURE IPString(IPnum:IPAddr;VAR IPstr:ARRAY OF CHAR);
VAR
  ipnum1,ipnum2:CARDINAL;
BEGIN         
  ipnum1:=CARDINAL(IPnum DIV shift16);
  ipnum2:=CARDINAL(IPnum MOD shift16);
  IPstr[0]:=CHR(ipnum1 DIV shift8);
  IPstr[1]:=CHR(ipnum1 MOD shift8);
  IPstr[2]:=CHR(ipnum2 DIV shift8);
  IPstr[3]:=CHR(ipnum2 MOD shift8);
END IPString;

BEGIN      
  b:=SetOptionFile("N2Con");
  b:=GetStrOption("OurDName",ODName);       (*obtaining information from*)
  b:=GetStrOption("DNSServN1",serverN1);       (*a file*)
  b:=GetStrOption("DNSServN2",serverN2);
  b:=GetStrOption("DNSServ1",servIP1);
  b:=GetStrOption("DNSServ2",servIP2);
  b:=ScanIPAddr(servIP1,SIPNum1);
  b:=ScanIPAddr(servIP2,SIPNum2);
  b:=GetStrOption("GateIP",gateIP);
  b:=ScanIPAddr(gateIP,IPgate);  
  IPString(IPgate,gate);
  b:=GetStrOption("HostIP",hostIP);
  b:=ScanIPAddr(hostIP,IPhost);
  IPString(IPhost,host);    
  b:=GetStrOption("NetMask",netmask);  
  b:=ScanIPAddr(netmask,Netmask);                      

(*changes the network variables in the operating system to the values
   read in from the file*)

  rs:=NetConfig(host,gate,ODName,serverN1,serverN2,SIPNum1,SIPNum2,
                                            Netmask);
  IF rs<>Ok THEN
    GetMessage(rs,str);
    WriteString(str);WriteLn;
  END
END R2Config.
