IMPLEMENTATION MODULE R2NetSubs;
                              
FROM R2SysCalls IMPORT ReadString, WriteString;
FROM R2Strings IMPORT Insert, Length, Substring;
FROM R2Format IMPORT ScanAddr, FormatCard;          
FROM R2NewerCalls IMPORT IPAddr;
FROM SYSTEM IMPORT ADDRESS;

PROCEDURE FormatIPAddr( ip : IPAddr; digs : CARDINAL; VAR s : ARRAY OF CHAR );
  VAR
    i,j,c,cnt,len : CARDINAL;
    str           : ARRAY [0..79] OF CHAR;
    t             : ARRAY [0..2] OF CHAR;
  BEGIN 
    i := 0;
    cnt := 0;
    LOOP
      c := CARDINAL( ip MOD 100H );
      FormatCard( c, 10, 1, t );
      len := Length(t);
      j := len;
      REPEAT
        str[i+len-j] := t[j-1];
        DEC(j);
      UNTIL j = 0;
      i := i + Length(t);
      INC(cnt);    
      IF cnt = 4 THEN EXIT; END;
      str[i] := '.';
      INC(i);
      ip := ip DIV 100H;
    END; (* FOR *)                     
    IF digs > 79 THEN digs := 79; END;
    IF digs > i THEN 
      DEC(digs,i);
    ELSE
      digs := 0;
    END; (* IF *)                               
    FOR c := 1 TO digs DO 
      str[i] := ' ';
      INC(i);
    END; (* FOR *)
    IF i > HIGH(s) + 1 THEN i := HIGH(s) + 1; END;
    FOR c := 0 TO i - 1 DO s[c] := str[i-1-c]; END;
    IF i <= HIGH(s) THEN s[i] := 0C; END;
  END FormatIPAddr;                                                    

PROCEDURE ScanIPAddr( VAR s : ARRAY OF CHAR; VAR ip : IPAddr ) : BOOLEAN;
  VAR
   i,j,k,len  : CARDINAL;        
   a          : ADDRESS;
   t          : ARRAY [0..2] OF CHAR;
  BEGIN            
    i := 0;                      
    ip := 0;
    WHILE (i <= HIGH(s)) AND (s[i] = ' ') DO INC(i); END;
    FOR k := 1 TO 3 DO
      j := i + 1;
      WHILE (j <= HIGH(s)) AND (s[j] <> '.') DO INC(j); END;
      len := j - i;
      IF (len = 0) OR (len > 3) THEN RETURN FALSE; END;
      Substring(s,t,i,len);
      IF (NOT ScanAddr(t,10,a)) OR (a > 255) THEN RETURN FALSE; END;
      ip := IPAddr(a) + ip * 100H;
      i := j + 1;
    END; (* FOR *)   
    j := i + 1;
    WHILE (j <= HIGH(s)) AND (s[j] <> 0C) AND (s[j] <> ' ') DO INC(j); END;
    len := j - i;
    IF (len = 0) OR (len > 3) THEN RETURN FALSE; END;
    Substring(s,t,i,len);
    IF NOT ScanAddr(t,10,a) THEN RETURN FALSE; END;
    ip := IPAddr(a) + ip * 100H;
    RETURN TRUE;
  END ScanIPAddr;

PROCEDURE WriteIPAddr( ip : IPAddr; w : CARDINAL );
  VAR
    str : ARRAY [0..79] OF CHAR;
  BEGIN
    FormatIPAddr(ip,w,str);
    WriteString(str);
  END WriteIPAddr;
                
PROCEDURE ReadIPAddr( VAR ip : IPAddr );
  VAR
    str : ARRAY [0..79] OF CHAR;
  BEGIN         
    LOOP 
      ReadString(str);
      IF NOT ScanIPAddr(str,ip) THEN
        WriteString('Try again: ');
      ELSE
        EXIT;
      END;
    END; (* LOOP *)
  END ReadIPAddr;

BEGIN                                    
END R2NetSubs.
