MODULE TCBINFO;
FROM R2NewerCalls IMPORT TCBInfo, TCB, SocHandle, Status, GetMessage,
                         TCBState,OutState;
FROM TIO IMPORT CurPos, Cls, Normal, UnderLine, Blink, Bold, Reverse;
FROM R2SysCalls IMPORT WriteLn, WriteString,Sleep;
IMPORT R2SysCalls;
FROM R2NumbIO IMPORT ReadCard;
FROM R2Format IMPORT FormatAddr, FormatCard;
FROM SYSTEM   IMPORT ADDRESS, ADR;
FROM R2NetSubs IMPORT FormatIPAddr;
FROM R2SysCalls IMPORT Write;
CONST        
  maxOff=20;
  col1=2;
  col2=40;

TYPE
  tcbPtr = POINTER TO TCB;
  sPtr   = POINTER TO Str;
  Str    = ARRAY[0..123] OF CHAR;
VAR                              
  s     : sPtr;
  t     : tcbPtr;
  rb,sb,str,z : Str;
  soc   : SocHandle;
  ls    : R2SysCalls.Status;        
  rs    : Status;
  first : BOOLEAN;
  temp  : CARDINAL;
                                          
                
PROCEDURE Pad( VAR s : ARRAY OF CHAR );
  VAR
    i : CARDINAL;
  BEGIN         
    i := 0;
    WHILE s[i] <> 0C DO INC(i); END;
    WHILE i < 14 DO s[i] := ' '; INC(i); END;
    s[i] := 0C;
  END Pad;

PROCEDURE WriteAddr( a : ADDRESS );
  BEGIN       
    FormatAddr( a, 10, 1, z );
    Pad(z);
    WriteString(z);
  END WriteAddr;
                                  
PROCEDURE WriteCard( c : CARDINAL );
  BEGIN           
    FormatCard( c, 10, 1, z );
    Pad(z);
    WriteString(z);
  END WriteCard;

PROCEDURE WrHdr(x,y:CARDINAL; s:ARRAY OF CHAR);
BEGIN
  CurPos(x,y);
  UnderLine;
  WriteString(s);
  Normal;
END WrHdr;

PROCEDURE WrS( x,y: CARDINAL; str, str2:ARRAY OF CHAR);
BEGIN
  CurPos(x,y);
  WriteString(str);
  CurPos(x,y+maxOff);
  WriteString(' : ');
  WriteString(str2);
END WrS;

PROCEDURE WrA( x,y: CARDINAL;str:ARRAY OF CHAR; a:ADDRESS);
BEGIN
IF first THEN
  CurPos(x,y);
  WriteString(str);
  CurPos(x,y+maxOff); 
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);       
  WriteAddr(a);
END WrA;  

PROCEDURE WrC( x,y: CARDINAL; s : ARRAY OF CHAR; c:CARDINAL);
BEGIN               
IF first THEN
  CurPos(x,y);                                 
  WriteString(s); 
  CurPos(x,y+maxOff);
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);
  WriteCard(c);
END WrC;

PROCEDURE WrIP( x,y: CARDINAL; s : ARRAY OF CHAR; a:ADDRESS);
BEGIN               
IF first THEN
  CurPos(x,y);                                 
  WriteString(s); 
  CurPos(x,y+maxOff);
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);
  FormatIPAddr(a,1,z);
  Pad(z);
  WriteString(z);
END WrIP;

PROCEDURE WrB( x,y: CARDINAL; s : ARRAY OF CHAR; bool:BOOLEAN);
BEGIN
IF first THEN
  CurPos(x,y);      
  WriteString(s);
  CurPos(x,y+maxOff);
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);
  IF bool THEN
    WriteString('TRUE ');
  ELSE
    WriteString('FALSE');
  END(*IF*);
END WrB;                                

PROCEDURE WrStat(x,y:CARDINAL;s:ARRAY OF CHAR;state:Status);
VAR
  str:ARRAY[0..20] OF CHAR;
BEGIN
IF first THEN
  CurPos(x,y);
  WriteString(s);
  CurPos(x,y+maxOff);
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);
  GetMessage(state,str);
  WriteString(str);
END WrStat;                                  

PROCEDURE WrTcbStat(x,y:CARDINAL;s:ARRAY OF CHAR;state:TCBState);
BEGIN    
IF first THEN
  CurPos(x,y);
  WriteString(s);
  CurPos(x,y+maxOff);
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);
  CASE state OF
     CLOSED:      WriteString('CLOSED      ');      |
     LISTEN:      WriteString('LISTEN      ');      |
     SYNSENT:     WriteString('SYNSENT     ');      |
     SYNRCVD:     WriteString('SYNRCVD     ');      |
     ESTABLISHED: WriteString('ESTABLISHED ');      |
     FINWAIT1:    WriteString('FINWAIT1    ');      |
     FINWAIT2:    WriteString('FINWAIT2    ');      |
     CLOSEWAIT:   WriteString('CLOSEWAIT   ');      |
     LASTACK:     WriteString('LASTACK     ');      |
     CLOSING:     WriteString('CLOSING     ');      |
     TIMEWAIT:    WriteString('TIMEWAIT    ');
  ELSE
     WriteString('BAD STATE');
  END(*CASE*);
END WrTcbStat;                                  

PROCEDURE WrBuff( x,y : CARDINAL; rcv : BOOLEAN; s : ARRAY OF CHAR );
VAR
  i : CARDINAL;
BEGIN
IF first THEN
  CurPos(x,y);
  IF rcv THEN
    WriteString('rBuff');
  ELSE
    WriteString('sBuff');
  END;
  CurPos(x,y+maxOff);
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);
FOR i := 0 TO 49 DO
  IF (s[i] > CHR(31)) AND (s[i] < CHR(127)) THEN
    Write(s[i]);
  ELSE
    Write('_');
  END; (* IF *)
END; (* FOR *)
END WrBuff;

PROCEDURE WrTcbOutS(x,y:CARDINAL;s:ARRAY OF CHAR;state:OutState);
BEGIN    
IF first THEN
  CurPos(x,y);
  WriteString(s);
  CurPos(x,y+maxOff);
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);
  CASE state OF
     IDLE:         WriteString('IDLE       ');      |
     PERSIST:      WriteString('PERSIST    ');      |
     TRANSMIT:     WriteString('TRANSMIT   ');      |
     RETRANSMIT:   WriteString('RETRANSMIT '); 
  ELSE
     WriteString('Bad out State');
  END(*CASE*);
END WrTcbOutS;                                  
                  
PROCEDURE WrSt(x,y:CARDINAL; s:ARRAY OF CHAR; state : Status);
BEGIN    
IF first THEN
  CurPos(x,y);
  WriteString(s);
  CurPos(x,y+maxOff);
  WriteString(' : ');
ELSE
  CurPos(x,y+maxOff+3);
END(*IF*);
  CASE state OF
     Ok:          WriteString('Ok      ');      |
     BadTCB:      WriteString('BadTCB  ');      |
     NoTCB:       WriteString('NoTCB   ');      |
     FReset:      WriteString('FReset  ');      |
     FRefusal:    WriteString('FRefusal');      |
     LReset:      WriteString('LReset  '); 
  ELSE
     WriteString('Bad State');
  END(*CASE*);
END WrSt;                                      

PROCEDURE DisplayTCB();
BEGIN               
  WITH t^ DO
    WrC(2,col1,'Process id',pid);
    WrSt(2,col2,'Current Status',status);
    WrC(3,col1,'Soc number',soc);
    WrTcbStat(3,col2,'tcbState',tcbState);
    WrB(4,col1,'needOut',flags.needOut);
    WrTcbOutS(4,col2,'tcbOutState',outState);
    WrB(5,col1,'firstSend',flags.firstSend);
    WrB(5,col2,'ocBlocked',ocBlocked);
    WrB(6,col1,'rcvdFin',flags.rcvdFin);
    WrB(6,col2,'rdBlocked',rdBlocked);
    WrB(7,col1,'rcvDone',flags.rcvDone);
    WrB(7,col2,'wrBlocked',wrBlocked);
    WrB(8,col1,'sendFin',flags.sendFin);
    WrB(8,col2,'attached',attached);
    WrB(9,col1,'sendDone',flags.sendDone);
    WrC(9,col2,'Local Port',locPort);
    WrB(10,col1,'tcbCode.ack',tcbCode.ack);
    WrC(10,col2,'Foreign Port',forPort);
    WrB(11,col1,'tcbCode.reset',tcbCode.reset);
    WrIP(11,col2,'Foreign Host',forHost);
    WrB(12,col1,'tcbCode.syn',tcbCode.syn);
    WrA(12,col2,'sendUnAck',sendUnAck);
    WrB(13,col1,'tcbCode.fin',tcbCode.fin);
    WrA(13,col2,'sendNext',sendNext);
    WrA(14,col1,'lastWinSeq',lastWinSeq);
    WrA(14,col2,'sendLast',sendLast);
    WrA(15,col1,'lastWinAck',lastWinAck);
    WrC(15,col2,'slowStartThresh',slowStartThresh);
    WrC(16,col1,'sendWinSz',sendWinSz);
    WrA(16,col2,'initSendSeq',initSendSeq);
    WrC(17,col1,'congWinSz',congWinSz);
    WrC(17,col2,'Retransmit count',retransCnt);
    WrA(18,col1,'Receive next',rcvNext);
    WrA(18,col2,'Retrans TMO',retransTmoVal);
    WrA(19,col1,'Fin seq num',finSeq);
    WrA(19,col2,'Win seq num',winSeq);
    WrC(20,col1,'Receive buff pos',rcvBuffPos);
    WrC(20,col2,'Send buff pos',sendBuffPos);
    WrC(21,col1,'Receive buff count',rcvBuffCnt);
    WrC(21,col2,'Send buff count',sendBuffCnt);
    WrA(22,col1,'Smooth rtt',smoothRndTripTime);
    WrA(22,col2,'Rtt dev. est.',rndTripDevEst);
    WrBuff( 23, col1, TRUE, rb );
    WrBuff( 24, col1, FALSE, sb );
  END(*WITH*); 
END DisplayTCB;                 

VAR
  csoc,
  pos : CARDINAL;

BEGIN                             
  first:=TRUE; 
  WriteString('Please enter soc handle-->');
  ReadCard(csoc);WriteLn;
  soc := SocHandle(csoc);
  Cls();
  WrHdr(1,col1,'TCB information');
LOOP
  rs:=TCBInfo( soc, str, sb, rb );
  IF rs = Ok THEN
    s := ADR(str);
    t := tcbPtr(s);                          
    DisplayTCB(); 
  ELSE        
    Cls(); 
    WrHdr(1,col1,'...no tcb');
    EXIT;
  END(*IF*);
  first:=FALSE;
  CurPos(24,80);
  ls:=Sleep(200);
END(*LOOP*)
END TCBINFO.  
