MODULE Telnet;
FROM TelOpts IMPORT IAC, DONT, DOIT, WONT, WILL, RDont, RDo, RWill, RWont,
                    SDo, SDont, SWill, SWont, Echo, SuppressGA, RegisterSoc;
FROM R2NewCalls IMPORT AttachTerminal;
FROM DNS IMPORT Resolve,RESULT;
FROM R2SysCalls IMPORT GetCommand, WriteString, WriteLn, Sleep, Read, Result,
                       Write;
FROM TIO IMPORT Cls;
FROM R2NewerCalls IMPORT TCPOpen, TCPWrite, TCPRead, TCPClose, TCPAttach,
                         GetMessage, TCPDetach, Port, SocHandle, Status,
                         IPAddr;
IMPORT R2SysCalls;
FROM R2NetSubs IMPORT WriteIPAddr, ScanIPAddr;
FROM R2Strings IMPORT Compress;
FROM R2NumbIO IMPORT WriteCard;

CONST
  forPort = 23;
  tmo     = 3000;
  CR      = 15C;
  LF      = 12C;
VAR
  pos,len:CARDINAL;
  s:ARRAY[0..2048] OF CHAR;
  Fiac,Fcmnd,OptMode:BOOLEAN;
  forHost : IPAddr;
  port : Port;                      
  soc  : SocHandle;
  t1 : ARRAY [0..30] OF CHAR;

PROCEDURE DoOpt();
VAR
  cmnd, opt:CHAR;
BEGIN
  IF NOT Fiac THEN
    INC(pos);
    Fiac:=TRUE;
  END(*IF*);
  IF (pos<len) AND NOT Fcmnd THEN
     cmnd:=s[pos];
     INC(pos);
     Fcmnd:=TRUE;
  END(*IF*);                                   
  
  IF (pos<len) AND Fcmnd THEN
    IF ( ORD(cmnd) > 250 ) AND ( cmnd <> IAC ) THEN
      opt:=s[pos];
      INC(pos);
      CASE cmnd OF
        DONT : RDont(opt);        |
        DOIT : RDo(opt);          |
        WONT : RWont(opt);        |
        WILL : RWill(opt);
        ELSE;
      END(*CASE*);         
    END; (* IF *)
     OptMode:=FALSE;
     Fiac:=FALSE;
     Fcmnd:=FALSE;
   END(*IF*);
END DoOpt;
     
PROCEDURE Wr( ch : CHAR );
  BEGIN                 
    IF ( ch = CHR(8)) OR (ch=CHR(9)) OR (ch=CHR(13)) OR (ch=CHR(10)) OR
       (( ch > CHR(31)) AND (ch<CHR(127))) THEN
       Write(ch);
    END;
  END Wr;

PROCEDURE Process();
VAR 
 ch:CHAR;
BEGIN
  LOOP
    IF NOT RdCh(ch) THEN RETURN END;
    Wr(ch);
  END(*LOOP*);
END Process;

PROCEDURE RdCh( VAR ch:CHAR):BOOLEAN;
BEGIN
  IF pos<len THEN
    OptMode:=(s[pos]=IAC) OR OptMode;
    IF OptMode THEN
       DoOpt();
       RETURN RdCh(ch);
    END(*IF*);
    ch:=s[pos];
    INC(pos);
    RETURN TRUE;
  ELSE    
    pos:=0;
    RETURN FALSE;
  END(*IF*);
END RdCh;

PROCEDURE SetUp(): BOOLEAN;
VAR                                                   
  xp : IPAddr;
  rs:Status;
  t, t2: ARRAY[0..30] OF CHAR;
BEGIN    
  GetCommand(t);
  Compress(t);
  IF t[1]=0C THEN                             
     WriteLn;
     WriteString('Usage: TELNET host');WriteLn;
     RETURN FALSE;
  END(*IF*);
  IF ( NOT ScanIPAddr( t, forHost )) AND 
                          ( Resolve( t, forHost, t2, xp )<> NoError) THEN
     WriteLn;
     WriteString('INVALID HOST ADDRESS/NAME');WriteLn;
     RETURN FALSE;
  END(*IF*);
  rs:=TCPOpen(forPort,forHost,soc);
  IF rs<>Ok THEN
     GetMessage(rs,t);
     WriteString(t);WriteLn;
     RETURN FALSE;
  ELSE   
     AttachTerminal;
     rs:=TCPAttach(soc);
     RegisterSoc(soc);
  END(*IF*);
  RETURN TRUE;
END SetUp;                     

PROCEDURE InitIt();
BEGIN
  t1[0] := CR;
  t1[1] := LF;
  t1[2] := 0C;
  Fiac:=FALSE;
  Fcmnd:=FALSE;
  OptMode:=FALSE;
  pos:=0;
  SDo( Echo );
  SDo( SuppressGA );  
  SWont( Echo );
  SWill( SuppressGA );
END InitIt;
                 
VAR
  l2rs:R2SysCalls.Status;
  n2res:Status;
  t:ARRAY[0..500] OF CHAR;
  m : ARRAY[0..30]OF CHAR;  
  i : CARDINAL;
BEGIN (*MAIN*)
  IF SetUp() THEN
    InitIt();
    LOOP
      l2rs:=Sleep(tmo);
      i:=0; 
      Read(t[i],FALSE);
      WHILE Result()=R2SysCalls.Ok DO
        IF t[i] = CR THEN
          INC(i);
          t[i]:=LF;
        END(*IF*);
        INC(i);  
        Read(t[i],FALSE);
      END(*WHILE*);
      n2res:=TCPWrite(soc,t,i);
      n2res:=TCPRead(soc,s,len,FALSE);
      IF n2res <> Ok THEN EXIT; END;
      Process();
    END(*LOOP*);
  END(*IF*);                       
  n2res := TCPClose( soc );
END Telnet.
