IMPLEMENTATION MODULE TelOpts;

FROM R2NewerCalls IMPORT SocHandle, Status, TCPWrite;
FROM R2SysCalls IMPORT WriteString,WriteLn,Write;
FROM R2NumbIO   IMPORT WriteCard;
TYPE
  Queue = ( Empty, Opposite );
  State = ( Yes, WantYes, No, WantNo );
  Node  = RECORD
            us,
            him : State;
            usq,
            himq : Queue;
            desired : BOOLEAN;
          END;

VAR
  optList : ARRAY [0C..MaxOpt] OF Node;

   (***************************************************

               receive option processing

   ***************************************************)

PROCEDURE RWill( opt : CHAR );
  BEGIN                                          
(*WriteString('Received a will->');WriteCard(ORD(opt),3);WriteLn;*)
    WITH optList[opt] DO
      CASE him OF
        No      : IF desired THEN
(*Write('a');*)
                    him := Yes;
                    SendCmnd( DOIT, opt );
                  ELSE              
(*Write('b');*)
                    SendCmnd( DONT, opt );
                  END; (* IF *)|
        Yes     : ;|
        WantNo  : IF himq = Empty THEN
(*Write('c');*)
                    him := No;
                  ELSE
(*Write('d');*)
                    him := Yes;
                    himq := Empty;
                  END; (* IF *)|
        WantYes : IF himq = Empty THEN
(*Write('e');*)
                    him := Yes;
                  ELSE
(*Write('f');*)
                    him := WantNo;
                    himq := Empty;
                    SendCmnd( DONT, opt );
                  END; (* IF *)
      END; (* CASE *)
    END; (* WITH *)
  END RWill;

PROCEDURE RDo( opt : CHAR );
  BEGIN                                            
(*WriteString('Received a do->');WriteCard(ORD(opt),3);WriteLn;*)
    WITH optList[opt] DO
      CASE us OF
        No      : IF him = WantYes THEN
(*Write('g');*)
                    us := Yes;
                    SendCmnd( WILL, opt );
                  ELSE
(*Write('h');*)
                    SendCmnd( WONT, opt );
                  END; (* IF *)|
        Yes     : ;|
        WantNo  : IF usq = Empty THEN
(*Write('i');*)
                    us := No;
                  ELSE
(*Write('j');*)
                    us := Yes;
                    usq := Empty;
                  END; (* IF *)|
        WantYes : IF usq = Empty THEN
(*Write('k');*)
                    us := Yes;
                  ELSE
(*Write('l');*)
                    us := WantNo;
                    usq := Empty;
                    SendCmnd( WONT, opt );
                  END; (* IF *)
      END; (* CASE *)
    END; (* WITH *)
  END RDo;

PROCEDURE RWont( opt : CHAR );
  BEGIN                                           
(*WriteString('received a wont->');WriteCard(ORD(opt),3);WriteLn;*)
    WITH optList[opt] DO
      CASE him OF
        No      : ; |
        Yes     : him := No;
(*Write('m');*)
                  SendCmnd( DONT, opt ); |
        WantNo  : IF himq = Empty THEN
(*Write('n');*)
                    him := No;
                  ELSE
(*Write('o');*)
                    him := WantYes;
                    himq := Empty;
                    SendCmnd( DOIT, opt );
                  END; (* IF *) |
        WantYes : IF himq = Empty THEN
(*Write('p');*)
                    him := No;
                  ELSE
(*Write('q');*)
                    him := No;
                    himq := Empty;
                  END; (* IF *)
      END; (* CASE *)
    END; (* WITH *)
  END RWont;

PROCEDURE RDont( opt : CHAR );
  BEGIN
(*WriteString('recived a dont->');WriteCard(ORD(opt),3);WriteLn;*)
    WITH optList[opt] DO
      CASE us OF
        No      : ; |
        Yes     : us := No;
(*Write('r');*)
                  SendCmnd( WONT, opt ); |
        WantNo  : IF usq = Empty THEN
(*Write('s');*)
                    us := No;
                  ELSE
(*Write('t');*)
                    us := WantYes;
                    usq := Empty;
                    SendCmnd( WILL, opt );
                  END; (* IF *) |
        WantYes : IF usq = Empty THEN
(*Write('u');*)
                    us := No;
                  ELSE
(*Write('v');*)
                    us := No;
                    usq := Empty;
                  END; (* IF *)
      END; (* CASE *)
    END; (* WITH *)
  END RDont;

   (***************************************************

               send option processing

   ***************************************************)

PROCEDURE SDo( opt : CHAR );
  BEGIN                                            
(*WriteString('Sending option->');WriteCard(ORD(opt),3);WriteLn;*)
    WITH optList[opt] DO         
      desired := TRUE;
      CASE him OF
        No      : him := WantYes; SendCmnd( DOIT, opt );    |
        Yes     : ;|
        WantNo  : IF himq = Empty THEN himq := Opposite; END; |
        WantYes : IF himq = Opposite THEN himq := Empty; END;
      END; (* CASE *)
    END; (* WITH *)
  END SDo;

PROCEDURE SWill( opt : CHAR );
  BEGIN                                           
(*WriteString('Sending will you->');WriteCard(ORD(opt),3);WriteLn;*)
    WITH optList[opt] DO
      desired := TRUE;
      CASE us OF
        No      : us := WantYes; SendCmnd( WILL, opt );    |
        Yes     : ;|
        WantNo  : IF usq = Empty THEN usq := Opposite; END; |
        WantYes : IF usq = Opposite THEN usq := Empty; END;
      END; (* CASE *)
    END; (* WITH *)
  END SWill;

PROCEDURE SDont( opt : CHAR );
  BEGIN                                             
(*WriteString('Sending dont->');WriteCard(ORD(opt),3);WriteLn;*)
    WITH optList[opt] DO
      CASE him OF
        No      : ;|
        Yes     : him := WantNo; SendCmnd( DONT, opt ); |
        WantNo  : IF himq = Opposite THEN himq := Empty; END; |
        WantYes : IF himq = Empty THEN himq := Opposite; END;
      END; (* CASE *)
    END; (* WITH *)
  END SDont;

PROCEDURE SWont( opt : CHAR );
  BEGIN
(*WriteString('Sending wont->');WriteCard(ORD(opt),3);WriteLn;*)
    WITH optList[opt] DO                        
      CASE us OF
        No      : ;|
        Yes     : us := WantNo; SendCmnd( WONT, opt ); |
        WantNo  : IF usq = Opposite THEN usq := Empty; END; |
        WantYes : IF usq = Empty THEN usq := Opposite; END;
      END; (* CASE *)
    END; (* WITH *)
  END SWont;                      
                  
VAR
  isoc : SocHandle;
  s    : ARRAY [0..3] OF CHAR;

PROCEDURE RegisterSoc( soc : SocHandle );
  BEGIN           
    isoc := soc;
  END RegisterSoc;

PROCEDURE SendCmnd( cmnd, option : CHAR );
  VAR
    n2res : Status;
  BEGIN       
    s[0] := IAC;
    s[1] := cmnd;
    s[2] := option;
    n2res := TCPWrite( isoc, s, 3 );
  END SendCmnd;

PROCEDURE TInit;
  VAR
    i : CARDINAL;
  BEGIN
    FOR i := 0 TO ORD(MaxOpt) DO
      WITH optList[CHR(i)] DO
        IF ( CHR(i) = SuppressGA ) THEN
          us := Yes;
          him := Yes;
          usq := Empty;
          himq := Empty;
        ELSE
          us:=No;
          him:=No;
          usq:=Empty;
          himq:=Empty;
        END; (* IF *)                           
        desired := FALSE;
      END; (* WITH *)
    END; (* FOR *)
  END TInit;
     
BEGIN        
  s[3] := 0C;
  TInit;
END TelOpts.
