IMPLEMENTATION MODULE R2Format;

FROM SYSTEM IMPORT ADDRESS;
FROM R2SysCalls IMPORT Time;
FROM R2Strings IMPORT Length, Substring, Insert;

PROCEDURE  FormatCard( n, rad, digs : CARDINAL; VAR s : ARRAY OF CHAR);

VAR     i, c : CARDINAL;
        str : ARRAY [0..79] OF CHAR;

BEGIN   i := 0;
        WHILE ((n > 0) OR (digs > 0)) AND (i < 80) DO
          c := n MOD rad;
          IF c < 10 THEN INC(c,48) ELSE INC(c,55) END;
          str[i] := CHR(c);
          IF (n = 0) AND (i > 0) THEN str[i] := ' ' END;
          n := n DIV rad;
          INC(i);
          IF digs > 0 THEN DEC(digs) END;
          END;
        IF i > HIGH(s)+1 THEN i := HIGH(s)+1 END;
        FOR c := 0 TO i-1 DO s[c] := str[i-1-c] END;
        IF i <= HIGH(s) THEN s[i] := 0C END;
END FormatCard;

PROCEDURE  FormatAddr( a : ADDRESS; rad, digs : CARDINAL; 
                       VAR s : ARRAY OF CHAR);

VAR     i, c : CARDINAL;
        str : ARRAY [0..79] OF CHAR;

BEGIN   i := 0;
        WHILE ((a > 0) OR (digs > 0)) AND (i < 80) DO
          c := CARDINAL(a MOD ADDRESS(rad));
          IF c < 10 THEN INC(c,48) ELSE INC(c,55) END;
          str[i] := CHR(c);
          IF (a = 0) AND (i > 0) THEN str[i] := ' ' END;
          a := a DIV ADDRESS(rad);
          INC(i);
          IF digs > 0 THEN DEC(digs) END;
          END;
        IF i > HIGH(s)+1 THEN i := HIGH(s)+1 END;
        FOR c := 0 TO i-1 DO s[c] := str[i-1-c] END;
        IF i <= HIGH(s) THEN s[i] := 0C END;
END FormatAddr;

PROCEDURE  ScanCard( VAR s : ARRAY OF CHAR; rad : CARDINAL;
                     VAR c : CARDINAL) : BOOLEAN;

VAR     i, d : CARDINAL;

BEGIN   i := 0;
        c := 0;
        LOOP IF i > HIGH(s) THEN RETURN TRUE END;
             IF s[i] = 0C THEN RETURN TRUE END;
             IF s[i] < '0' THEN EXIT END;
             IF (s[i] > '9') AND (s[i] < 'A') THEN EXIT END;
             IF s[i] > 'Z' THEN EXIT END;
             d := ORD(s[i]) - 48;
             IF d > 9 THEN d := d - 7 END;
             IF d >= rad THEN EXIT END;
             c := rad*c + d;
             INC(i);
             END;
        RETURN FALSE;
END ScanCard;

PROCEDURE  ScanAddr( VAR s : ARRAY OF CHAR; rad : CARDINAL;
                     VAR a : ADDRESS) : BOOLEAN;

VAR     i, d : CARDINAL;

BEGIN   i := 0;
        a := 0;
        LOOP IF i > HIGH(s) THEN RETURN TRUE END;
             IF s[i] = 0C THEN RETURN TRUE END;
             IF s[i] < '0' THEN EXIT END;
             IF (s[i] > '9') AND (s[i] < 'A') THEN EXIT END;
             IF s[i] > 'Z' THEN EXIT END;
             d := ORD(s[i]) - 48;
             IF d > 9 THEN d := d - 7 END;
             IF d >= rad THEN EXIT END;
             a := ADDRESS(rad)*a + ADDRESS(d);
             INC(i);
             END;
        RETURN FALSE;
END ScanAddr;

PROCEDURE  FormatTime( t : Time; VAR s : ARRAY OF CHAR);

VAR     y, m, d, x : CARDINAL;
        s1, s2 : ARRAY [0..79] OF CHAR;
        hy, co : ARRAY [0..1] OF CHAR;

BEGIN   hy[0] := '-'; hy[1] := 0C; co[0] := ':'; co[1] := 0C;
        x := t.day;
        y := (x DIV 512) + 1980;
        x := x MOD 512;
        m := (x DIV 32);
        d := x MOD 32;
        FormatCard(d,10,2,s);
        Substring("JanFebMarAprMayJunJulAugSepOctNovDec",s1,3*m,3);
        Insert(hy,s,Length(s));
        Insert(s1,s,Length(s));
        Insert(hy,s,Length(s));
        FormatCard(y,10,4,s1);
        Insert(s1,s,Length(s));
        x := t.min;
        FormatCard(x DIV 60,10,4,s1);
        Insert(s1,s,Length(s));
        x := x MOD 60;
        IF x < 10 
          THEN Insert(':0',s,Length(s)) 
          ELSE Insert(co,s,Length(s))
          END;
        FormatCard(x,10,1,s1);
        Insert(s1,s,Length(s));
        x := t.csec DIV 100;
        IF x < 10 
          THEN Insert(':0',s,Length(s)) 
          ELSE Insert(co,s,Length(s))
          END;
        FormatCard(x,10,1,s1);
        Insert(s1,s,Length(s));
END FormatTime;

END R2Format.
