IMPLEMENTATION MODULE R2NewCalls;  (*  new system calls *)

FROM R2SysCalls IMPORT Process, Ticks, Status, Handle, Time;
FROM SYSTEM IMPORT ADDRESS, CODE, SETREG;

CONST   Trap15 = 047117B;
        PopA0  = 020137B;
        JmpA0  = 047320B;
        MoveQ1 = 071000B;

(*$T-*)
(*$P-*)
PROCEDURE  Resume( p : Process) : Status;  (* Awake a sleeping process *)

BEGIN   CODE(MoveQ1+48);
        CODE(PopA0,Trap15,JmpA0);
END Resume;

(*$P-*)
PROCEDURE  UpTime ( VAR t : Ticks ) ;

BEGIN   CODE(MoveQ1+49);
        CODE(PopA0,Trap15,JmpA0);
END UpTime;

(*$P-*)
PROCEDURE  SetDevParams( VAR dn : ARRAY OF CHAR; p, v : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+50);
        CODE(PopA0,Trap15,JmpA0);
END SetDevParams;

(*$P-*)
PROCEDURE  GetDevParams( VAR dn : ARRAY OF CHAR; p : CARDINAL;
                         VAR v : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+51);
        CODE(PopA0,Trap15,JmpA0);
END GetDevParams;

(*$P-*)
PROCEDURE  GetJobInfo( p : Process; VAR pages, ti : CARDINAL; 
                       VAR par : Process; VAR im : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+52);
        CODE(PopA0,Trap15,JmpA0);
END GetJobInfo;

(*$P-*)
PROCEDURE  AttachTerminal;  (* key presses wake sleep *)

BEGIN   CODE(MoveQ1+53);
        CODE(PopA0,Trap15,JmpA0);
END AttachTerminal;

(*$P-*)
PROCEDURE  DetachTerminal;

BEGIN   CODE(MoveQ1+54);
        CODE(PopA0,Trap15,JmpA0);
END DetachTerminal;

(*$P-*)
PROCEDURE  AttachMessage;   (* messages wake sleep *)

BEGIN   CODE(MoveQ1+55);
        CODE(PopA0,Trap15,JmpA0);
END AttachMessage;

(*$P-*)
PROCEDURE  DetachMessage;

BEGIN   CODE(MoveQ1+56);
        CODE(PopA0,Trap15,JmpA0);
END DetachMessage;

(*$P-*)
PROCEDURE  ViewHandle( h : Handle; VAR p : Process; 
                       VAR fn : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+57);
        CODE(PopA0,Trap15,JmpA0);
END ViewHandle;

(*$P-*)
PROCEDURE  SetFileDate( h : Handle; VAR t : Time) : Status;

BEGIN   CODE(MoveQ1+58);
        CODE(PopA0,Trap15,JmpA0);
END SetFileDate;

(*$P-*)
PROCEDURE  GetLogical( n : CARDINAL; VAR log, tran : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+59);
        CODE(PopA0,Trap15,JmpA0);
END GetLogical;

(*$P-*)
PROCEDURE  GetGlobal( n : CARDINAL; VAR log, tran : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+60);
        CODE(PopA0,Trap15,JmpA0);
END GetGlobal;

(*$P-*)
PROCEDURE  AttachTree( VAR root : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+61);
        CODE(PopA0,Trap15,JmpA0);
END AttachTree;

(*$P-*)
PROCEDURE  DetachTree;

BEGIN   CODE(MoveQ1+62);
        CODE(PopA0,Trap15,JmpA0);
END DetachTree;

(*$P-*)
PROCEDURE  SetName( proc : Process; VAR name : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+63);
        CODE(PopA0,Trap15,JmpA0);
END SetName;

(*$P-*)
PROCEDURE  GetName( proc : Process; VAR name : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+64);
        CODE(PopA0,Trap15,JmpA0);
END GetName;

(*$P-*)
PROCEDURE  WriteMessage( VAR name, message : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+65);
        CODE(PopA0,Trap15,JmpA0);
END WriteMessage;

(*$P-*)
PROCEDURE  Lock( VAR resource : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+66);
        CODE(PopA0,Trap15,JmpA0);
END Lock;

(*$P-*)
PROCEDURE  UnLock( VAR resource : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+67);
        CODE(PopA0,Trap15,JmpA0);
END UnLock;

(*$P-*)
PROCEDURE  AttachLock( VAR resource : ARRAY OF CHAR);

BEGIN   CODE(MoveQ1+68);
        CODE(PopA0,Trap15,JmpA0);
END AttachLock;

(*$P-*)
PROCEDURE  DetachLock;

BEGIN   CODE(MoveQ1+69);
        CODE(PopA0,Trap15,JmpA0);
END DetachLock;

(*$P-*)
PROCEDURE  ShowLock( n : CARDINAL; VAR resource : ARRAY OF CHAR;
                     VAR owner : CARDINAL; VAR proc : Process) : Status;

BEGIN   CODE(MoveQ1+70);
        CODE(PopA0,Trap15,JmpA0);
END ShowLock;

END R2NewCalls.
