IMPLEMENTATION MODULE R2Storage;

FROM SYSTEM IMPORT ADDRESS, REGISTER;
FROM R2SysCalls IMPORT ExpandCode, Exit, Status;

TYPE    nodeptr = POINTER TO node;
        node =  RECORD  next : nodeptr;
                        size : ADDRESS;
                END;

VAR     empty : nodeptr;
        HeapTop : CARDINAL;  (* First free page *)

PROCEDURE ALLOCATE( VAR addr : ADDRESS; s : CARDINAL);

VAR     inc : CARDINAL;
        ptr : ADDRESS;

BEGIN   LOOP Allocate(addr,s);
             IF addr <> NIL THEN EXIT END;
             inc := (s DIV 1000H) + 1;
             IF ExpandCode(inc) <> Ok THEN
               Exit(NoHeap);
               END;
             ptr := ADDRESS(HeapTop)*1000H;
             DEALLOCATE(ptr,inc*1000H);
             INC(HeapTop,inc);
             END;
END ALLOCATE;

PROCEDURE Allocate( VAR addr : ADDRESS; s : CARDINAL);

VAR     p, q : nodeptr;

BEGIN   s := ((s + 7) DIV 8)*8;
        p := empty;
        q := NIL;
        addr := NIL;
        WHILE p <> NIL DO
          WITH p^ DO
            IF size >= ADDRESS(s) THEN 
              size := size - ADDRESS(s);
              addr := ADDRESS(p) + size;
              IF size = 0 THEN
                IF q = NIL 
                  THEN empty := next
                  ELSE q^.next := next 
                  END;
                END;
              p := NIL;
              ELSE q := p;
                   p := next;
              END;
            END;
          END;
END Allocate;

PROCEDURE DEALLOCATE ( VAR addr : ADDRESS ; s : CARDINAL);

VAR     n, p, q : nodeptr;

BEGIN   n := nodeptr(addr);
        s := ((s + 7) DIV 8)*8;
        p := empty;
        q := NIL;
        n^.size := ADDRESS(s);
        n^.next := NIL;
        IF empty = NIL 
          THEN empty := n 
          ELSE WHILE (addr > ADDRESS(p)) AND (p <> NIL) DO
                 q := p;
                 p := p^.next;
                 END;
               IF q = NIL 
                 THEN empty := n 
                 ELSE q^.next := n;
                 END;
               n^.next := p;
               IF addr + ADDRESS(s) = ADDRESS(p) THEN 
                 n^.size := n^.size + p^.size;
                 n^.next := p^.next;
                 END;
               IF q <> NIL THEN 
                 IF ADDRESS(q) + q^.size = addr THEN
                   q^.size := q^.size + n^.size;
                   q^.next := n^.next;
                   END;
                 END;
               END;
        addr := NIL;
END DEALLOCATE;

PROCEDURE  InitHeap;

VAR     d6, bal : ADDRESS;

BEGIN   empty := NIL; 
        d6 := REGISTER(6);   (* FirstFree from the loader *)
        HeapTop := CARDINAL((d6+0FFFH) DIV 1000H);
        d6 := ((d6+7) DIV 8)*8;
        bal := ADDRESS(HeapTop)*1000H - d6 ;
        IF bal <> 0 THEN DEALLOCATE(d6,CARDINAL(bal)) END;
END InitHeap;

BEGIN   InitHeap;
END R2Storage.
