IMPLEMENTATION MODULE R2SysCalls;  (*  LUMOS interface *)

FROM SYSTEM IMPORT ADDRESS, CODE, SETREG;

(* NB: These pseudo routines are NOT reentrant *)

CONST   Trap15 = 047117B;
        PopA0  = 020137B;  (* MOVE.L (SP)+,A0 *)
        JmpA0  = 047320B;  (* JMP    (A0)     *)
        MoveQ1 = 071000B;  (* MOVEQ  bb,D1    *)

(*$T-*)
(*$P-*)
PROCEDURE  Execute( VAR image, command, home : ARRAY OF CHAR;
                    terminal, user : CARDINAL; CCfatal, wait, priv : BOOLEAN;
                    VAR proc : Process; VAR result : Status; 
                    VAR pc : ADDRESS) : Status;

BEGIN   CODE(MoveQ1+1);
        CODE(PopA0,Trap15,JmpA0);
END Execute;

(*$P-*)
PROCEDURE  Exit( rs : Status );

BEGIN   CODE(MoveQ1+2);
        CODE(PopA0,Trap15,JmpA0);
END Exit;

(*$P-*)
PROCEDURE  Kill ( proc : Process; rs : Status ) : Status;

BEGIN   CODE(MoveQ1+3);
        CODE(PopA0,Trap15,JmpA0);
END Kill;

(*$P-*)
PROCEDURE  Sleep( interval : Ticks ) : Status;

BEGIN   CODE(MoveQ1+4);
        CODE(PopA0,Trap15,JmpA0);
END Sleep;

(*$P-*)
PROCEDURE  GetPID( VAR proc : Process) : Status;

BEGIN   CODE(MoveQ1+5);
        CODE(PopA0,Trap15,JmpA0);
END GetPID;

(*$P-*)
PROCEDURE  GetUser( proc : Process; VAR user : CARDINAL ) : Status;

BEGIN   CODE(MoveQ1+6);
        CODE(PopA0,Trap15,JmpA0);
END GetUser;

(*$P-*)
PROCEDURE  SetUser( proc : Process; user : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+7);
        CODE(PopA0,Trap15,JmpA0);
END SetUser;

(*$P-*)
PROCEDURE  GetCommand( VAR s : ARRAY OF CHAR);

BEGIN   CODE(MoveQ1+8);
        CODE(PopA0,Trap15,JmpA0);
END GetCommand;

(*$P-*)
PROCEDURE  TestCC() : BOOLEAN;

BEGIN   CODE(MoveQ1+9);
        CODE(PopA0,Trap15,JmpA0);
END TestCC;

(*$P-*)
PROCEDURE  SetCCMode( fatal : BOOLEAN ); 

BEGIN   CODE(MoveQ1+10);
        CODE(PopA0,Trap15,JmpA0);
END SetCCMode;

(*$P-*)
PROCEDURE  Result() : Status;

BEGIN   CODE(MoveQ1+11);
        CODE(PopA0,Trap15,JmpA0);
END Result;

(*$P-*)
PROCEDURE  Read( VAR ch : CHAR; wait : BOOLEAN);

BEGIN   CODE(MoveQ1+12);
        CODE(PopA0,Trap15,JmpA0);
END Read;

(*$P-*)
PROCEDURE  ReadString( VAR s : ARRAY OF CHAR);

BEGIN   CODE(MoveQ1+13);
        CODE(PopA0,Trap15,JmpA0);
END ReadString;

(*$P-*)
PROCEDURE  Write( ch : CHAR );

BEGIN   CODE(MoveQ1+14);
        CODE(PopA0,Trap15,JmpA0);
END Write;

(*$P-*)
PROCEDURE  WriteString( VAR s : ARRAY OF CHAR);

BEGIN   CODE(MoveQ1+15);
        CODE(PopA0,Trap15,JmpA0);
END WriteString;

(*$P-*)
PROCEDURE  WriteLn;

BEGIN   CODE(MoveQ1+16);
        CODE(PopA0,Trap15,JmpA0);
END WriteLn;

(*$P-*)
PROCEDURE  Open( VAR fn : ARRAY OF CHAR; write : BOOLEAN; 
                 VAR h : Handle ) : Status;

BEGIN   CODE(MoveQ1+17);
        CODE(PopA0,Trap15,JmpA0);
END Open;

(*$P-*)
PROCEDURE  Create( VAR fn : ARRAY OF CHAR; mode : FileMode; 
                   VAR h : Handle ) : Status;

BEGIN   CODE(MoveQ1+18);
        CODE(PopA0,Trap15,JmpA0);
END Create;

(*$P-*)
PROCEDURE  Close( h : Handle; save : BOOLEAN) : Status;

BEGIN   CODE(MoveQ1+19);
        CODE(PopA0,Trap15,JmpA0);
END Close;

(*$P-*)
PROCEDURE  Delete( VAR fn : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+20);
        CODE(PopA0,Trap15,JmpA0);
END Delete;

(*$P-*)
PROCEDURE  Rename( VAR old, new : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+21);
        CODE(PopA0,Trap15,JmpA0);
END Rename;

(*$P-*)
PROCEDURE  GetMode( h : Handle; VAR date : Time;
                    VAR mode : FileMode; VAR owner : CARDINAL ) : Status;

BEGIN   CODE(MoveQ1+22);
        CODE(PopA0,Trap15,JmpA0);
END GetMode;

(*$P-*)
PROCEDURE  SetMode( h : Handle; mode : FileMode; owner : CARDINAL ) : Status;

BEGIN   CODE(MoveQ1+23);
        CODE(PopA0,Trap15,JmpA0);
END SetMode;

(*$P-*)
PROCEDURE  Size( h : Handle; VAR size : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+24);
        CODE(PopA0,Trap15,JmpA0);
END Size;

(*$P-*)
PROCEDURE  FastSize( VAR dvn : ARRAY OF CHAR; first : CARDINAL;
                     VAR size : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+25);
        CODE(PopA0,Trap15,JmpA0);
END FastSize;

(*$P-*)
PROCEDURE  ReadBlock( h : Handle; VAR b : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+26);
        CODE(PopA0,Trap15,JmpA0);
END ReadBlock;

(*$P-*)
PROCEDURE  WriteBlock( h : Handle; VAR b : ARRAY OF CHAR; 
                       trunc : BOOLEAN) : Status;

BEGIN   CODE(MoveQ1+27);
        CODE(PopA0,Trap15,JmpA0);
END WriteBlock;

(*$P-*)
PROCEDURE  Seek( h : Handle; blocknum : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+28);
        CODE(PopA0,Trap15,JmpA0);
END Seek;

(*$P-*)
PROCEDURE  GetDevAttr( VAR dn : ARRAY OF CHAR; VAR devsize : CARDINAL;
                       VAR attr : DevAttrSet ) : Status;

BEGIN   CODE(MoveQ1+29);
        CODE(PopA0,Trap15,JmpA0);
END GetDevAttr;

(*$P-*)
PROCEDURE  FormatTrack( h : Handle; track : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+30);
        CODE(PopA0,Trap15,JmpA0);
END FormatTrack;

(*$P-*)
PROCEDURE  Mount( VAR dn, label : ARRAY OF CHAR; private : BOOLEAN) : Status;

BEGIN   CODE(MoveQ1+31);
        CODE(PopA0,Trap15,JmpA0);
END Mount;

(*$P-*)
PROCEDURE  Dismount( VAR dn : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+32);
        CODE(PopA0,Trap15,JmpA0);
END Dismount;

(*$P-*)
PROCEDURE  FreeSpace( VAR dn : ARRAY OF CHAR; VAR space : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+33);
        CODE(PopA0,Trap15,JmpA0);
END FreeSpace;

(*$P-*)
PROCEDURE  Translate( VAR sn, tn : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+34);
        CODE(PopA0,Trap15,JmpA0);
END Translate;

(*$P-*)
PROCEDURE  CreateLogical( VAR log, tran : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+35);
        CODE(PopA0,Trap15,JmpA0);
END CreateLogical;

(*$P-*)
PROCEDURE  DeleteLogical( VAR log : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+36);
        CODE(PopA0,Trap15,JmpA0);
END DeleteLogical;

(*$P-*)
PROCEDURE  CreateGlobal( VAR log, tran : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+37);
        CODE(PopA0,Trap15,JmpA0);
END CreateGlobal;

(*$P-*)
PROCEDURE  DeleteGlobal( VAR log : ARRAY OF CHAR) : Status;

BEGIN   CODE(MoveQ1+38);
        CODE(PopA0,Trap15,JmpA0);
END DeleteGlobal;

(*$P-*)
PROCEDURE  TestMessage( wait : BOOLEAN ) : CARDINAL;

BEGIN   CODE(MoveQ1+39);
        CODE(PopA0,Trap15,JmpA0);
END TestMessage;

(*$P-*)
PROCEDURE  ExpandCode( frames : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+40);
        CODE(PopA0,Trap15,JmpA0);
END ExpandCode;

(*$P-*)
PROCEDURE  ExpandStack( frames : CARDINAL) : Status;

BEGIN   CODE(MoveQ1+41);
        CODE(PopA0,Trap15,JmpA0);
END ExpandStack;

(*$P-*)
PROCEDURE  GetTime( VAR t : Time) : Status;

BEGIN   CODE(MoveQ1+42);
        CODE(PopA0,Trap15,JmpA0);
END GetTime;

(*$P-*)
PROCEDURE  SetTime( VAR t : Time) : Status;

BEGIN   CODE(MoveQ1+43);
        CODE(PopA0,Trap15,JmpA0);
END SetTime;

(*$P-*)
PROCEDURE  GetMessage( r : Status; VAR s : ARRAY OF CHAR);

BEGIN   CODE(MoveQ1+44);
        CODE(PopA0,Trap15,JmpA0);
END GetMessage;

(*$P-*)
PROCEDURE  SetTrapMode( fatal : BOOLEAN);

BEGIN   CODE(MoveQ1+45);
        CODE(PopA0,Trap15,JmpA0);
END SetTrapMode;

(*$P-*)
PROCEDURE  TestTrap() : Status;

BEGIN   CODE(MoveQ1+46);
        CODE(PopA0,Trap15,JmpA0);
END TestTrap;

(*$P-*)
PROCEDURE  ReBoot() : Status;

BEGIN   CODE(MoveQ1+47);
        CODE(PopA0,Trap15,JmpA0);
END ReBoot;

END R2SysCalls.
