IMPLEMENTATION MODULE R2TimeSubs;  

FROM R2SysCalls IMPORT Time, WriteString, WriteLn;
FROM R2Strings IMPORT Copy, Insert, Substring, Find;
FROM R2Format IMPORT FormatCard, ScanCard;

CONST   Months = "Jan-Feb-Mar-Apr-May-Jun-Jul-Aug-Sep-Oct-Nov-Dec-";

PROCEDURE  CompareTime( t1, t2 : Time) : INTEGER;

(* if t1 < t2 then returns < 0, = returns 0, > returns > 0 *)

VAR     d : INTEGER;

BEGIN   d := t1.day - t2.day;
        IF d <> 0 THEN RETURN d END;
        d := t1.min - t2.min;
        IF d <> 0 THEN RETURN d END;
        RETURN t1.csec - t2.csec;
END CompareTime;

PROCEDURE  ScanTime( VAR s : ARRAY OF CHAR; VAR t : Time) : BOOLEAN;

VAR     i, j, da, mo, yr, hr, mi, se : CARDINAL;
        dat, tim, num : ARRAY [0..79] OF CHAR;
        hs : BOOLEAN;

BEGIN   i := 0;
        WHILE (i <= HIGH(s)) AND (s[i] <> 0C) AND (s[i] = ' ') DO 
          INC(i) END;
        j := i;
        hs := FALSE;
        WHILE (j <= HIGH(s)) AND (s[j] <> 0C) AND (s[j] <> ' ') DO 
          hs := hs OR (s[j] = '-');
          INC(j);
          END;                
        dat[0] := 0C;
        IF hs THEN
          Substring(s,dat,i,j-i);
          i := j;
          WHILE (i <= HIGH(s)) AND (s[i] <> 0C) AND (s[i] = ' ') DO 
            INC(i) END;
          j := i;
          WHILE (j <= HIGH(s)) AND (s[j] <> 0C) AND (s[j] <> ' ') DO 
            INC(j) END;
          END;
        Substring(s,tim,i,j-i);
        IF dat[0] <> 0C THEN
          i := 0;
          WHILE (i <= HIGH(dat)) AND (dat[i] <> 0C) AND (dat[i] <> '-') DO 
            INC(i) END;
          Substring(dat,num,0,i);
          IF NOT ScanCard(num,10,da) THEN RETURN FALSE END;
          IF (da = 0) OR (da > 31) THEN RETURN FALSE END;
          Substring(dat,num,i+1,4);
          mo := Find(num,Months) DIV 4;
          IF mo > 11 THEN RETURN FALSE END;
          Substring(dat,num,i+5,4);
          IF NOT ScanCard(num,10,yr) THEN RETURN FALSE END;
          IF yr < 100 THEN INC(yr,1900) END;
          IF yr < 1980 THEN RETURN FALSE END;
          CASE mo+1 OF
            9, 4, 6, 11 : i := 30 |
            2 : IF (yr MOD 4) = 0 THEN i := 29 ELSE i := 28 END
            ELSE i := 31
            END;
          IF da > i THEN RETURN FALSE END;
          t.day := da + mo*32 + (yr-1980)*512;
          END;
        IF tim[0] <> 0C THEN
          i := 0;
          WHILE (i <= HIGH(tim)) AND (tim[i] <> 0C) AND (tim[i] <> ':') DO
            INC(i) END;
          j := i; 
          INC(i);
          WHILE (i <= HIGH(tim)) AND (tim[i] <> 0C) AND (tim[i] <> ':') DO
            INC(i) END;
          Substring(tim,num,0,j);
          IF num[0] = 0C THEN RETURN FALSE END;
          IF NOT ScanCard(num,10,hr) THEN RETURN FALSE END;
          IF hr > 23 THEN RETURN FALSE END;
          Substring(tim,num,j+1,i-j-1);
          IF num[0] = 0C THEN RETURN FALSE END;
          IF NOT ScanCard(num,10,mi) THEN RETURN FALSE END;
          IF mi > 59 THEN RETURN FALSE END;
          Substring(tim,num,i+1,2);
          IF NOT ScanCard(num,10,se) THEN END; (* may be absent *)
          IF se > 59 THEN RETURN FALSE END;
          t.min := hr*60 + mi;
          t.csec := se*100;
          END;
        RETURN TRUE;
END ScanTime;

PROCEDURE  FormatTime( t : Time; VAR s : ARRAY OF CHAR);

VAR     yr, mo, da, x : CARDINAL;
        temp : ARRAY [0..22] OF CHAR;
        num : ARRAY [0..5] OF CHAR;

BEGIN   Copy("--  ::",temp);
        x := t.csec DIV 100;
        FormatCard(x,10,2,num);
        IF num[0] = ' ' THEN num[0] := '0' END;
        Insert(num,temp,6);
        x := t.min MOD 60;
        FormatCard(x,10,2,num);
        IF num[0] = ' ' THEN num[0] := '0' END;
        Insert(num,temp,5);
        x := t.min DIV 60;
        FormatCard(x,10,2,num);
        Insert(num,temp,4);
        x := t.day;
        yr := (x DIV 512) + 1980;
        x := x MOD 512;
        mo := x DIV 32;
        da := x MOD 32;
        FormatCard(yr,10,4,num);
        Insert(num,temp,2);
        Substring(Months,num,4*mo,3);
        Insert(num,temp,1);
        FormatCard(da,10,2,num);
        Insert(num,temp,0);
        Copy(temp,s);
END FormatTime;                                                      

END R2TimeSubs.
