IMPLEMENTATION MODULE DBG;
       
FROM L2Errors   IMPORT Status;
FROM L2Terminal IMPORT Write;
FROM SYSTEM     IMPORT ADDRESS;
FROM N2TCPMain  IMPORT TCBState, OutState;

VAR
  flag : BOOLEAN;      
  i    : CARDINAL;

PROCEDURE SetDbg( dbgon : BOOLEAN );
  BEGIN
    flag := dbgon;
  END SetDbg;

PROCEDURE Wr( c : CHAR );
  VAR
    rs : Status;
  BEGIN
    IF NOT flag THEN RETURN; END;
    rs := Write( 3, c );
    rs := Write(3,' ');
  END Wr;

PROCEDURE WrH( c : CHAR );
  VAR
    rs : Status;
    a,b1,b2,b3 : CARDINAL;
  BEGIN                                 
    IF NOT flag THEN RETURN; END;
    a := CARDINAL(c);
    b1 := a DIV 100;
    b2 := (a MOD 100) DIV 10;
    b3 := (a MOD 10);
    rs := Write(3,CHR(b1+48));
    rs := Write(3,CHR(b2+48));
    rs := Write(3,CHR(b3+48));
    rs := Write(3,CHR(32));
  END WrH;
   
VAR
  s : ARRAY[0..15] OF CHAR;

PROCEDURE WrC( n : CARDINAL );
  VAR
    c,i : CARDINAL;             
    rs : Status;                                  
  BEGIN
    IF NOT flag THEN RETURN; END;
    i := 0;   
    IF n = 0 THEN 
      rs := Write(3,'0'); 
    ELSE
      WHILE (n>0) DO
        c := n MOD 10;
        INC(c,48);
        s[i] := CHR(c);
        INC(i);
        n := n DIV 10;
      END;
      FOR c := 0 TO i - 1 DO rs := Write(3,s[i-1-c]); END;
    END;
    rs := Write(3,' ');
  END WrC;             

PROCEDURE WrA( n : ADDRESS );
  VAR
    c,i : CARDINAL;             
    rs : Status;                                  
  BEGIN
    i := 0;   
    IF n = 0 THEN 
      rs := Write(3,'0'); 
    ELSE
      WHILE (n>0) DO
        c := CARDINAL(n MOD 10);
        INC(c,48);
        s[i] := CHR(c);
        INC(i);
        n := n DIV 10;
      END;
      FOR c := 0 TO i - 1 DO rs := Write(3,s[i-1-c]); END;
    END;
    rs := Write(3,' ');
  END WrA;    

PROCEDURE DbgS( s : ARRAY OF CHAR );
  VAR
    rs : Status;
  BEGIN 
    IF NOT flag THEN RETURN; END; 
    FOR i := 0 TO HIGH(s) DO rs := Write(3,s[i]); END;
    rs := Write(3,' ');
  END DbgS;            

PROCEDURE DbgA( s : ARRAY OF CHAR; a : ADDRESS );
  VAR
    rs : Status;
  BEGIN   
    IF NOT flag THEN RETURN; END;
    DbgS(s);
    rs := Write(3,':');
    rs := Write(3,' ');
    WrA(a);
  END DbgA;

PROCEDURE DbgC( s : ARRAY OF CHAR; c : CARDINAL );
  VAR
    rs : Status;
  BEGIN   
    IF NOT flag THEN RETURN; END;
    DbgS(s);
    rs := Write(3,':');
    rs := Write(3,' ');
    WrC(c);
  END DbgC;

PROCEDURE DbgB( s : ARRAY OF CHAR; b : BOOLEAN );
  VAR
    rs : Status;
  BEGIN
    IF NOT flag THEN RETURN; END;
    DbgS(s);
    rs := Write(3,':');
    rs := Write(3,' ');
    IF b THEN 
      DbgS('TRUE');
    ELSE
      DbgS('FALSE');
    END;
 END DbgB;

PROCEDURE DbgTS( state : TCBState );
  BEGIN
    IF NOT flag THEN RETURN; END;
    DbgS('TCPState =');
    CASE state OF
      CLOSED      : DbgS('CLOSED');       |
      LISTEN      : DbgS('LISTEN');       |
      SYNSENT     : DbgS('SYNSENT');      |
      SYNRCVD     : DbgS('SYNRCVD');      |
      ESTABLISHED : DbgS('ESTABLISHED');  |
      FINWAIT1    : DbgS('FINWAIT1');     |
      FINWAIT2    : DbgS('FINWAIT2');     |
      CLOSING     : DbgS('CLOSING');      |
      LASTACK     : DbgS('LASTACK');      |
      CLOSEWAIT   : DbgS('CLOSEWAIT');    |
      TIMEWAIT    : DbgS('TIMEWAIT');  
      ELSE     DbgS('ERR__NO_STATE!!');
    END; (* CASE *)                                     
  END DbgTS;

PROCEDURE DbgOS( state : OutState );
  BEGIN
    IF NOT flag THEN RETURN; END;
    DbgS('OutState =');
    CASE state OF
      IDLE        : DbgS('IDLE');       |
      PERSIST     : DbgS('PERSIST');    |
      TRANSMIT    : DbgS('TRANSMIT');   |
      RETRANSMIT  : DbgS('RETRANSMIT'); 
    END; (* CASE *)                                     
  END DbgOS;

BEGIN                           
  flag := TRUE;
END DBG.
