IMPLEMENTATION MODULE L2Errors;

FROM L2Strings IMPORT Copy;

PROCEDURE  GetMessage( r : Status; VAR s : ARRAY OF CHAR);

BEGIN   CASE r OF
          Ok          : Copy("Normal completion",s)             |
          NoMemory    : Copy("No memory available",s)           |
          NoSuch      : Copy("No such object",s)                |
          NoSpace     : Copy("No addressing space available",s) |
          NoHeap      : Copy("Heap exhausted",s)                |
          NoSlot      : Copy("Table full",s)                    |
          EmptyBuff   : Copy("Buffer empty",s)                  |
          TimedOut    : Copy("Timed out",s)                     |
          DevError    : Copy("Device error",s)                  |
          IllegalOp   : Copy("Illegal operation",s)             |
          SeekFail    : Copy("Seek failed",s)                   |
          CRCError    : Copy("CRC error",s)                     |
          OverRun     : Copy("Data overrun",s)                  |
          NoSector    : Copy("Sector not found",s)              |
          Protect     : Copy("Write protect",s)                 |
          EndTrack    : Copy("End of track",s)                  |
          BadFormat   : Copy("Bad format",s)                    |
          NoTrack     : Copy("No such track",s)                 |
          NoDevice    : Copy("No such device",s)                |
          NoUnit      : Copy("No such unit",s)                  |
          NoFunction  : Copy("Function not supported",s)        |
          NoDirect    : Copy("Directory not found",s)           |
          NoFile      : Copy("File not found",s)                |
          NoAccess    : Copy("Access prohibited",s)             |
          NoBlocks    : Copy("Volume full",s)                   |
          BadHandle   : Copy("Bad file handle",s)               |
          EndFile     : Copy("End of file",s)                   |
          EscKey      : Copy("Escape key pressed",s)            |
          BadName     : Copy("Invalid file name",s)             |
          VolBusy     : Copy("Volume in use",s)                 |
          NoShare     : Copy("Sharing not permitted",s)         |
          NoPriv      : Copy("Privilege violation",s)           |
          BadLabel    : Copy("Incorrect volume label",s)        |
          BadVolume   : Copy("Invalid volume structure",s)      |
          BadAddress  : Copy("Illegal user address",s)          |
          OffVolume   : Copy("Rename off volume",s)             |
          Locked      : Copy("File locked",s)                   |
          NoLogical   : Copy("Logical name not in tables",s)    |
          BadLogical  : Copy("Invalid logical name",s)          |
          NotMounted  : Copy("Device not mounted",s)            |
          BadDevice   : Copy("Invalid device type",s)           |
          DeviceBusy  : Copy("Device not available",s)          |
          BadFunction : Copy("Invalid function",s)              |
          BadDirect   : Copy("Invalid directory",s)             |
          Exists      : Copy("New name already exists",s)       |
          NoWrite     : Copy("Writing not permitted",s)         |
          Break       : Copy("Terminated by <CTRL-C>",s)        |
          BadImage    : Copy("Invalid load file",s)             |
          NoCall      : Copy("Illegal system call",s)           |
          BusError    : Copy("Bus error",s)                     |
          AddrError   : Copy("Address error",s)                 |
          IllInst     : Copy("Illegal instruction",s)           |
          DivZero     : Copy("Divide by zero",s)                |
          BoundsError : Copy("Bounds error",s)                  |
          ArithOver   : Copy("Arithmetic overflow",s)           |
          PrivViol    : Copy("Privilege fault",s)               |
          TraceTrap   : Copy("Trace trap",s)                    |
          UnIntVec    : Copy("Uninitialised vector",s)          |
          SpuriousInt : Copy("Spurious interrupt",s)            |
          Halt        : Copy("Program HALT",s)                  |
          NoReturn    : Copy("No RETURN",s)                     |
          CaseRange   : Copy("CASE selector out of range",s)    |
          StackOver   : Copy("Stack overflow",s)                |
          RangeError  : Copy("Range error",s)                   |
          BadTrap     : Copy("Illegal trap",s)                  |
          NotActive   : Copy("Process not active",s) 
          ELSE          Copy("Unknown error",s)
          END;
END GetMessage;

END L2Errors.
