IMPLEMENTATION MODULE L2RamDisk;

FROM L2Errors IMPORT Status;
FROM L2BlockMove IMPORT FastCopy;
FROM L2Storage IMPORT ALLOCATE;
FROM L2Strings IMPORT Copy;
FROM SYSTEM IMPORT ADR;

CONST   maxtracks = 16;          (* makes 512 blocks on disk = 256 K *)
        trackblocks = 32;

TYPE    block = ARRAY [0..511] OF CHAR;
        track = ARRAY [0..trackblocks-1] OF block;
        trackptr = POINTER TO track;

VAR     disk : ARRAY [0..maxtracks-1] OF trackptr;

PROCEDURE  ReadBlock( sector : CARDINAL; VAR b : ARRAY OF CHAR) : Status;

VAR     p : trackptr;

BEGIN   IF i >= SectorCount THEN RETURN NoSector END;
        p := disk[sector DIV trackblocks];
        IF p = NIL THEN RETURN DevError END;
        IF HIGH(b) = 511 
          THEN FastCopy(ADR(p^[sector MOD trackblocks]),ADR(b))
          ELSE Copy(p^[sector MOD trackblocks],b)
          END;
        RETURN Ok;
END ReadBlock;

PROCEDURE  WriteBlock( sector : CARDINAL; VAR b : ARRAY OF CHAR) : Status;

VAR     p : trackptr;

BEGIN   IF i >= SectorCount THEN RETURN NoSector END;
        p := disk[sector DIV trackblocks];
        IF p = NIL THEN RETURN DevError END;
        IF HIGH(b) = 511 
          THEN FastCopy(ADR(b),ADR(p^[sector MOD trackblocks]))
          ELSE Copy(b,p^[sector MOD trackblocks])
          END;
        RETURN Ok;
END WriteBlock;

VAR     i : CARDINAL;

BEGIN   SectorCount := maxtracks * trackblocks;
        FOR i := 0 TO maxtracks-1 DO NEW(disk[i]) END;
END L2RamDisk.
