IMPLEMENTATION MODULE L2SysCalls;  (* V1.4 *)

FROM SYSTEM IMPORT REGISTER;
FROM L2Exceptions IMPORT Handler, Establish;
FROM L2Errors IMPORT Status, GetMessage;
FROM L2Loader IMPORT Execute, Exit, Kill, Sleep, GetPID, GetUser, SetUser,
                     GetCommand, TestCC, SetCCMode, CreateGlobal, DeleteGlobal,
                     SetTime, GetTime, ReBoot, Resume, UpTime, SetDevParams,
                     GetJobInfo, SetName, GetName, WriteMessage, SetPriority,
                     HangUp;
FROM L2Device IMPORT GetDevParams;
IMPORT L2TTIO;
FROM L2TTIO IMPORT Result, Read, ReadString, Write, WriteString, WriteLn;
FROM L2Files IMPORT Open, Create, Close, Delete, Rename, GetMode, SetMode,
                    Size, FastSize, ReadBlock, WriteBlock, Seek, GetDevAttr,
                    FormatTrack, Mount, Dismount, FreeSpace, ViewHandle,
                    SetFileDate, AttachTree, DetachTree;
FROM L2Logicals IMPORT CreateLogical, DeleteLogical, Translate, GetLogical,
                       GetSystemLogical;
IMPORT L2Message;
FROM L2Message IMPORT TestMessage;
FROM L2Kernel IMPORT ExpandStack, ExpandCode, ExecuteOnUserStack, Valid;
FROM L2Traps IMPORT SetTrapMode, TestTrap;
FROM L2Locks IMPORT Lock, UnLock, AttachLock, DetachLock, ShowLock;
FROM L2Cache IMPORT ViewCache, CacheStats;
FROM N2Packets IMPORT Qquery;
FROM N2Arp IMPORT ArpStats,StatsCache;
FROM N2IP IMPORT IPStats;
FROM N2UDP IMPORT GlobalStats, SetUDPPort, Send, Receive, ProcessStats;
FROM N2ICMP IMPORT ICMPStats, Ping;
FROM L2Storage IMPORT HeapSz;
FROM N2TCPMain IMPORT TCPStats, TCBInfo;
FROM N2TCPUser IMPORT TCPListen, TCPOpen, TCPWrite, TCPRead, TCPClose,
                      TCPAbort, TCPAttach, TCPDetach;
FROM L2Terminal IMPORT VTIn, VTOut, VTAllocate, VTDeallocate;
IMPORT N2Errors;
FROM N2Config   IMPORT NetConfig,DNSInfo;
FROM N2TCPTimer IMPORT SetTimerGrain;

CONST   MaxCalls = 104;

TYPE    Pattern = ARRAY [0..11] OF CHAR;
VAR
        pr : ARRAY[0..MaxCalls] OF PROC;
        pa : ARRAY[0..MaxCalls] OF Pattern;

PROCEDURE  Trap15;

VAR     func : CARDINAL;

BEGIN   func := CARDINAL(REGISTER(1));
        IF (func > MaxCalls) OR (func = 0) THEN Exit(NoCall) END;
        IF NOT Valid(pa[func]) THEN Exit(BadAddress) END;
        IF NOT ExecuteOnUserStack(pr[func]) THEN Exit(StackOver) END;
END Trap15;

PROCEDURE InitPa;
BEGIN
pa[01] := "FOOOWWWWWVCU";
pa[02] := "W ";
pa[03] := "FWW";
pa[04] := "FL";
pa[05] := "FV";
pa[06] := "FWV";
pa[07] := "FWW";
pa[08] := "O ";
pa[09] := "F ";
pa[10] := "W ";
pa[11] := "F ";
pa[12] := "CW";
pa[13] := "O ";
pa[14] := "W ";
pa[15] := "O ";
pa[16] := "  ";
pa[17] := "FOWV";
pa[18] := "FOWV";
pa[19] := "FWW";
pa[20] := "FO";
pa[21] := "FOO";
pa[22] := "FWTVV";
pa[23] := "FWWW";
pa[24] := "FWV";
pa[25] := "FOWV";
pa[26] := "FWO";
pa[27] := "FWOW";
pa[28] := "FWW";
pa[29] := "FOVC";
pa[30] := "FWW";
pa[31] := "FOOW";
pa[32] := "FO";
pa[33] := "FOV";
pa[34] := "FOO";
pa[35] := "FOO";
pa[36] := "FO";
pa[37] := "FOO";
pa[38] := "FO";
pa[39] := "FW";
pa[40] := "FW";
pa[41] := "FW";
pa[42] := "FT";
pa[43] := "FT";
pa[44] := "WO";
pa[45] := "W ";
pa[46] := "F ";
pa[47] := "F ";
pa[48] := "FW";
pa[49] := "U ";
pa[50] := "FOWW";
pa[51] := "FOWV";
pa[52] := "FWVVVO";
pa[53] := "  ";
pa[54] := "  ";
pa[55] := "  ";
pa[56] := "  ";
pa[57] := "FWVO";
pa[58] := "FWT";
pa[59] := "FWOO";
pa[60] := "FWOO";
pa[61] := "FO";
pa[62] := "  ";
pa[63] := "FWO";
pa[64] := "FWO";
pa[65] := "FOO";
pa[66] := "FO";
pa[67] := "FO";
pa[68] := "O ";
pa[69] := "  ";
pa[70] := "FWOVV";
pa[71] := "FWVVUU";
pa[72] := "UU";
pa[73] := "VV";
pa[74] := "VVVVVU";
pa[75] := "VVVVVUUU";
pa[76] := "VVVVUUU";
pa[77] := "VVV";
pa[78] := "FW";     
pa[79] := "FOOCW";
pa[80] := "FW";
pa[81] := "FOWWL";
pa[82] := "FOVLVU";
pa[83] := "FLVUUUT";
pa[84] := "FLLWU";
pa[85] := "UU";
pa[86] := "FU";          
pa[87] := "UUUUUUUU";
pa[88] := "FWV";
pa[89] := "FWLV";
pa[90] := "FWOW";
pa[91] := "FWOVW";
pa[92] := "FW";
pa[93] := "FW";
pa[94] := "FW";
pa[95] := "FW";        
pa[96] := "FWOOO";    
pa[97] := "WO";
pa[98] := "FOOOOOLLL";            
pa[99] := "OOOOOUUU";     
pa[100] := "FWW";
pa[101] := "FWC";
pa[102] := "FV";
pa[103] := "W ";
pa[104] := "FW";
END InitPa;

PROCEDURE InitPr;
BEGIN
pr[01] := PROC(Execute);
pr[02] := PROC(Exit);
pr[03] := PROC(Kill);
pr[04] := PROC(Sleep);
pr[05] := PROC(GetPID);
pr[06] := PROC(GetUser);
pr[07] := PROC(SetUser);
pr[08] := PROC(GetCommand);
pr[09] := PROC(TestCC);
pr[10] := PROC(SetCCMode);
pr[11] := PROC(Result);
pr[12] := PROC(Read);
pr[13] := PROC(ReadString);
pr[14] := PROC(Write);
pr[15] := PROC(WriteString);
pr[16] := PROC(WriteLn);
pr[17] := PROC(Open);
pr[18] := PROC(Create);
pr[19] := PROC(Close);
pr[20] := PROC(Delete);
pr[21] := PROC(Rename);
pr[22] := PROC(GetMode);
pr[23] := PROC(SetMode);
pr[24] := PROC(Size);
pr[25] := PROC(FastSize);
pr[26] := PROC(ReadBlock);
pr[27] := PROC(WriteBlock);
pr[28] := PROC(Seek);
pr[29] := PROC(GetDevAttr);
pr[30] := PROC(FormatTrack);
pr[31] := PROC(Mount);
pr[32] := PROC(Dismount);
pr[33] := PROC(FreeSpace);
pr[34] := PROC(Translate);
pr[35] := PROC(CreateLogical);
pr[36] := PROC(DeleteLogical);
pr[37] := PROC(CreateGlobal);
pr[38] := PROC(DeleteGlobal);
pr[39] := PROC(TestMessage);
pr[40] := PROC(ExpandCode);
pr[41] := PROC(ExpandStack);
pr[42] := PROC(GetTime);
pr[43] := PROC(SetTime);
pr[44] := PROC(GetMessage);
pr[45] := PROC(SetTrapMode);
pr[46] := PROC(TestTrap);
pr[47] := PROC(ReBoot);
pr[48] := PROC(Resume);
pr[49] := PROC(UpTime);
pr[50] := PROC(SetDevParams);
pr[51] := PROC(GetDevParams);
pr[52] := PROC(GetJobInfo);
pr[53] := PROC(L2TTIO.Attach);
pr[54] := PROC(L2TTIO.Detach);
pr[55] := PROC(L2Message.Attach);
pr[56] := PROC(L2Message.Detach);
pr[57] := PROC(ViewHandle);
pr[58] := PROC(SetFileDate);
pr[59] := PROC(GetLogical);
pr[60] := PROC(GetSystemLogical);
pr[61] := PROC(AttachTree);
pr[62] := PROC(DetachTree);
pr[63] := PROC(SetName);
pr[64] := PROC(GetName);
pr[65] := PROC(WriteMessage);
pr[66] := PROC(Lock);
pr[67] := PROC(UnLock);
pr[68] := PROC(AttachLock);
pr[69] := PROC(DetachLock);
pr[70] := PROC(ShowLock);
pr[71] := PROC(ViewCache);
pr[72] := PROC(CacheStats);
pr[73] := PROC(Qquery);
pr[74] := PROC(ArpStats);
pr[75] := PROC(IPStats);
pr[76] := PROC(GlobalStats);
pr[77] := PROC(ICMPStats);
pr[78] := PROC(SetPriority);
pr[79] := PROC(StatsCache);
pr[80] := PROC(SetUDPPort);
pr[81] := PROC(Send);
pr[82] := PROC(Receive);
pr[83] := PROC(ProcessStats);
pr[84] := PROC(Ping);
pr[85] := PROC(HeapSz);
pr[86] := PROC(SetTimerGrain);
pr[87] := PROC(TCPStats);
pr[88] := PROC(TCPListen);
pr[89] := PROC(TCPOpen);
pr[90] := PROC(TCPWrite);
pr[91] := PROC(TCPRead);
pr[92] := PROC(TCPClose);
pr[93] := PROC(TCPAbort);
pr[94] := PROC(TCPAttach);
pr[95] := PROC(TCPDetach);
pr[96] := PROC(TCBInfo);
pr[97] := PROC(N2Errors.GetMessage);
pr[98] := PROC(NetConfig);
pr[99] := PROC(DNSInfo);
pr[100] := PROC(VTIn);
pr[101] := PROC(VTOut);
pr[102] := PROC(VTAllocate);
pr[103] := PROC(VTDeallocate);
pr[104] := PROC(HangUp);
END InitPr;

VAR 
  j:CARDINAL;

BEGIN
FOR j:=0 TO MaxCalls DO
  pa[j]:="            ";
END(*FOR*);
 InitPa;
 InitPr;
 Establish(47,Handler(Trap15),0);
END L2SysCalls.
