IMPLEMENTATION MODULE L2TTIO;   (* Direct access to a process terminal *)

FROM L2Errors IMPORT Status;
FROM L2Kernel IMPORT Process, CurrentProcess, ProcMax;
IMPORT L2Terminal;

VAR     LastResult : ARRAY Process OF Status;

PROCEDURE  Result() : Status;

BEGIN   RETURN LastResult[CurrentProcess];
END Result;

PROCEDURE  Read( VAR ch : CHAR; wait : BOOLEAN);

BEGIN   LastResult[CurrentProcess]
           := L2Terminal.Read(Terminals[CurrentProcess],ch,wait);
END Read;

PROCEDURE  ReadString( VAR s : ARRAY OF CHAR);

BEGIN   LastResult[CurrentProcess]
           := L2Terminal.ReadString(Terminals[CurrentProcess],s);
END ReadString;

PROCEDURE  Write( ch : CHAR );

BEGIN   LastResult[CurrentProcess]
           := L2Terminal.Write(Terminals[CurrentProcess],ch);
END Write;

PROCEDURE  WriteString( VAR s : ARRAY OF CHAR);

BEGIN   LastResult[CurrentProcess]
           := L2Terminal.WriteString(Terminals[CurrentProcess],s);
END WriteString;

PROCEDURE  WriteLn;

BEGIN   LastResult[CurrentProcess]
           := L2Terminal.WriteLn(Terminals[CurrentProcess]);
END WriteLn;

PROCEDURE  Attach;

BEGIN   LastResult[CurrentProcess]
           := L2Terminal.Attach(Terminals[CurrentProcess]);
END Attach;

PROCEDURE  Detach;

BEGIN   LastResult[CurrentProcess]
           := L2Terminal.Detach(Terminals[CurrentProcess]);
END Detach;
       
VAR     p : Process;

BEGIN   FOR p := 1 TO ProcMax DO LastResult[p] := Ok END;
END L2TTIO.
