IMPLEMENTATION MODULE N2Base;

FROM SYSTEM IMPORT ADDRESS;
FROM L2Strings IMPORT Copy; 
CONST
  Shift8  = 100H;
  Shift16 = 10000H;
  Shift24 = 1000000H; 
    
PROCEDURE HostNet2( c : CARDINAL; pos : CARDINAL; VAR s : ARRAY OF CHAR );
  BEGIN
    s[pos] := CHR( c DIV Shift8 );
    s[pos+1] := CHR( c MOD Shift8 );
  END HostNet2;

PROCEDURE NetHost2( VAR c : CARDINAL; pos : CARDINAL; VAR s : ARRAY OF CHAR );
  BEGIN
    c := ORD( s[pos] ) * Shift8 + ORD( s[pos+1] );
  END NetHost2;

PROCEDURE HostNet4( a : ADDRESS; pos : CARDINAL; VAR s : ARRAY OF CHAR );
  VAR
    c : CARDINAL;
  BEGIN
    c := CARDINAL( a DIV Shift16 );
    s[pos] := CHR( c DIV Shift8 );
    s[pos+1] := CHR( c MOD Shift8 );
    c := CARDINAL( a MOD Shift16 );
    s[pos+2] := CHR( c DIV Shift8 );
    s[pos+3] := CHR( c MOD Shift8 );
  END HostNet4;

PROCEDURE NetHost4( VAR a : ADDRESS; pos : CARDINAL; VAR s : ARRAY OF CHAR );
  BEGIN
    a := ADDRESS( s[pos] ) * Shift24 + ADDRESS( s[pos+1] ) * Shift16 +
         ADDRESS( s[pos+2] ) * Shift8 + ADDRESS( s[pos+3] );
  END NetHost4;

PROCEDURE ChkSum( VAR chksum : CARDINAL; pos, len : CARDINAL;
                  VAR data : ARRAY OF CHAR; doPseudo : BOOLEAN );
 VAR
   highByte, lowByte, sum : ADDRESS;
   lastPos : CARDINAL;
 BEGIN
   highByte := 0;
   lowByte := 0;                                              

  (* do pseudo header if requested. *)

   IF doPseudo THEN
     highByte := ADDRESS( data[IPsaddr] );
     lowByte := ADDRESS( data[IPsaddr + 1] );
     highByte := highByte + ADDRESS( data[IPsaddr + 2] );
     lowByte := lowByte + ADDRESS( data[IPsaddr + 3] );
     highByte := highByte + ADDRESS( data[IPdaddr] );
     lowByte := lowByte + ADDRESS( data[IPdaddr + 1] );
     highByte := highByte + ADDRESS( data[IPdaddr + 2] );
     lowByte := lowByte + ADDRESS( data[IPdaddr + 3] );
     lowByte := lowByte + ADDRESS( data[IPproto] );
     highByte := highByte + ADDRESS( len DIV Shift8 );
     lowByte := lowByte + ADDRESS( len MOD Shift8 );
   END; (* IF *)

  (* checksum calculation .. 16 bit one's compliment of the
                             16 bit one's compliment sum.    *)         

   lastPos := pos + len - 1;
   WHILE pos < lastPos DO
     highByte := highByte + ADDRESS( data[pos] );
     INC( pos );
     lowByte := lowByte + ADDRESS( data[pos] );
     INC( pos );
   END; (* WHILE *)
   IF ODD( len ) THEN
     highByte := highByte + ADDRESS( data[pos] );
   END; (* IF *)
   sum := highByte * Shift8 + lowByte;
   sum := sum MOD Shift16 + sum DIV Shift16; (* add in the accumulated carry *)
   sum := sum MOD Shift16 + sum DIV Shift16; (* ...one more time             *)
   chksum := CARDINAL( 0FFFFH - sum );       (* one's compliment of the sum  *)
 END ChkSum;

BEGIN
END N2Base.
