IMPLEMENTATION MODULE N2Config;

FROM SYSTEM    IMPORT ADDRESS;
FROM L2Strings IMPORT Copy; 
FROM N2Base    IMPORT HostIP,GateIP,NetMaskH,NetMaskL;
FROM N2Driver  IMPORT NodeNumber;
FROM L2Loader  IMPORT Privilege;
FROM L2Kernel  IMPORT CurrentProcess, SetNoSwitch;
FROM L2Errors  IMPORT Status;
VAR
  i : CARDINAL;
  OurDName,NameServ1,NameServ2:ARRAY[0..50] OF CHAR;
  ServIP1,ServIP2:ADDRESS;
    
(* This procedure will return the values for all our network variables.
   For example, it returns or Host IP number and our netmask *)

PROCEDURE DNSInfo(VAR HostIp, GateIp, OurDomainName,DNSServ1,
                     DNSServ2:ARRAY OF CHAR; VAR DNSServIP1,DNSServIP2,
                                            Netmask:ADDRESS);
BEGIN
  Copy(HostIP,HostIp);
  Copy(GateIP,GateIp);                              
  Copy(OurDName,OurDomainName);
  Copy(NameServ1,DNSServ1);
  Copy(NameServ2,DNSServ2);
  DNSServIP1:=ServIP1;
  DNSServIP2:=ServIP2;
  Netmask:=ADDRESS(NetMaskH)*10000H+ADDRESS(NetMaskL);
END DNSInfo;
              
(* This procedure allows us to configure any network parameters in the
   operating system without having to recompile the system *)

PROCEDURE NetConfig(HostIPNum,GateIPNum,OurDomainName,DNSServ1,
                    DNSServ2:ARRAY OF CHAR;DNSServIP1,DNSServIP2,
                                            Netmask:ADDRESS):Status; 
VAR
  rs:Status;
BEGIN                                   
  IF Privilege(CurrentProcess) THEN 
    SetNoSwitch(TRUE);
    Copy(HostIPNum,HostIP);
    Copy(GateIPNum,GateIP);
    Copy(OurDomainName,OurDName);
    Copy(DNSServ1,NameServ1);
    Copy(DNSServ2,NameServ2);
    ServIP1:=DNSServIP1;
    ServIP2:=DNSServIP2;           
    NetMaskH:=BITSET(Netmask DIV 10000H);
    NetMaskL:=BITSET(Netmask MOD 10000H);
    SetNoSwitch(FALSE);
    RETURN Ok;
  ELSE
    RETURN PrivViol;
  END(*IF*);                
END NetConfig;            


BEGIN
  HostIP[0]:=CHR(142);                     (*Host IP is 142.51.25.1*)
  HostIP[1]:=CHR(51);
  HostIP[2]:=CHR(25);
  HostIP[3]:=CHR(1);
  GateIP[0]:=CHR(142);                     (*Gateway IP is 142.51.25.254*)
  GateIP[1]:=CHR(51);
  GateIP[2]:=CHR(25);
  GateIP[3]:=CHR(254);
  FOR i:=0 TO 15 DO INCL(NetMaskH,i);END;      (*The NetMask is 24 ones*)
  FOR i:=8 TO 15 DO INCL(NetMaskL,i);END;      (*followed by 8 zeros*)
  FOR i:=0 TO 7 DO EXCL(NetMaskL,i);END;
END N2Config.
