IMPLEMENTATION MODULE N2Errors;

FROM L2Strings IMPORT Copy;

PROCEDURE GetMessage( r : Status; VAR s : ARRAY OF CHAR );
  BEGIN
    CASE r OF
      Ok            : Copy("Normal Completion",s);                        |
      BoundsError   : Copy("Length exceeds array boundaries",s);          |
      BuffOverFlow  : Copy("Length exceeds buffer capacity",s);           |
      ZeroLen       : Copy("Expected non zero length",s);                 |
      SysErr        : Copy("Lumos-2 system error",s);                     |
      NoPort        : Copy("Port not open",s);                            |
      TimedOut      : Copy("Timed out",s);                                |
      PortInUse     : Copy("Port number is being used",s)                 |
      PrivViol      : Copy("Privilege violation",s)                       |
      NoHeap        : Copy("Heap has been exausted",s)                    |
      RTableFull    : Copy("Register table is full",s)                    |
      NotRegistered : Copy("Protocol hasn't been registered with IP",s)   |
      DevError      : Copy("Device error",s);                             |
      BadSeq        : Copy("Ping sequence number out of order",s);        |
      LReset        : Copy("Local host iniiated reset",s);                |
      FReset        : Copy("Foreign host initiated reset",s);             |
      FRefusal      : Copy("Foreign host refused connection",s);          |
      IllegalOp     : Copy("Illegal operation",s);                        |
      ConInUse      : Copy("Connection is in use",s);                     |
      NoSocs        : Copy("No sockets currently available",s);           |
      NoTCB         : Copy("No TCB on this soc handle",s);                |
      BadState      : Copy("TCB state does not allow requested operation",s); |
      BadSoc        : Copy("Invalid soc handle",s);                       |
      RcvDone       : Copy("Receive done (EOT)",s);
      ELSE            Copy("Unknown error",s);
    END;
  END GetMessage;

BEGIN
END N2Errors.
