IMPLEMENTATION MODULE N2TCPMain;

FROM L2Kernel   IMPORT SemInit, Guard, UnGuard;
FROM N2Errors   IMPORT Status;
FROM SYSTEM     IMPORT ADDRESS;

TYPE
  TcPtr = POINTER TO ARRAY [0..123] OF CHAR;

PROCEDURE TCBInfo( soc:SocHandle; VAR s, bs, br :ARRAY OF CHAR):Status;
VAR
  tt : TcPtr;
  i,j : CARDINAL;
BEGIN               
  IF (soc=0) OR (soc>MaxSocs) THEN
    RETURN NoSocs;
  END(*IF*);              
  Guard(socList[soc].tcbGuard);                      
  IF socList[soc].tcb=NIL THEN
    UnGuard(socList[soc].tcbGuard);
    RETURN NoTCB;
  ELSE        
    tt := TcPtr(socList[soc].tcb);                      (* kludge *)
    i := 0;
    WHILE (i < 124) AND (i<HIGH(s)+1) DO s[i] := tt^[i]; INC(i); END;

   (* partial buffer dumps for debugging *)

    WITH socList[soc].tcb^ DO
      IF rcvBuffer <> NIL THEN
        i := ( rcvBuffPos + 2048 -50 ) MOD 2048;
        FOR j := 0 TO 49 DO
          br[j] := rcvBuffer^[i];
          INC(i);
          i := i MOD 2048;
        END;
      END;
      IF sendBuffer <> NIL THEN
        i := ( sendBuffPos + 2048 -50 ) MOD 2048;
        FOR j := 0 TO 49 DO
          bs[j] := sendBuffer^[i];
          INC(i);
          i := i MOD 2048;
        END;
      END;
    END(*WITH*);                          

    UnGuard(socList[soc].tcbGuard);
    RETURN Ok;
  END(*IF*);                 
END TCBInfo;

PROCEDURE TCPStats(VAR Insegs,PassOpen,Outs,EstResets,CurrEst,AttFails,
                    RetranSegs,OutSegs:ADDRESS);
BEGIN
  Insegs:=TCPInSegs;
  PassOpen:=TCPPassOpen;
  Outs:=TCPOuts;
  EstResets:=TCPEstabResets;
  CurrEst:=TCPCurrEstab;
  AttFails:=TCPAttemptFails;
  RetranSegs:=TCPRetransSegs;
  OutSegs:=TCPOutSegs;
END TCPStats;

VAR
  j  : CARDINAL;  

BEGIN
  activeSocs.head := NIL;     
  SemInit( activeSocs.guard , 1);
  FOR j:=1 TO MaxSocs DO
    SemInit( socList[j].tcbGuard , 1);
    SemInit( socList[j].ioGuard , 0);               
    socList[j].tcb := NIL;
    socList[j].flagged := FALSE;
  END(*FOR*);
  TCPInSegs := 0;
  TCPPassOpen := 0;
  TCPOuts := 0;
  TCPEstabResets := 0;
  TCPCurrEstab := 0;
  TCPAttemptFails := 0;
  TCPRetransSegs := 0;
  TCPOutSegs := 0;
END N2TCPMain.
