MODULE Extract;

(* This program extracts M2 modules from mail messages and constructs
   proper file names based on the module contents.  The message file
   is deleted.   

   Usage:   Extract <files>

   where <files>  (possibly a wildcard pattern) identifies one or more
   messages extracted from mail.
 
   The parsing is primitive.  Use with care.
*)

FROM R2SysCalls IMPORT WriteString, WriteLn, GetCommand, Exit, Status, Delete;
FROM R2Streams IMPORT Stream, Done, OpenStream, CreateStream, CloseStream,
                      EndStream, WriteLine, ReadLine, SysErr;
FROM R2Strings IMPORT Copy, Find, Insert, Compress, Remove, Length;
FROM R2Directories IMPORT SetWild, NextWild, FullName;

VAR     pat, fn, lin, tx : ARRAY [0..133] OF CHAR;
        is, os : Stream;
        k : CARDINAL;
        oo : BOOLEAN;
        x : Status;

BEGIN   GetCommand(pat);
        x := SetWild(pat);
        IF x <> Ok THEN Exit(x) END;
        WHILE NextWild() = Ok DO
          WriteString(FullName);
          OpenStream(is,FullName,FALSE);
          IF NOT Done THEN Exit(SysErr) END;
          oo := FALSE;
          WHILE NOT EndStream(is) DO
            ReadLine(is,lin);
            IF oo THEN
              WriteLine(os,lin);
            ELSIF Find("MODULE",lin) < Length(lin) THEN
              Copy(lin,tx);
              IF Find("DEFIN",lin) = 0 
                THEN Copy(".DEF",fn) 
                ELSE Copy(".MOD",fn)
                END;
              k := Find("MODULE ",lin);
              Remove(lin,0,k+6);
              k := 0;
              WHILE (k <= HIGH(lin)) AND (lin[k] <> ';') DO INC(k) END;
              IF k <= HIGH(lin) THEN lin[k] := 0C END;
              Compress(lin);
              Insert(lin,fn,0);
              WriteString(" -> ");
              WriteString(fn);
              CreateStream(os,fn);
              IF NOT Done THEN Exit(SysErr) END;
              oo := TRUE;
              WriteLine(os,tx);
              END;
            END;
          WriteLn;
          CloseStream(is);
          IF oo THEN 
            CloseStream(os);
            x := Delete(FullName);
            END;
          END;
END Extract.
