MODULE Frag;  

(* Measure various disk fragmentation numbers *)

FROM R2SysCalls IMPORT Status, Open, Handle, WriteLn, WriteString, ReadString,
                       Close, GetDevAttr, DevAttrSet, Exit, ReadBlock;
FROM R2NumbIO IMPORT WriteCard;             
FROM R2Strings IMPORT Concatenate;
FROM RealIO IMPORT WriteReal;

VAR     h : Handle;
        k, ds, nf, ms, ns, cs : CARDINAL;
        rs : Status;
        dv, af : ARRAY [0..79] OF CHAR;
        da : DevAttrSet;
        bk : RECORD CASE BOOLEAN OF
                 TRUE : f : ARRAY [0..255] OF CARDINAL;
              | FALSE : a : ARRAY [0..511] OF CHAR;
                END;
               END;

BEGIN   WriteString("Device: ");
        ReadString(dv);
        rs := GetDevAttr(dv,ds,da);
        IF rs <> Ok THEN Exit(rs) END;
        Concatenate(dv,"-ALLOCATION.SYS",af);
        rs := Open(af,FALSE,h);
        IF rs <> Ok THEN Exit(rs) END;
        nf := 0; ms := 0; ns := 0; cs := 0;
        FOR k := 0 TO ds-1 DO
          IF (k MOD 256) = 0 THEN 
            rs := ReadBlock(h,bk.a);
            IF rs <> Ok THEN Exit(rs) END;
            END;
          IF bk.f[k MOD 256] = 0
            THEN INC(nf);
                 IF cs = 0 THEN INC(ns) END;
                 INC(cs);
            ELSE IF cs > ms THEN ms := cs END;
                 cs := 0;
            END;
          END;
        IF cs > ms THEN ms := cs END;
        rs := Close(h,TRUE);
        WriteString("Free blocks: "); WriteCard(nf,1); WriteLn;
        WriteString("Runs       : "); WriteCard(ns,1); WriteLn;
        WriteString("Average len: "); WriteReal(FLOAT(nf)/FLOAT(ns)); WriteLn;
        WriteString("Maximum len: "); WriteCard(ms,1); WriteLn;
END Frag.
