MODULE Help;

FROM R2Strings IMPORT Concatenate, Copy, Remove, Find, Length, 
                      Insert, Compress;
FROM R2SysCalls IMPORT Status, Open, Close, ReadBlock, Handle, ReadString,
                       GetCommand, WriteString, WriteLn, Write, Exit, Result;
FROM CommComp IMPORT Component;
FROM R2Streams IMPORT Stream, OpenStream, EndStream, CloseStream, ReadLine,
                      Done, SetPos;
FROM SYSTEM IMPORT ADDRESS;

CONST   maxrecs = 320;    (* should agree with Compile *)

TYPE    toptyp = ARRAY [0..11] OF CHAR;
        block = ARRAY [0..511] OF CHAR;
        indrec = RECORD nam : toptyp;
                        pos : ADDRESS;
                 END;

VAR     com : ARRAY [0..79] OF CHAR;
        blank : ARRAY [0..1] OF CHAR;

PROCEDURE  RecHelp( prefix, toplist, file : ARRAY OF CHAR);

VAR     k : CARDINAL;
        hfn, ifn, top : ARRAY [0..79] OF CHAR;
        hs : Stream;
        ih : Handle;
        x : Status;
        index : RECORD
                  CASE BOOLEAN OF
                       TRUE : blocks : ARRAY [0..(maxrecs DIV 32)-1] OF block;
                    | FALSE : recs : ARRAY [0..maxrecs-1] OF indrec;
                    END;
                  END;

    PROCEDURE  UpCase( VAR s : ARRAY OF CHAR);

    VAR     i : CARDINAL;

    BEGIN   FOR i := 0 TO HIGH(s) DO s[i] := CAP(s[i]) END;
    END UpCase;

    PROCEDURE  Display( topic : ARRAY OF CHAR);

    VAR     j, f : CARDINAL;
            p, q, r, s, t : ARRAY [0..79] OF CHAR;

    BEGIN   j := 0; f := 0;
            Copy(topic,p);
            UpCase(p);
            WITH index DO
              LOOP IF recs[j].nam[0] = 0C THEN EXIT END;
                   Copy(recs[j].nam,s);
                   UpCase(s);
                   IF Find(p,s) = 0 THEN
                     INC(f);
                     WriteLn;
                     SetPos(hs,recs[j].pos);
                     WriteString(prefix);
                     WriteString(recs[j].nam);
                     WriteLn; WriteLn;
                     LOOP IF EndStream(hs) THEN EXIT END;
                          ReadLine(hs,s);
                          IF s[0] = '@' THEN
                            Remove(s,0,1);
                            Copy(recs[j].nam,q);
                            Compress(q);
                            Concatenate(prefix,q,t);
                            Concatenate(t,blank,q);
                            Copy(toplist,r);
                            RecHelp(q,r,s);
                            EXIT;
                            END;
                          IF s[0] = '*' THEN EXIT END;
                          WriteString("   ");
                          WriteString(s);
                          WriteLn;
                          END;
                     END;
                   INC(j);
                   END;
              END;
            IF f = 0 THEN 
              WriteString("Sorry, no help available for: ");
              WriteString(prefix);
              WriteString(topic);
              WriteLn;
              END;
    END Display;

    PROCEDURE  HelpIndex;
    
    VAR     k : CARDINAL;
    
    BEGIN   WriteLn;       
            IF prefix[0] = 0C
              THEN WriteString("Help")
              ELSE WriteString("Additional help");
              END;
            WriteString(" is available for:");
            WriteLn; WriteLn;
            k := 0;
            LOOP IF index.recs[k].nam[0] = 0C THEN EXIT END;
                 WriteString(index.recs[k].nam);
                 IF (k MOD 5) = 4 THEN WriteLn ELSE WriteString("  ") END;
                 INC(k);
                 END;
            IF (k MOD 5) <> 0 THEN WriteLn END;
    END HelpIndex;

BEGIN   Concatenate("$Help-",file,top);
        Concatenate(top,".HLP",hfn);
        Concatenate(top,".IND",ifn);
        Component(com,top);
        OpenStream(hs,hfn,FALSE);
        IF NOT Done THEN RETURN END;
        IF Open(ifn,FALSE,ih) <> Ok THEN RETURN END;
        FOR k := 0 TO maxrecs-1 DO index.recs[k].nam[0] := 0C END;
        k := 0;
        LOOP IF ReadBlock(ih,index.blocks[k]) <> Ok THEN EXIT END;
             INC(k);
             END;
        x := Close(ih,TRUE);
        IF top[0] = 0C
          THEN HelpIndex;
               LOOP WriteLn;
                    IF prefix[0] = 0C 
                      THEN WriteString("Topic ? ")
                      ELSE WriteString(prefix);
                           WriteString("topic ? ");
                      END;
                    ReadString(top);
                    IF Result() <> Ok THEN Exit(Ok) END;
                    IF top[0] = 0C THEN EXIT END;
                    IF (top[0] = '*') OR (top[0] = '?') 
                      THEN HelpIndex;
                      ELSE Display(top);
                      END;
                    END;
          ELSE Display(top);
          END;
        CloseStream(hs);
END RecHelp;

BEGIN   blank[0] := ' '; blank[1] :=0C;
        GetCommand(com);
        RecHelp("",com,"Help");
END Help.
