MODULE Info;

FROM R2SysCalls IMPORT ReadString, WriteString, WriteLn, Status, GetMessage,
                       GetUser, GetCommand, Result;
FROM R2NumbIO IMPORT WriteCard;
FROM R2NewCalls IMPORT GetLogical, GetGlobal, ViewHandle, GetJobInfo, GetName,
                       ShowLock;
FROM R2Strings IMPORT Length, Insert, Remove, Concatenate, Substring;
 
PROCEDURE  InfoLog( glob : BOOLEAN);

VAR     dol : ARRAY [0..1] OF CHAR;
        log, tran : ARRAY [0..79] OF CHAR;
        n : CARDINAL;
        rs : Status;

BEGIN   dol[0] := '$'; dol[1] := 0C;
        WriteLn;
        n := 1;      
        LOOP IF glob 
               THEN rs := GetGlobal(n,log,tran);
               ELSE rs := GetLogical(n,log,tran);
               END;
             IF rs <> Ok THEN EXIT END;
             Insert(dol,log,0);
             Insert("             ",log,Length(log));
             Remove(log,9,20);
             Insert(" = ",tran,0);
             Insert(log,tran,0);
             WriteString(tran); WriteLn;
             INC(n);
             END;
        WriteLn;
END InfoLog;

PROCEDURE  InfoFiles;

VAR     rs : Status;
        fn : ARRAY [0..79] OF CHAR;
        n, p : CARDINAL;

BEGIN   WriteLn;
        WriteString("Handle  Process  File name"); 
        WriteLn; WriteLn;
        n := 0;
        LOOP 
          rs := ViewHandle(n,p,fn);
          IF rs = NoSuch THEN EXIT END;
          IF rs = Ok THEN
            WriteCard(n,6);
            WriteCard(p,9);
            WriteString('  ');
            WriteString(fn);
            WriteLn;
            END;
          INC(n);
          END;
        WriteLn;
END InfoFiles;

PROCEDURE  InfoLocks;

VAR     i, p, u : CARDINAL;
        res : ARRAY [0..79] OF CHAR;

BEGIN   WriteLn;
        WriteString("Lock  Process  User  Resource");
        WriteLn; WriteLn;
        i := 0;
        LOOP  IF ShowLock(i,res,u,p) <> Ok THEN EXIT END;
              WriteCard(i,4);
              WriteCard(p,9);
              WriteCard(u,6);
              WriteString("  ");
              WriteString(res);
              WriteLn;  
              INC(i);
              END;
        WriteLn;
END InfoLocks;

PROCEDURE  InfoJobs;

VAR     n, p, t, f, u : CARDINAL;
        fn, un, tm : ARRAY [0..79] OF CHAR;
        rs : Status;

BEGIN   WriteLn;
        WriteString("Job  Pages  Term  Parent  User  Username  Program");
        WriteLn; WriteLn;
        FOR n := 3 TO 40 DO
          rs := GetJobInfo(n,p,t,f,fn);
          u := 0;
          un[0] := 0C;
          IF rs = Ok THEN
               WriteCard(n,3);
               WriteCard(p,7);
               WriteCard(t,6);
               WriteCard(f,8);
               rs := GetUser(n,u);
               IF rs = Ok THEN WriteCard(u,6); END;
               rs := GetName(n,un);        
               IF rs = Ok THEN 
                 WriteString('  ');
                 Concatenate(un,"        ",tm);
                 Substring(tm,un,0,8);
                 WriteString(un);
                 WriteString('  ');
                 WriteString(fn);
                 END;
               WriteLn;
               END;
          END;
        WriteLn;
END InfoJobs;

VAR     com : ARRAY [0..19] OF CHAR;
        loop : BOOLEAN;

BEGIN   GetCommand(com);
        loop := com[0] = 0C;
        LOOP IF loop THEN
               WriteString("Info> ");
               ReadString(com);
               IF Result() = EndFile THEN com[0] := 'X' END;
               END;
             CASE CAP(com[0]) OF
                 ' ', 0C  : WriteString("Info types: ");
                            WriteString("Jobs, Logicals, Globals, Files,");
                            WriteString(" Resource locks, All");
                            WriteLn;
               | 'J'      : InfoJobs;
               | 'L'      : InfoLog(FALSE);
               | 'G'      : InfoLog(TRUE);
               | 'F'      : InfoFiles;
               | 'R'      : InfoLocks;
               | 'A'      : InfoJobs; InfoLog(FALSE); 
                            InfoLog(TRUE); InfoFiles; InfoLocks;
               | 'X'      : EXIT;
                 ELSE WriteString('Info -- Unknown type'); WriteLn;
                 END;
             IF NOT loop THEN EXIT END;
             END;
END Info.
