MODULE Locate;  (* scans maps and listings to locate address in source *)

(*  Usage:  * LOCATE  image  address

    Locate will search map files and listings to find the source line
    that corresponds to address.

    Author:  G. Guenther, 1990 09 25  after original work by A. Atrens.
*)

FROM R2SysCalls IMPORT GetCommand, WriteString, WriteLn, Status, Exit;
FROM R2Streams IMPORT Stream, OpenStream, ReleaseStream, EndStream, Done,
                      ReadLine;
FROM CommComp IMPORT Component;
FROM R2Format IMPORT ScanCard, ScanAddr;
FROM R2NumbIO IMPORT WriteCard, WriteAddr;
FROM R2Strings IMPORT Compare, Length, Concatenate, Remove;
FROM SYSTEM IMPORT ADDRESS;

TYPE    string = ARRAY [0..133] OF CHAR;

VAR     fil : Stream;
        r, s, t, Line, ModName, Module : string;
        n, k, LineNum, ProcNum : CARDINAL;
        m, Start, Offset, Crash : ADDRESS;
        b : BOOLEAN;

BEGIN   Start := 0;  Offset := 0;
        GetCommand(r);
        Component(r,s);
        Concatenate(s,".MAP",t);
        OpenStream(fil,t,FALSE);
        IF NOT Done THEN 
          WriteString("Locate -- Cannot open ");
          WriteString(t);
          WriteLn;
          Exit(Status(-1));
          END;
        Component(r,s);
        b := ScanAddr(s,16,Crash);
        WHILE NOT EndStream(fil) DO
          ReadLine(fil,r);
          Component(r,s);
          IF Compare(s,"from") = 0 THEN
            Component(r,s);
            Component(r,t);
          ELSIF Compare(s,"Proc") = 0 THEN
            REPEAT Component(r,s);
                   Component(r,s);
                   n := Length(s);
                   IF n > 0 THEN Remove(s,n-1,1) END;
                   b := ScanCard(s,10,n);
                   Component(r,s);
                   b := ScanAddr(s,16,m);
                   IF (m >= Offset) AND (m <= Crash) THEN
                     Offset := m;
                     ModName := t;
                     ProcNum := n;
                     END;
                   Component(r,s);
            UNTIL s[0] = 0C;
            END;
          END;
        ReleaseStream(fil);
        n := Length(ModName);
        Remove(ModName,n-4,4);
        Module := ModName;
        Concatenate(Module,".LIS",ModName);
        OpenStream(fil,ModName,FALSE);
        WriteString("Module: ");
        WriteString(Module);
        WriteString("  Procedure: ");
        WriteCard(ProcNum,1);
        IF NOT Done THEN
          WriteLn;
          WriteString("Locate -- Cannot open ");
          WriteString(ModName);
          WriteLn;
          Exit(Status(-1));
          END;
        WHILE NOT EndStream(fil) DO
          ReadLine(fil,r);
          Component(r,s);
          b := ScanCard(s,10,n);
          Component(r,s);
          b := ScanCard(s,10,k);
          Component(r,s);
          b := ScanAddr(s,16,m);
          IF ( m >= Start) AND (k = ProcNum) AND (m + Offset <= Crash) THEN
            Start := m;
            LineNum := n;
            Line := r;
            END;
          END;
        ReleaseStream(fil);
        WriteString("  Line: "); 
        WriteCard(LineNum,1);
        WriteLn;
        WriteString(Line);
        WriteLn;
END Locate.
