MODULE Printer; (* The printer symbiont of the print spool system *)

FROM R2SysCalls IMPORT WriteString, WriteLn, Open, ReadBlock, WriteBlock,
                       Handle, Exit, Status, GetMode, GetPID, Translate, 
                       ModeBits, Time,
                       TestMessage, GetMessage, Sleep, Close, FileMode;
FROM R2Format IMPORT ScanCard;                                           
FROM R2Strings IMPORT Substring, Remove, Insert;
FROM R2Streams IMPORT Done, OpenStream, CreateStream, CloseStream, Stream,
                      ReadLine, WriteLine, WriteChar, EndStream, SysErr;

VAR     in, out, pf : Handle;
        m : FileMode;
        tim : Time;
        fs, ps : Stream;
        str, num : ARRAY [0..79] OF CHAR;
        pid, qmg, usr, i : CARDINAL;
        rs : Status;

PROCEDURE  Check( rs : Status);

BEGIN   IF rs <> Ok THEN 
          GetMessage(rs,str);
          WriteString("** Printer -- ");
          WriteString(str);
          WriteLn;
          Exit(Status(-1));
          END;
END Check;

BEGIN   Check(Open("#M0",FALSE,in));
        Check(Open("$QUEUE",TRUE,out));
        Check(GetPID(pid));            
        Check(Translate("$QUEUE",str));
        Substring(str,num,2,10);
        IF NOT ScanCard(num,10,qmg) THEN Check(BadLogical) END;
        LOOP i := TestMessage(TRUE);
             rs := ReadBlock(in,str);   (* Will get EOF if Queue dies *)
             IF i = qmg THEN            (* we ignore unsolicited messages *)
               Check(rs);               (* Cause exit if error from Queue *)
               i := 0;
               WHILE (i <= HIGH(str)) AND (str[i] <> ' ') AND (str[i] <> 0C) 
                 DO INC(i) END;
               Substring(str,num,0,i);
               Remove(str,0,i+1);
               IF NOT ScanCard(num,10,usr) THEN Check(BadFunction) END;
               i := 0;
               REPEAT CreateStream(ps,"#T4");
                      INC(i);
                      IF (NOT Done) AND (i = 10) THEN
                        WriteString("** Printer -- Device not available");
                        WriteLn;
                        Exit(Status(-1));
                        END;
                      IF NOT Done THEN Check(Sleep(1000)) END;
               UNTIL Done;              
               rs := Open(str,FALSE,pf);
               IF rs = Ok THEN
                 rs := GetMode(pf,tim,m,i);
                 IF (rs = Ok) AND NOT (((i = usr) AND (ORd IN m)) OR
                    (WRd IN m) OR (usr = 0)) THEN
                   rs := Close(pf,FALSE);
                   rs := NoAccess;
                   END;
                 END;
               IF rs = Ok THEN
                 OpenStream(fs,str,FALSE); 
                 IF NOT Done 
                   THEN rs := Close(pf,FALSE);
                        rs := SysErr
                   ELSE WHILE NOT EndStream(fs) DO
                          ReadLine(fs,str);
                          WriteLine(ps,str);
                          END;
                        CloseStream(fs);
                        rs := Close(pf,FALSE);
                        rs := Ok;
                   END;
                 END; 
               IF rs <> Ok THEN
                 Insert("Printer cannot access: ",str,0);
                 GetMessage(rs,num);
                 Insert(",  ",num,0);
                 Insert(str,num,0);
                 WriteLine(ps,num);
                 END;
               WriteChar(ps,14C);     (* Form feed *)
               CloseStream(ps);
               Check(WriteBlock(out,str,FALSE));    
               END;
             END; (* loop forever *)
END Printer.
