MODULE SetTerminal;

FROM R2SysCalls IMPORT Status, Exit, GetCommand, GetMessage, Translate,
   ReadString, WriteString, WriteLn;
FROM R2Format IMPORT ScanCard, FormatCard;
FROM R2NewCalls IMPORT GetDevParams, SetDevParams;

PROCEDURE NextWord( VAR s, w : ARRAY OF CHAR );
VAR
   i, j : CARDINAL;
BEGIN
   i := 0;
   WHILE (i<=HIGH(s)) AND (s[i]=' ') DO INC(i) END;
   j := 0;
   WHILE (i<=HIGH(s)) AND (j<=HIGH(w)) AND (s[i]>' ') DO
      w[j] := s[i];
      INC(i); INC(j);
      END;
   IF (j<=HIGH(w)) THEN w[j] := 0C END;
   j := 0;
   WHILE (i<=HIGH(s)) AND (s[i]<>0C) DO
      s[j] := s[i];
      INC(i); INC(j);
      END;
   IF (j<=HIGH(s)) THEN s[j] := 0C END;
END NextWord;

VAR
   term, speed : ARRAY [0..5] OF CHAR;
   inp : ARRAY [0..79] OF CHAR;
   rs : Status;
   b,code : CARDINAL;
   GotBaud, GotTerm : BOOLEAN;
BEGIN
   GetCommand(inp);
   NextWord(inp,speed);
   NextWord(inp,term);

   (* work out the terminal which is getting set*)
   IF ((term[0]='#') OR (term[0]='$')) AND (Translate(term,inp)=Ok) THEN
      NextWord( inp,term ); (* works like a copy *)
   ELSE
      rs := Translate("$TI",term);
      END;

   rs := GetDevParams(term,1,code);
   rs := SetDevParams(term,1,code);
   IF rs<>Ok THEN Exit(rs) END;
   LOOP
      IF NOT ScanCard(speed, 10, b) THEN
         code := 0;
      ELSE
         IF (b MOD 100) = 0 THEN b := b DIV 100 END;
         IF    (b=3)   THEN code := 44H
         ELSIF (b=6)   THEN code := 55H
         ELSIF (b=12)  THEN code := 66H
         ELSIF (b=18)  THEN code := 0AAH
         ELSIF (b=20)  THEN code := 77H
         ELSIF (b=24)  THEN code := 88H
         ELSIF (b=48)  THEN code := 99H
         ELSIF (b=96)  THEN code := 0BBH
         ELSIF (b=192) THEN code := 0CCH
         ELSE
            code := 0;
            END;
         END;
      IF code>0 THEN rs := SetDevParams(term,1,code) END;
      IF (code>0) AND (rs=Ok) THEN EXIT END;
      WriteString(speed); WriteLn;
      WriteString("valid baud rates are: 300, 600, 1200, 1800, 2400,");
      WriteString(" 4800, 9600, 19200"); WriteLn;
      WriteString("Select a baud rate: ");
      ReadString(speed);
      END; (* LOOP *)
END SetTerminal.
