MODULE ZapDir;

FROM R2SysCalls IMPORT WriteString, WriteLn, Status, Open, WriteBlock,
                       Time, Exit, ReadString, Translate, Dismount,
                       Handle, ReadBlock, Close, Seek, Mount,
                       ModeBits, FileMode, GetMode;
FROM R2NumbIO IMPORT WriteCard, ReadCard;

TYPE    LineType = ARRAY [0..77] OF CHAR;
        DirRec = RECORD Name : ARRAY [0..19] OF CHAR;
                        First : CARDINAL;
                        Date : Time;
                        Owner, Mode : CARDINAL;
                 END;
        Home = RECORD Key : ARRAY [0..3] OF CHAR;
                      Label : ARRAY [0..19] OF CHAR;
                      Date : Time;
                      Size, Owner, Mode : CARDINAL;
               END;
        Four = [0..3];
        Block = RECORD CASE Four OF
                 0 : a : ARRAY [0..511] OF CHAR      | 
                 1 : d : ARRAY [0..15] OF DirRec     |
                 2 : f : ARRAY [0..255] OF CARDINAL  |
                 3 : h : Home;
                 END;
                END;               

VAR     Dev, yorn : ARRAY [0..9] OF CHAR;
        dh : Handle; 
        b, i : CARDINAL;
        db : Block;

PROCEDURE  Check( rs : Status);

BEGIN   IF rs <> Ok THEN Exit(rs) END;
END Check;

BEGIN   WriteString('Device: ');
        ReadString(Dev);
        Check(Dismount(Dev));
        Check(Open(Dev,TRUE,dh));
        LOOP WriteString('Block: ');
             ReadCard(b);
             Check(Seek(dh,b));
             Check(ReadBlock(dh,db.a));
             WriteString('Rec: ');
             ReadCard(i);
             WITH db.d[i] DO
               WriteString(Name);
               WriteLn;
               WriteString('Ok to erase entry ? ');
               ReadString(yorn);
               IF CAP(yorn[0]) = 'Y' THEN
                 Name := "";
                 Check(Seek(dh,b));
                 Check(WriteBlock(dh,db.a,FALSE));
                 END;
               END;
             WriteString('More ? ');
             ReadString(yorn);
             IF CAP(yorn[0]) <> 'Y' THEN EXIT END;
             END;
        Check(Close(dh,TRUE));
        Check(Mount(Dev,'junk',FALSE));
END ZapDir.
